// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.


// show output results
package JRunMC.ui;

import JRunMC.util.*;

import java.io.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;


public class ResultDialog {

   private HtmlBrowserDialog viewer;


   private String monte_carlo_model="";
   private String output="";
   private String events_requested="";
   private String events_generated="";
   private String total_cross_section="";
   private String luminosity="";
   private String output_hepevt_record="";
   private String output_root_record="";
   private String averageCPU=""; 
   private String averageREAL="";
   private String run_started="";
   private String run_finished="";

   public ResultDialog( File f1) {

      String tmp;

      try {
      FileReader inFC = new FileReader(f1);
      BufferedReader inp = new BufferedReader(inFC);
      String line; 
       while ((line = inp.readLine()) != null) {     
        if (line.length()>1) {

        line=line.trim();  // System.out.println(s);

// get MC model
        tmp="monte-carlo-model="; 
        if (line.indexOf(tmp) > -1)  {
           line=StringUtil.replace(line,tmp, ""); 
           line=StringUtil.replace(line,"\n", "");
           monte_carlo_model=line.trim();
           } 

// get MC model
        tmp="output=";
        if (line.indexOf(tmp) > -1)  {
           line=StringUtil.replace(line,tmp, "");
           line=StringUtil.replace(line,"\n", "");
           output=line.trim();
           }

        tmp="events-requested=";
        if (line.indexOf(tmp) > -1)  {
           line=StringUtil.replace(line,tmp, "");
           line=StringUtil.replace(line,"\n", "");
           events_requested=line.trim();
           }
        tmp="events-generated=";
        if (line.indexOf(tmp) > -1)  {
           line=StringUtil.replace(line,tmp, "");
           line=StringUtil.replace(line,"\n", "");
           events_generated=line.trim();
           }

        tmp="total-cross-section=";
        if (line.indexOf(tmp) > -1)  {
           line=StringUtil.replace(line,tmp, "");
           line=StringUtil.replace(line,"\n", "");
           total_cross_section=line.trim();
           }

        tmp="luminosity=";
        if (line.indexOf(tmp) > -1)  {
           line=StringUtil.replace(line,tmp, "");
           line=StringUtil.replace(line,"\n", "");
           luminosity=line.trim();
           }

       tmp="output-hepevt-record=";
        if (line.indexOf(tmp) > -1)  {
           line=StringUtil.replace(line,tmp, "");
           line=StringUtil.replace(line,"\n", "");
           output_hepevt_record=line.trim();
           }

       tmp="output-root-record=";
        if (line.indexOf(tmp) > -1)  {
           line=StringUtil.replace(line,tmp, "");
           line=StringUtil.replace(line,"\n", "");
           output_root_record=line.trim();
           }

      tmp="average-CPU-time-for-1-event=";
        if (line.indexOf(tmp) > -1)  {
           line=StringUtil.replace(line,tmp, "");
           line=StringUtil.replace(line,"\n", "");
           averageCPU=line.trim();
           }

      tmp="average-REAL-time-for-1-event=";
        if (line.indexOf(tmp) > -1)  {
           line=StringUtil.replace(line,tmp, "");
           line=StringUtil.replace(line,"\n", "");
           averageREAL=line.trim();
           }

      tmp="run-started=";
        if (line.indexOf(tmp) > -1)  {
           line=StringUtil.replace(line,tmp, "");
           line=StringUtil.replace(line,"\n", "");
           run_started=line.trim();
           }

      tmp="run-finished=";
        if (line.indexOf(tmp) > -1)  {
           line=StringUtil.replace(line,tmp, "");
           line=StringUtil.replace(line,"\n", "");
           run_finished=line.trim();
           }



        }
       }

      } catch (IOException e){
        System.out.println( "Error in reading .runmc.out" );
       }



   viewer = new HtmlBrowserDialog( Global.mainFrame, "Results", true );

   String mess="<html><H2>"+monte_carlo_model+"</H2>"; 
   mess=mess+"<b>Output: <font color=\"green\">"+output+"</font><br>";  
   mess=mess+"No of requested events: <font color=\"green\">"+events_requested+"</font><br>"; 
   mess=mess+"No of generated events: <font color=\"green\">"+events_generated+"</font><br>";
   mess=mess+"Total cross-section: <font color=\"green\">"+total_cross_section+"</font><br>";
   mess=mess+"Total luminosity: <font color=\"green\">"+luminosity+"</font><br>";
   if (output_hepevt_record.length()>0) 
       mess=mess+"HEPEVT output: <font color=\"green\">"+output_hepevt_record+"</font><br>";
   if (output_hepevt_record.length()>0) 
       mess=mess+"RUNMC output: <font color=\"green\">"+output_root_record+"</font><br>";
   mess=mess+"CPU time per event: <font color=\"green\">"+averageCPU+"</font><br>";
   mess=mess+"Real time per event: <font color=\"green\">"+averageREAL+"</font><br>";
   mess=mess+"Run started: <font color=\"green\">"+run_started+"</font><br>";
   mess=mess+"Run finished: <font color=\"green\">"+run_finished+"</font></b></html>";

   viewer.setText( mess );

    Dimension dim = Global.mainFrame.getSize();
    int w=dim.width;
    int h=dim.height;
 // Get the system resolution
    Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
   // make sure the dialog is not too big
    Dimension size = new Dimension(Math.min(320,res.width),
                        Math.min(300, res.height) );
    viewer.setSize(size);
    Util.rightWithin ( Global.mainFrame, viewer );
    viewer.setCaretStart();
    viewer.setVisible(true);

   }


}
