// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC.hlookup;

import JRunMC.util.*;
import JRunMC.ui.*;

// Imports
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.*;
import java.math.*;
import java.lang.*;

public class  HistoViewer 
                extends         JFrame
 {


    public static final long serialVersionUID = 801;

    public static int  Nvariable=0;     // current number of variables 
    private static Vector<Object>  HVariables;  // with variables   
    private static Vector<Object>  HComments;   // with variables   
    private static Vector<Object>  HBinX;  // bins 
    private static Vector<Object>  HMinX;   // min 
    private static Vector<Object>  HMaxX;   // max 
    private static Vector<Object>  HBinY;  // bins
    private static Vector<Object>  HMinY;   // min
    private static Vector<Object>  HMaxY;   // max
    private static Vector<Object>  H2D;   // 2D? 
    private static int IcurrentHisto;


    private static int Hcurrent=0; // current position in table when inset
    private static DefaultListModel variableModel;
    private JPanel contentPane;
    private JPanel jPanel1;

    public  static AIDAEmbed hplot;
    private static FlowLayout flowLayout1;
    private static JSplitPane jSplitPane1;
    private static JScrollPane jScrollPane1;
    private static JScrollPane jScrollPane2;
    private  static JTableSource  jHlist; // variables 

    private static JButton jHB2;
    private static JButton jHB1;
    public  static DefaultListModel HlistModel;
    private BorderLayout borderLayout1;
    public static  VVTableModelInfo  model0; 
           
        // Instance attributes used in this dialog
        public HistoViewer()  {

       
         setDefaultCloseOperation( DISPOSE_ON_CLOSE ); 
         jPanel1 = new JPanel();
         flowLayout1 = new FlowLayout();
         jSplitPane1 = new JSplitPane();
         jScrollPane1 = new JScrollPane();
         jScrollPane2 = new JScrollPane();
         borderLayout1 = new BorderLayout();
       
         jHB1 = new JButton();
         jHB2 = new JButton(); 

                  
        contentPane = (JPanel)getContentPane();
        setDefaultCloseOperation( DISPOSE_ON_CLOSE );
        setTitle( "Histogram viewer");
        contentPane.setLayout(borderLayout1);

        jPanel1.setLayout(flowLayout1);
        jPanel1.setToolTipText("");





        jHB2.setText("Exit");
        jHB2.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1,
          "Exit histogram viewer?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) {
             SetIni.ShowStatus="Last action: Histogram viewer is closed";
            setVisible(false);
            dispose();
             }
        }  });






// AIDA
         hplot= new AIDAEmbed();
 

        
         
    // Create the data model for this example
    variableModel = new DefaultListModel();
    HVariables = new Vector<Object>();
    HComments = new Vector<Object>();
    HBinX = new Vector<Object>();
    HMinX = new Vector<Object>();
    HMaxX = new Vector<Object>();
    HBinY = new Vector<Object>();
    HMinY = new Vector<Object>();
    HMaxY = new Vector<Object>();
    H2D = new Vector<Object>();

       model0 = new VVTableModelInfo();
       jHlist = new JTableSource() { 

             public static final long serialVersionUID = 127;

             public Component prepareRenderer(TableCellRenderer renderer,
                                              int rowIndex, int vColIndex) {
            Component c = super.prepareRenderer(renderer, rowIndex, vColIndex);

            Color colcell = new  Color(244, 255, 255);
            Color colcolu = new  Color(255, 255, 200);


            if (rowIndex % 2 == 0 && !isCellSelected(rowIndex, vColIndex)) {
                c.setBackground(colcell);
            } else {
                // If not shaded, match the table's background
                c.setBackground(getBackground());
            }

          if (vColIndex ==0) c.setBackground(colcolu);
          // colom 
          c.setForeground(Color.black);       
          if (isCellSelected(rowIndex, vColIndex))  {c.setBackground(Color.blue); 
                                                     c.setForeground(Color.white);} 
            return c;
        }
    };

       jHlist.setModel(model0); 
       JTableHeader anHeader = jHlist.getTableHeader();
       anHeader.setForeground(new Color(0).yellow);
       anHeader.setBackground(new Color(0).black);
       jHlist.setToolTipText(
        "Click on the variable to display it");


       jHlist.setRowHeight(24);
       jHlist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
       jHlist.setShowGrid(false);
       model0.addColumn("Variable");
       model0.addColumn("Comment");
       jHlist.setFont(SetEnv.FontBold);


       jHlist.setShowHorizontalLines( true );
       jHlist.setShowVerticalLines( false );
       jHlist.setRowSelectionAllowed( true );
       jHlist.setColumnSelectionAllowed( false );

       // channge size
          TableColumn column0 = null;
          column0 = jHlist.getColumnModel().getColumn(0);
          column0.setPreferredWidth(80);
          column0.setMinWidth(80);
          column0.setMaxWidth(500);
          column0 = jHlist.getColumnModel().getColumn(1);
          column0.setPreferredWidth(120);
          column0.setMinWidth(2);
          column0.setMaxWidth(1000);

      // sets
      SetVariables(); 


      jHlist.addMouseListener(new MouseAdapter()
      {
       public void mouseClicked(MouseEvent em)
        {

        if (em.getClickCount() == 2 || em.getClickCount() ==1)
        {
  // first clean first dummy entry
          Object tmp=null;

          Point p = em.getPoint();
          int index  = jHlist.rowAtPoint(p);
          int column = jHlist.columnAtPoint(p); // This is the view column!
          tmp=HVariables.elementAt(index);
          String s1=(String)tmp;
          tmp=HComments.elementAt(index);
          // for 1D
          String s2=(String)tmp;
          tmp=HBinX.elementAt(index);
          int s3=Utility.GetInt(tmp.toString()); 
          tmp=HMinX.elementAt(index);
          double s4=Utility.GetDouble(tmp.toString());
          tmp=HMaxX.elementAt(index);
          double s5=Utility.GetDouble(tmp.toString()); 
          // for 2D
          tmp=HBinY.elementAt(index);
          int s6=Utility.GetInt(tmp.toString());
          tmp=HMinY.elementAt(index);
          double s7=Utility.GetDouble(tmp.toString());
          tmp=HMaxY.elementAt(index);
          double s8=Utility.GetDouble(tmp.toString());

// make plot 
          IcurrentHisto=index; 
          hplot.MakeHisto(s1,s2,s3,s4,s5,s6,s7,s8);

      } } } );




// menu bar
      JMenuBar bar = new JMenuBar();
      JMenu menu = new JMenu("File");
      JMenu option = new JMenu("Options");
      JMenu prop = new JMenu("Properties");


      JMenuItem item1 = new JMenuItem("Save as PNG");
        item1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
           hplot.SaveJCanvas();
           }  }  ); 


      JMenuItem item1pdf = new JMenuItem("Save as PDF");
        item1pdf.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
           hplot.SaveJCanvasPDF();
           }  }  );

      JMenuItem item2 = new JMenuItem("Print");
      item2.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
           hplot.PrintJCanvas();
           }  }  );


      JMenuItem item3 = new JMenuItem("Exit");
      // exit
         item3.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Exit histogram viewer?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) {
           SetIni.ShowStatus="Last action: Histogram viwer is closed";
           setVisible(false); dispose();}
        }  });

      menu.add(item1);
      menu.add(item1pdf);
      menu.add(item2);
      menu.add(item3);
      bar.add(menu);

// options
      JMenuItem Oitem1 = new JMenuItem("Histogram");
        Oitem1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
           hplot.Draw("h", Color.green);
           }  }  );
      option.add(Oitem1);


      JMenuItem Oitem2 = new JMenuItem("Symbols");
       Oitem2.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
           hplot.Draw("p", Color.green);
           }  }  );
      option.add(Oitem2);


      JMenuItem Oitem3 = new JMenuItem("Symbols+errors");
      Oitem3.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
           hplot.Draw("pe", Color.green);
           }  }  );
      option.add(Oitem3);


      JMenuItem Oitem3h = new JMenuItem("Histogram+errors");
       Oitem3h.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
           hplot.Draw("he", Color.green);
           }  }  );
      option.add(Oitem3h);


      JMenuItem Oitem4 = new JMenuItem("Filled");
         Oitem4.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
           hplot.Draw("a", Color.green);
           }  }  );
      option.add(Oitem4);


      bar.add(option);

      JMenuItem Editor= new JMenuItem("Canvas editor");
          Editor.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
           hplot.EditJCanvas();
           }  }  );

      prop.add(Editor);

// stat box
      JMenu StatBox= new JMenu("Statistics");
      ButtonGroup sbox = new ButtonGroup();
      JRadioButtonMenuItem sbox_on= new JRadioButtonMenuItem("on",true);
      JRadioButtonMenuItem sbox_off= new JRadioButtonMenuItem("off",false);
      sbox_on.setHorizontalTextPosition(JMenuItem.RIGHT);
      sbox_off.setHorizontalTextPosition(JMenuItem.RIGHT);
      sbox.add(sbox_on);
      sbox.add(sbox_off);
      StatBox.add(sbox_on);
      StatBox.add(sbox_off);
      prop.add(StatBox);

      sbox_on.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e)
      {  hplot.SetStatBox();  } });

      sbox_off.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e)
      {  hplot.removeStatBox();  } });

      JMenuItem AxisX = new JMenu("X axis");
      ButtonGroup groupX = new ButtonGroup();
      JRadioButtonMenuItem LogX= new JRadioButtonMenuItem("log",false);
      JRadioButtonMenuItem LinX= new JRadioButtonMenuItem("lin",true);
      LogX.setHorizontalTextPosition(JMenuItem.RIGHT);
      LinX.setHorizontalTextPosition(JMenuItem.RIGHT);
      groupX.add(LogX);
      groupX.add(LinX);
      AxisX.add(LogX);
      AxisX.add(LinX);
      prop.add(AxisX);

      LogX.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e)
      {  hplot.SetAxisX("Title","log");  } });

      LinX.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e)
      {  hplot.SetAxisX("Title","lin");   } });


      JMenuItem AxisY = new JMenu("Y axis");
      ButtonGroup groupY = new ButtonGroup();
      JRadioButtonMenuItem LogY= new JRadioButtonMenuItem("log",false);
      JRadioButtonMenuItem LinY= new JRadioButtonMenuItem("lin",true);
      LogY.setHorizontalTextPosition(JMenuItem.RIGHT);
      LinY.setHorizontalTextPosition(JMenuItem.RIGHT);
      groupY.add(LogY);
      groupY.add(LinY);
      AxisY.add(LogY);
      AxisY.add(LinY);
      prop.add(AxisY);

      LogY.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e)
      {  hplot.SetAxisY("Entries","log");  } });

      LinY.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e)
      {  hplot.SetAxisY("Entries","lin");   } });

      bar.add(prop);
// add menu 
      this.setJMenuBar(bar);




        jHB1.setText("Update histogram");
        jHB1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          Object tmp=null;
          int index  = IcurrentHisto;
          tmp=HVariables.elementAt(index);
          String s1=(String)tmp;
          tmp=HComments.elementAt(index);
          // for 1D
          String s2=(String)tmp;
          tmp=HBinX.elementAt(index);
          int s3=Utility.GetInt(tmp.toString());
          tmp=HMinX.elementAt(index);
          double s4=Utility.GetDouble(tmp.toString());
          tmp=HMaxX.elementAt(index);
          double s5=Utility.GetDouble(tmp.toString());
          // for 2D
          tmp=HBinY.elementAt(index);
          int s6=Utility.GetInt(tmp.toString());
          tmp=HMinY.elementAt(index);
          double s7=Utility.GetDouble(tmp.toString());
          tmp=HMaxY.elementAt(index);
          double s8=Utility.GetDouble(tmp.toString());

// make plot
          hplot.MakeHisto(s1,s2,s3,s4,s5,s6,s7,s8);
        }  });







        jPanel1.add(jHB1, null);
        jPanel1.add(jHB2, null); 
        jSplitPane1.setOrientation(JSplitPane.HORIZONTAL_SPLIT);
        jSplitPane1.setOneTouchExpandable(true);
        jSplitPane1.setDividerLocation(150);
        
        

        jSplitPane1.add(jScrollPane1, JSplitPane.LEFT);
        jScrollPane1.getViewport().add(jHlist);
        jSplitPane1.add(jScrollPane2, JSplitPane.RIGHT);
        contentPane.add(jSplitPane1, java.awt.BorderLayout.CENTER);
        contentPane.add(jPanel1, java.awt.BorderLayout.SOUTH);
        jScrollPane2.getViewport().add( hplot );
        
	


        Show();
      
   }  // end main class 






          
// set histogram names  
        public void SetVariables()  { 
         
          // clean first 
          HVariables.clear();
          HComments.clear();
          HBinX.clear();
          HMinX.clear();
          HMaxX.clear();
          HBinY.clear();
          HMinY.clear();
          HMaxY.clear();
          H2D.clear();

          // Remove all rows
          model0.setRowCount(0);
          Nvariable=0;
          int ikk=0;
          String[] SS = new String[2];

          for (int i=0;i<SetIni.HistoN;i++) {
          String s1=StringUtil.replace(SetIni.HistoName[i], "@", "");

          if (SetIni.Histo2D[i] == 1) {
           HVariables.addElement( s1 );
           HComments.addElement( " "+SetIni.HistoComm[i]  );
           HBinX.addElement( SetIni.HistoBins[i]  );
           HMinX.addElement( SetIni.HistoMin[i]  );
           HMaxX.addElement( SetIni.HistoMax[i]  );
           HBinY.addElement( 0 );
           HMinY.addElement( 0.0 );
           HMaxY.addElement( 0.0 );
           H2D.addElement(  SetIni.Histo2D[i]  );
           Nvariable++;
           }
// get 2 D histogram 
          if (SetIni.Histo2D[i] == 2 && ikk<2) {
           SS[ikk]=s1; 
           if (ikk == 1) {
              ikk=0;
              HVariables.addElement( SS[0]+"-"+SS[1] );
//              System.out.println(SS[0]+"-"+SS[1] );
              HComments.addElement( " "+SetIni.HistoComm[i-1]+" vs "+SetIni.HistoComm[i]  );
              H2D.addElement( SetIni.Histo2D[i]  );
              HBinX.addElement( SetIni.HistoBins[i-1]  );
              HMinX.addElement( SetIni.HistoMin[i-1]  );
              HMaxX.addElement( SetIni.HistoMax[i-1]  );
              HBinY.addElement( SetIni.HistoBins[i]  );
              HMinY.addElement( SetIni.HistoMin[i]  );
              HMaxY.addElement( SetIni.HistoMax[i]  );
              Nvariable++;
           }
           ikk++;
         
           }
          }

 

// fill 
         for (int i=0; i<HVariables.size();  i++) {
          String ss0=(String)HVariables.elementAt(i);
          String ss1=(String)HComments.elementAt(i);
            model0.addRow(
                   new Object[]{new String(ss0), new String(ss1) }); 
         } 
          jSplitPane1.repaint();     
        }  
        


 

// store message 
     private void setMessage()  {
          SetIni.ShowHistoN=Integer.toString(SetIni.HistoN)+" histograms";
     } 
          


// create about
    public void Show() {

// store mainframe dimensions
    Dimension dim = Global.mainFrame.getSize();
    int w=dim.width;
    int h=dim.height;
 // Get the system resolution
    Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
   // make sure the dialog is not too big
    Dimension size = new Dimension(Math.min(600,res.width),
                        Math.min((int)(1.0*h), res.height) );
    this.setSize(size);
    Util.rightWithin ( Global.mainFrame, this );

//    this.pack();
 //   Util.centreWithin( Global.mainFrame, this );
    this.setVisible(true);

   }






          
} // end class






 // change defaults for JList
class HistoCellRenderer
 extends  JLabel
 implements ListCellRenderer 
{

 public static final long serialVersionUID = 11;

 private ImageIcon image[];
  
 final static ImageIcon longIcon = new ImageIcon("long.gif");
 final static ImageIcon shortIcon = new ImageIcon("short.gif");
  
 

 public HistoCellRenderer()
 {
  setOpaque(true);

 
  /*
  // Pre-load the graphics images to save time
  image = new ImageIcon[4];
  image[0] = new ImageIcon( "circles.gif" );
  image[1] = new ImageIcon( "bubbles.gif" );
  image[2] = new ImageIcon( "thatch.gif" );
  image[3] = new ImageIcon( "pinstripe.gif" );
 
 */
 }
  
  
 public Component getListCellRendererComponent(
   JList list, Object value, int index, 
   boolean isSelected, boolean cellHasFocus )
   
 
 {
  // Display the text for this item
   
  String s = value.toString();
         setText(s);
         setIcon((s.length() > 10) ? longIcon : shortIcon);
  
  
  // Draw the correct colors and font
  if( isSelected )
  {
   // Set the color and font for a selected item
   setBackground( Color.blue );
   setForeground( Color.white );
   setFont( new Font( "Lucida Sans", Font.BOLD, 14 ) );
  }
  else
  {
   // Set the color and font for an unselected item
   setBackground( Color.white );
   setForeground( Color.black );
   setFont( new Font( "Lucida Sans", Font.BOLD, 14 ) );
  }

  return this;
 }





} // end main class

