// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.
// define your MC available 
package JRunMC.ui;

import JRunMC.util.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.lang.*;



   public class  SetMC {
    
   // new MC 
    public static Vector<String> available;
    public static Vector<String> available_alias; // alias names 
    public static Vector<String> status; 
    private static String pathTObin;
    private static TreeSet<String>  sMonteCarlo;


    public static void init() { 

      // location of databases
    available = new Vector<String>();
    available_alias = new Vector<String>();
    status = new Vector<String>();
    sMonteCarlo = new TreeSet<String>();

  pathTObin = SetEnv.RUNDIR+File.separator+"bin";
  if (SetEnv.OSsys.equals("windows") ) 
         pathTObin =SetEnv.RUNDIRwin32+File.separator+"bin";

    } // ini 



// Fill vectors with MC information
  public static void FillMCexe() { 


// clear first 
    available.clear();
    available_alias.clear();
    status.clear();
    sMonteCarlo.clear();

    File f1= new File(pathTObin);
    int nn=0;



    if (f1.isDirectory()) {

     String s[]=f1.list();

     for (int i=0; i<s.length; i++) {
         File f=new File (pathTObin + File.separator+ s[i]);

         if (f.isFile() && f.isAbsolute() ) {
             if ( s[i].startsWith("runmc.")  
               && f.length()>2000) { // for windows, do not pick up runmc.lnk 
                  String ss=StringUtil.replace(s[i], "runmc.", "");
               //   System.out.println( ss );  
                  sMonteCarlo.add(ss);  
       } }
      }

      
// fill vectors
    Iterator itr = sMonteCarlo.iterator();
    while (itr.hasNext() ) {
      Object elem=itr.next();
       String mc = elem.toString(); 
       available.addElement( mc ); 

       status.addElement( "idle"  );
// build association
      if ( mc.equals("pythia6") ) available_alias.addElement( "PYTHIA 6.4" ); 
      if ( mc.equals("herwig") ) available_alias.addElement( "HERWIG 6.5" );
      if ( mc.equals("aroma") ) available_alias.addElement( "AROMA 2.2.4" );
      if ( mc.equals("ariadne") ) available_alias.addElement( "ARIADNE 4.12" );
      if ( mc.equals("lepto-ariadne") ) available_alias.addElement( "LEPTO/ARIADNE" );
      if ( mc.equals("cascade") ) available_alias.addElement( "CASCADE 1.2" );
      if ( mc.equals("rapgap3") ) available_alias.addElement( "RAPGAP 3.1" );
      if ( mc.equals("phojet") ) available_alias.addElement( "PHOJET 1.05" );
      if ( mc.equals("lepto") ) available_alias.addElement( "LEPTO 6.5" );
      if ( mc.equals("external") ) available_alias.addElement( "EXTERNAL" );
     } 

     if (available.size() != available_alias.size() ) {
      System.out.println("some MC executables have no aliases" );
      System.exit(0);
      } 

    
     } 
    
    
   } // end ini  
     
     
   }
