// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC.ui;


import JRunMC.util.XMLformater;

// set preferences for RMC info file
import java.io.*;
import java.util.*;
import java.util.prefs.*;
import java.text.*;


   public class  SetPref{

    public static Preferences   prefs;

    //keys
    public static final String keyjGroup="group";
    public static final String keyjTitle="title";
    public static final String keyjShortDescription="short-description";
    public static final String keyjAuthor="authors";
    public static final String keyjContact="contact";
    public static final String keyjLastModified="last-modified";
    public static final String keyjDescription="description";
    public static final String keyProject="project";
    public static final String keyTime="time";
  
    public static String FileName;
    public static String shortName;
 



       public static void init(){

      shortName="user-comment.xml"; 


      String path=SetEnv.RUNDIR;
      if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;
      FileName = path+File.separator+"proj"+File.separator+shortName; 
 
      prefs=Preferences.userNodeForPackage( JRunMC.class );
//     prefs.userNodeForPackage(String.class);


     prefs.put(keyProject, new String( SetIni.MOutput )  ); 

         // Get today's date
       Date date = new Date();
       Format  formatter = new SimpleDateFormat("dd-MMM-yy");
       prefs.put(keyTime, new String( formatter.format(date) )  );

        prefs.put(keyjTitle, "");
        prefs.put(keyjShortDescription, "");
        prefs.put(keyjAuthor, "" );
        prefs.put(keyjContact, "" );
        prefs.put(keyjLastModified, "" );
        prefs.put(keyjDescription, ""  );
        prefs.put(keyjGroup, ""  );

       }




 
 
    public static void Read(){                


    File f = new File(FileName);

    if (f.exists() && f.length()>1 ) { 

// create about
    // Create an input stream on a file
    InputStream is = null;
    try {
        is = new BufferedInputStream(new FileInputStream( f ));
    } catch (FileNotFoundException e) {
         System.out.println( "File not found!" );
    }

    // Import preference data
    try {
         Preferences.importPreferences(is);
// build new group from all RMC
    String textjGroup = SetPref.prefs.get(SetPref.keyjGroup, "");

//     System.out.println(textjGroup);
    String sw=textjGroup.trim();
    if (sw.length()>0) SetEnv.ListGroup.add( sw );

    } catch (InvalidPreferencesFormatException e) {
    } catch (IOException e) {
         System.out.println( "Error in importing preferences!" );
    }

    } else { 

        System.out.println( "Preferences set to zero" );
        prefs.put(keyjTitle, "");
        prefs.put(keyjShortDescription, "");
        prefs.put(keyjAuthor, "" );
        prefs.put(keyjContact, "" );
        prefs.put(keyjLastModified, "" );
        prefs.put(keyjDescription, ""  );
        prefs.put(keyjGroup,""  );
     } // exist

 
    } // end 
      
      
// create about
   public static void Write() {


   try {
          prefs.exportNode(new FileOutputStream( FileName ));

    } catch (IOException e) {
    } catch (BackingStoreException e) {
    }

// format this nicely - good for debugging
    XMLformater.format(FileName,"/>", "/>\n");



    } 
      
      
   
   
   }

                  
                  
 
