
         SUBROUTINE RUNMCherwigsteer 


         INCLUDE "src/herwig6505.inc" 
         include "../mcarlo/inc/runmc_steer.inc"

C set here HERWIG parameters for initialization
C  PURPOSE: Interpret the seering to change the default
C          note: only those parameters can be changed which the user
C                may change according to the HERWIG  manual.
C
C **********************************************************************

          write(6,*) "--------------------------------------"
          write(6,*) " HERWIG65  STEERING CARD              "
          write(6,*) "--------------------------------------"


C          note: only those parameters can be changed which the user
C                may change according to the PYTHIA manual.
C
C**********************************************************************
C---Determine the machine accuacy EPSMAC (D= 2.E-06)
      EPSMAC = 0.5
      DO 33 I= 1, 100
      EPSMAC = EPSMAC * 0.5
      IF ((1.0+EPSMAC) .EQ. 1.0)  GO TO 35
   33 CONTINUE
      EPSMAC = 1.0E-6
   35 EPSMAC = 2.0 * EPSMAC
      WRITE(6,330) EPSMAC
 330  FORMAT(1X,/,' COMPUTED MACHINE ACCURACY = ',G10.2,/)

C---Interpret the text containing the parameters to be changed
      If(Nloop.ge.1) Then
           Do 30 I=1,Nloop

            LND = Ld(I)
            LNE = Le(I)

            PARAM = parax(I)
            INT = Ival(I)
            REA = Rval(I)

* IPRO means IPROC  

            IF (PARAM.EQ.'IPRO') THEN
                IDEF = IPROC
                IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                    IPROC = INT
                    PRINT 91001, PARAM,LND,IDEF,INT
                ELSE
                    PRINT 92001, PARAM,LND,IDEF,INT
                ENDIF
            ENDIF

* IPRI means IPRINT 

            IF (PARAM.EQ.'IPRI') THEN
                IDEF = IPRINT
                IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                    IPRINT = INT
                    PRINT 91001, PARAM,LND,IDEF,INT
                ELSE
                    PRINT 92001, PARAM,LND,IDEF,INT
                ENDIF
            ENDIF

* NFLA means NFLAV 

            IF (PARAM.EQ.'NFLA') THEN
                IDEF = NFLAV 
                IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                    NFLAV = INT
                    PRINT 91001, PARAM,LND,IDEF,INT
                ELSE
                    PRINT 92001, PARAM,LND,IDEF,INT
                ENDIF
            ENDIF


* IOPR means IOPREM
            IF (PARAM.EQ.'IOPR') THEN
                IDEF = IOPREM 
                IF (ABS(IDEF-INT).GT.EPSMAC) THEN
                    IOPREM = INT
                    PRINT 91001, PARAM,LND,IDEF,INT
                ELSE
                    PRINT 92001, PARAM,LND,IDEF,INT
                ENDIF
            ENDIF

 



* PBE1 means PBEAM1
* PBE2 means PBEAM2

            IF (PARAM.EQ.'PBE1') THEN
                RDEF = PBEAM1
                IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                    PBEAM1 = REA
                    PRINT 91002, PARAM,LND,RDEF,REA
                ELSE
                    PRINT 92002, PARAM,LND,RDEF,REA
                ENDIF
            ENDIF

            IF (PARAM.EQ.'PBEA2') THEN
                RDEF = PBEAM2 
                IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                    PBEAM2 = REA
                    PRINT 91002, PARAM,LND,RDEF,REA
                ELSE
                    PRINT 92002, PARAM,LND,RDEF,REA
                ENDIF
            ENDIF


** QCDL means QCDLAM
            IF (PARAM.EQ.'QCDL') THEN
                RDEF = QCDLAM 
                IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                    QCDLAM = REA
                    PRINT 91002, PARAM,LND,RDEF,REA
                ELSE
                    PRINT 92002, PARAM,LND,RDEF,REA
                ENDIF
            ENDIF

* RMAS means RMASS(1-6) - mass 

            IF (PARAM.EQ.'RMAS') THEN
                RDEF = RMASS(LND)
                IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                    RMASS(LND) = REA
                    PRINT 91002, PARAM,LND,RDEF,REA
                ELSE
                    PRINT 92002, PARAM,LND,RDEF,REA
                ENDIF
            ENDIF

* PTMI means PTMIN  

           IF (PARAM.EQ.'PTMI') THEN
                RDEF = PTMIN  
                IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                    PTMIN = REA
                    PRINT 91002, PARAM,LND,RDEF,REA
                ELSE
                    PRINT 92002, PARAM,LND,RDEF,REA
                ENDIF
            ENDIF

* PRSO means PRSOF
           IF (PARAM.EQ.'PRSO') THEN
                RDEF = PRSOF 
                IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                    PRSOF = REA
                    PRINT 91002, PARAM,LND,RDEF,REA
                ELSE
                    PRINT 92002, PARAM,LND,RDEF,REA
                ENDIF
            ENDIF

* Q2MI means Q2MIN
           IF (PARAM.EQ.'Q2MI') THEN
                RDEF = Q2MIN 
                IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                    Q2MIN = REA
                    PRINT 91002, PARAM,LND,RDEF,REA
                ELSE
                    PRINT 92002, PARAM,LND,RDEF,REA
                ENDIF
            ENDIF

* Q2MA means Q2MAX 
           IF (PARAM.EQ.'Q2MI') THEN
                RDEF = Q2MAX
                IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                    Q2MAX = REA
                    PRINT 91002, PARAM,LND,RDEF,REA
                ELSE
                    PRINT 92002, PARAM,LND,RDEF,REA
                ENDIF
            ENDIF

* YBMI means YBMIN  
           IF (PARAM.EQ.'YBMI') THEN
                RDEF = YBMIN 
                IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                    YBMIN = REA
                    PRINT 91002, PARAM,LND,RDEF,REA
                ELSE
                    PRINT 92002, PARAM,LND,RDEF,REA
                ENDIF
            ENDIF

* WHMI means WHMIN
           IF (PARAM.EQ.'WHMI') THEN
                RDEF = WHMIN
                IF (ABS(RDEF-REA).GT.EPSMAC) THEN
                    WHMIN = REA
                    PRINT 91002, PARAM,LND,RDEF,REA
                ELSE
                    PRINT 92002, PARAM,LND,RDEF,REA
                ENDIF
            ENDIF
 


30      CONTINUE
      ENDIF

91001 FORMAT(' RUNMC: ',A4,'(',I4,')',
     &       ' changed from the default ',I8,' TO',I8)
92001 FORMAT(' RUNMC (waring):',A4,'(',I4,')',
     &       ' not changed from the default ',I8,' TO',I8)
91002 FORMAT(' RUNMC: ',A4,'(',I4,')',
     &       ' changed from the default ',E10.3,' TO',E10.3)
92002 FORMAT(' RUNMC (waring):',A4,'(',I4,')',
     &       ' not changed from the default ',E10.3,' TO',E10.3)

91003 FORMAT(' RUNMC:',
     &'CHAF(',I4,') changed from the default:',A4,A4)
92003 FORMAT(' RUNMC:',
     &'CHAF(',I4,') not changed from the default :',A4,A4)
91004 FORMAT('                                     TO:',A4,A4)


      RETURN
      END
