CDECK  ID>, HWH2BH.
*CMZ :-        -30/06/01  18.21.35  by  Stefano Moretti
*-- Author :  Kosuke Odagiri & Stefano Moretti
C-----------------------------------------------------------------------
      SUBROUTINE HWH2BH(P1,P2,P3,P4,P5,
     &                  EMW,EMH,EMH01,EMH02,EMH03,EMB,EMT,IFL,IRES,CKM,
     &                  GAMT,M2)
C-----------------------------------------------------------------------
C...Matrix element for b(1) + q(2) -> b(3) + q'(4) + H+/-(5) and C.C.,
C...q(q') massless incoming(outgoing) quark, all other masses retained.
C...It factorises 64.*PIFAC**3*ALPHA**3/4./SWEIN/SWEIN/SWEIN/EMW/EMW.
C
C...First release:  01-APR-1998 by Kosuke Odagiri
C...First modified: 12-APR-1998 by Stefano Moretti
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER MU,IRES,IFL
      DOUBLE PRECISION P1(0:3),P2(0:3),P3(0:3),P4(0:3),P5(0:3)
      DOUBLE PRECISION EMB,EMT,EMW,EMH,EMH01,EMH02,EMH03
      DOUBLE PRECISION GAMT,GAMWTMP,GAMH01,GAMH03,GAMH02,CKM
      DOUBLE PRECISION QW(0:3),QS(0:3)
      DOUBLE PRECISION N0,DOTHH,DOTSS,DOTWW,E1234
      DOUBLE PRECISION DOTTT,DOT12,DOT13,DOT14,DOT1H,DOT23
      DOUBLE PRECISION DOT24,DOT2H,DOT34,DOT3H,DOT4H
      DOUBLE PRECISION PT2,PV2,PA2,PTPV,PTPA,IMPTPV,IMPTPA
      DOUBLE PRECISION M2
      DOUBLE COMPLEX PV,PA,PT,PW,Z
      PARAMETER (GAMWTMP=0.D0,GAMH01=0.D0,GAMH03=0.D0,GAMH02=0.D0)
      PARAMETER (Z=(0.D0,1.D0))
      DOUBLE PRECISION SC,RICCI
      EXTERNAL SC,RICCI
C
      DO 670 MU=0,3
         QW(MU)=P2(MU)-P4(MU)
         QS(MU)=P1(MU)-P3(MU)
 670  CONTINUE
C
      DOTHH=EMH*EMH
      DOTSS=SC(QS,QS)
      DOTWW=SC(QW,QW)
      DOT13=EMB*EMB-DOTSS/2.D0
      DOT24=-DOTWW/2.D0
      DOT2H=SC(P2,P5)
      DOT4H=SC(P4,P5)
C
      IF(IFL.EQ.1)THEN
        DOT12=SC(P1,P2)
        DOT14=SC(P1,P4)
        DOT1H=SC(P1,P5)
        DOT23=SC(P2,P3)
        DOT34=SC(P3,P4)
        DOT3H=SC(P3,P5)
        E1234=RICCI(P1,P2,P3,P4)
      ELSE IF(IFL.EQ.-1)THEN
        DOT12=-SC(P3,P2)
        DOT14=-SC(P3,P4)
        DOT1H=-SC(P3,P5)
        DOT23=-SC(P2,P1)
        DOT34=-SC(P1,P4)
        DOT3H=-SC(P1,P5)
        E1234=-RICCI(P1,P2,P3,P4)
      END IF
C
      DOTTT=DOTHH+EMB*EMB+2.D0*DOT3H
C
      PV=COSA*SINBMA/(DOTSS-EMH01*EMH01+Z*EMH01*GAMH01)+
     1   SINA*COSBMA/(DOTSS-EMH02*EMH02+Z*EMH02*GAMH02)
      PA=SINB/(DOTSS-EMH03*EMH03+Z*EMH03*GAMH03)
      PW=1./(DOTWW-EMW*EMW+Z*EMW*GAMWTMP)
C REMOVE TOP DIAGRAM.
      IF(IRES.EQ.1)PT=1./(DOTTT-EMT*EMT+Z*EMT*GAMT)
      IF(IRES.EQ.0)PT=(0.D0,0.D0)
      PT=PT*CKM
      PT2 =DREAL(DCONJG(PT)*PT)
      PV2 =DREAL(DCONJG(PV)*PV)
      PA2 =DREAL(DCONJG(PA)*PA)
      PTPV=DREAL(DCONJG(PT)*PV)
      PTPA=DREAL(DCONJG(PT)*PA)
      IMPTPV=DIMAG(DCONJG(PT)*PV)
      IMPTPA=DIMAG(DCONJG(PT)*PA)
C
      N0=ABS(PW)
C
      M2=N0*N0* ( EMB*EMB/COSB/COSB*(PV2+PA2)*DOT13*
     &   (2.D0*DOT4H*DOT2H-DOT24*DOTHH)+
     T 2.D0*PT2*DOT12*
     O   (EMB*EMB*TANB*TANB*(2.D0*DOT3H*DOT4H-DOT34*DOTHH)+
     P    EMT*EMT/TANB/TANB*(EMT*EMT*DOT34))+
     & EMB*EMB*TANB/COSB*DREAL(PV+PA)*
     X   (DREAL(PT)*(4.D0*DOT4H*DOT12*DOT13-
     T    (2.D0*DOT4H+DOTHH)*(DOT12*DOT34+DOT13*DOT24-DOT14*DOT23))+
     M    DIMAG(PT)*(2.D0*DOT4H+DOTHH)*E1234) )
      RETURN
 999  END
C
      DOUBLE PRECISION FUNCTION SC(A,B)
      DOUBLE PRECISION A(0:3),B(0:3)
      SC=A(0)*B(0)-A(1)*B(1)-A(2)*B(2)-A(3)*B(3)
      RETURN
      END
