CDECK  ID>, HWH2SS
*CMZ :-        -27/02/01  17:04:16  by  Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWH2SS(S,K,KK)
C-----------------------------------------------------------------------
C     Subroutine to calculate the spinor products in the notation of
C     Kleiss and Strirling S(1) is S and S(2) is T
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION WRN(2),K(5),KK(5),P(5,2),Q1,Q2,EPS,QTI,PTI,
     &     PT,QT,DPM,DMP,QP,QM,P1,P2,PP,PM
      DOUBLE COMPLEX S(2),ZI,Z1,ZT,ZQ,ZQS,ZPS,ZP,ZDPM,ZDMP
      INTEGER I,II,JJ
      EPS=0.0000001
      ZI=DCMPLX(ZERO,ONE)
      Z1=DCMPLX(ONE,ZERO)
C FOLLOWING DO LOOP IS TO CONVERT TO OUR STANDARD INDEXING
      DO I=1,4
        P(I,2) = K(I)
        P(I,1) = KK(I)
      ENDDO
      DO 2 II=1,2
      WRN(II)=ONE
      IF(P(4,II).LT.ZERO) WRN(II)=-ONE
      DO 2 JJ=1,4
      P(JJ,II)=WRN(II)*P(JJ,II)
    2 CONTINUE
C THE ABOVE CHECKS FOR MOMENTA WITH NEGATIVE ENERGY,INNER PRODUCTS
C ARE EXPRESSED DIFFERENTLY FOR DIFFERENT CASES
      Q1=P(4,1)+P(1,1)
      QP=ZERO
      IF(Q1.GT.EPS) QP=SQRT(Q1)
      Q2=P(4,1)-P(1,1)
      QM=0.0
      IF(Q2.GT.EPS)QM=SQRT(Q2)
      P1=P(4,2)+P(1,2)
      PP=ZERO
      IF(P1.GT.EPS)PP=SQRT(P1)
      P2=P(4,2)-P(1,2)
      PM=ZERO
      IF(P2.GT.EPS)PM=SQRT(P2)
      DMP=PM*QP
      ZDMP=DCMPLX(DMP,ZERO)
      DPM=PP*QM
      ZDPM=DCMPLX(DPM,ZERO)
C NOTE THAT IN OUR INNER PRODUCT NOTATION WE ARE COMPUTING <P,Q>
      PT=SQRT(P(2,2)**2+P(3,2)**2)
      QT=SQRT(P(2,1)**2+P(3,1)**2)
      IF(PT.GT.EPS) GOTO 99
      ZP=Z1
      GOTO 98
   99 PTI=ONE/PT
      ZP=DCMPLX(PTI*P(2,2),PTI*P(3,2))
   98 ZPS=DCONJG(ZP)
      IF(QT.GT.EPS) GOTO 89
      ZQ=Z1
      GOTO 88
   89 QTI=ONE/QT
      ZQ=DCMPLX(QTI*P(2,1),QTI*P(3,1))
   88 ZQS=DCONJG(ZQ)
      ZT=Z1
      IF(WRN(1).LT.ZERO) ZT=ZT*ZI
      IF(WRN(2).LT.ZERO) ZT=ZT*ZI
      S(2)=-(ZDMP*ZP-ZDPM*ZQ)*ZT
      S(1)=(ZDMP*ZPS-ZDPM*ZQS)*ZT
      END
