CDECK  ID>, HWHIGE.
*CMZ :-        -13/10/02  09.43.05  by  Peter Richardson
*-- Author :    Kosuke Odagiri and Stefano Moretti
C-----------------------------------------------------------------------
C...Generate completely differential cross section (EVWGT) in the variables
C...X(I) with I=1,4 (see below) for the processes from IPROC=1000-1099 (SM),
C...IPROC=1111-1139 (MSSM), as described in the HERWIG 6 documentation file.
C...(For IPROC=1140-1145 it describes MSSM charged Higgs production.)
C
C...First release: 18-SEP-2002 by Stefano Moretti
C
      SUBROUTINE HWHIGE
C--------------------------------------------------------------------------
C     LEPTOPRODUCTION OF MS(SM) HIGGSES IN ASSOCIATION WITH HEAVY QUARK PAIRS
C--------------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER JHIGGS
      INTEGER I,L,M,N,NN
      INTEGER IH,IQ,JQ,IIQ,JJQ
      INTEGER IAD
      INTEGER IDEC,NC,FLIP
      INTEGER ID1,ID2
      DOUBLE PRECISION CV,CA,BR
      DOUBLE PRECISION BRHIGQ,EMQ,ENQ,GMQ,EMQQ,EMH,GMH,EMHWT,EMW
      DOUBLE PRECISION PTMMIN,PTNMIN
      DOUBLE PRECISION T,TL,TLMIN,TLMAX,TTMIN,TTMAX,CTMP,RCM,RCM2
      DOUBLE PRECISION X(4),XL(4),XU(4)
      DOUBLE PRECISION Q4(0:3),Q34(0:3)
      DOUBLE PRECISION CT5,ST5,CT4,ST4,CF4,SF4,RQ52,RQ5,RQ42,RQ4,PQ4
      DOUBLE PRECISION P1(0:3),P2(0:3),P3(0:3),P4(0:3),P5(0:3)
      DOUBLE PRECISION F(0:3),G(0:3)
      DOUBLE PRECISION ECM,SHAT,S
      DOUBLE PRECISION EMIN,EMIN1,EMIN2,PCM2,PCM
      DOUBLE PRECISION HFC,HBC
      DOUBLE PRECISION M2EE
      DOUBLE PRECISION GRND,FACGPM(2)
      DOUBLE PRECISION ALPHA,EMSC2
      DOUBLE PRECISION HWRGEN,HWUAEM
      DOUBLE PRECISION PHI,CPHI,SPHI,ROT(3,3)
      DOUBLE PRECISION QAUX(0:3)
      DOUBLE PRECISION EPS,HCS,RCS,FACT
      DOUBLE PRECISION WEIGHT
      INTEGER IFL,KHIGGS,JH,JFL
      LOGICAL FIRST,GAUGE
      DOUBLE PRECISION E,Q3,YM3,GAM3,YM4,GAM4,GAM5,COLOUR
      DOUBLE PRECISION RM3,RM4,RM5
      DOUBLE PRECISION S2W,RMW,RMZ
      DOUBLE PRECISION RMHL,GAMHL
      DOUBLE PRECISION RMHH,GAMHH
      DOUBLE PRECISION RMHA,GAMHA
      EQUIVALENCE (RMHL,RMASS(203)),(RMHH,RMASS(204)),(RMHA,RMASS(205))
      LOGICAL HWRLOG
      EXTERNAL HWHIGM,HWRGEN,HWUAEM,HWHQCP,HWH2HE,HWEONE,HWRLOG
      PARAMETER (EPS=1.D-9)
      EQUIVALENCE (EMW,RMASS(198)),(NC,NCOLO)
      SAVE HCS,M2EE,FACT,S,SHAT,P3,P4,P5
      SAVE IIQ,JJQ,JHIGGS
C...ASSIGN Q/Q'-FLAVOUR.
      IF(IPROC.GE.1140)THEN
        IH=4 
        IF(IPROC.EQ.1140)IQ=2
        IF(IPROC.EQ.1141)IQ=4
        IF(IPROC.EQ.1142)IQ=6
        IF(IPROC.EQ.1143)IQ=7
        IF(IPROC.EQ.1144)IQ=8
        IF(IPROC.EQ.1145)IQ=9
        IAD=7
        JQ=IQ+5
        GMQ=ZERO
        IF(JQ.EQ.11)GMQ=HBAR/RLTIM(6)
      ELSE
        IF(IMSSM.EQ.0)THEN
          IH=0
          IQ=6
        ELSE
          IF(IPROC.LT.1140)IH=3
          IF(IPROC.LT.1130)IH=2
          IF(IPROC.LT.1120)IH=1
          IQ=IPROC-1100-10*IH
        END IF
        IAD=6
        JQ=IQ+6
        GMQ=ZERO
      END IF
C...PROCESS EVENT.
      IF(GENEV)THEN
        RCS=HCS*HWRGEN(0)
      ELSE
        EVWGT=0.
        HCS=0.
C...ASSIGN FINAL STATE MASSES.
        IF(IQ.LE.6)THEN
          EMQ=RMASS(IQ)
          ENQ=RMASS(JQ)
        ELSE
          EMQ=RMASS(2*IQ-7+114+IAD)
          ENQ=RMASS(2*IQ-7+114    )
        END IF
        EMH=RMASS(201+IHIGGS)
        GMH=HBAR/RLTIM(201+IHIGGS)
        EMHWT=1.
C...ENERGY AT PARTON LEVEL.
        ECM=PBEAM1+PBEAM2
        S=ECM*ECM
        SHAT=S
        IF((EMH.LE.0.).OR.(EMH.GE.ECM))RETURN
C...PHASE SPACE VARIABLES.
C...X(1)=(EMQQ**2-(EMQ+ENQ)**2)/((ECM-EMH)**2-(EMQ+ENQ)**2),
C...LIGHT QUARKS -> X(2)=(LOG|T|-LOG|TMIN|)/(LOG|TMAX|-LOG|TMIN|),
C...                X(3)=SIN(THETA4_CM_34),X(4)=COS(FI4_CM_34),
C...HEAVY QUARKS -> X(2)=COS(THETA5_CM),
C...                X(3)=COS(THETA4_CM_34),X(4)=FI4_CM_34,
C...PHASE SPACE BORDERS.
        XL(1)=0.
        XU(1)=1.
        IF((IQ+JQ).EQ.18)THEN
          XL(2)=-1.
          XL(4)=0.
          XU(4)=2.*PIFAC
        ELSE
          XL(2)=0.
          XL(4)=-1.
          XU(4)=1.
        END IF
        XU(2)=1.
        XL(3)=-1.
        XU(3)=1.
C...SINGLE PHASE SPACE POINT.
 100    CONTINUE
        WEIGHT=1.
        DO I=1,4
          X(I)=XL(I)+(XU(I)-XL(I))*HWRGEN(0)
          WEIGHT=WEIGHT*ABS(XU(I)-XL(I))
        END DO
C...ENERGY AT PARTON LEVEL.
        PTMMIN=0.
        PTNMIN=0.
        IF(IMSSM.NE.0)THEN
          IF(IPROC.GE.1140)THEN
            PTNMIN=PTMIN
          ELSE
            IF((IQ.NE.6).AND.(IQ.NE.12).AND.
     &         (JQ.NE.6).AND.(JQ.NE.12))THEN
              PTMMIN=PTMIN
              PTNMIN=PTMIN
            ELSE
              CONTINUE
            END IF
          END IF
        END IF
C...THREE PARTICLE KINEMATICS.
        EMQQ=SQRT(X(1)*((ECM-EMH)**2-(EMQ+ENQ)**2)+(EMQ+ENQ)**2)
C...INCOMING PARTONS: ALL MASSLESS.
        EMIN=0.
        IF((IQ+JQ).EQ.18)THEN
          CT5=X(2)
          CT4=X(3)
          ST4=SQRT(1.-CT4*CT4)
          CF4=COS(X(4))
          SF4=SIN(X(4))
        ELSE
          PCM2=((ECM*ECM-EMIN*EMIN-EMIN*EMIN)**2
     &        -(2.*EMIN*EMIN)**2)/(4.*ECM*ECM)
          PCM=SQRT(PCM2)
          RCM2=((ECM*ECM-EMQQ*EMQQ-EMH*EMH)**2
     &        -(2.*EMQQ*EMH)**2)/(4.*ECM*ECM)
          RCM=SQRT(RCM2)
          TTMAX=EMIN**2+EMQQ**2-0.5D0/ECM/ECM
     &        *((ECM*ECM+EMIN**2-EMIN**2)*(ECM*ECM+EMQQ**2-EMH**2)
     &    -SQRT((ECM*ECM-(EMIN+EMIN)**2)*(ECM*ECM-(EMIN-EMIN)**2))
     &    *SQRT((ECM*ECM-(EMQQ+EMH)**2)*(ECM*ECM-(EMQQ-EMH)**2)))
          TTMIN=EMIN**2+EMQQ**2-0.5D0/ECM/ECM
     &        *((ECM*ECM+EMIN**2-EMIN**2)*(ECM*ECM+EMQQ**2-EMH**2)
     &    +SQRT((ECM*ECM-(EMIN+EMIN)**2)*(ECM*ECM-(EMIN-EMIN)**2))
     &    *SQRT((ECM*ECM-(EMQQ+EMH)**2)*(ECM*ECM-(EMQQ-EMH)**2)))
          TLMIN=LOG(ABS(TTMAX))
          TLMAX=LOG(ABS(TTMIN))
          TL=X(2)*(TLMAX-TLMIN)+TLMIN
          T=EXP(ABS(TL))
          CTMP=-T-EMIN**2-EMQQ**2
     &       +2.*SQRT(PCM**2+EMIN**2)*SQRT(RCM**2+EMQQ**2)
          CT5=CTMP/2./PCM/RCM
          ST4=X(3)
          CT4=SQRT(1.-ST4*ST4)
          CF4=X(4)
          SF4=SQRT(1.-CF4*CF4)
        END IF
        IF(HWRLOG(HALF))THEN
          ST5=+SQRT(1.-CT5*CT5)
        ELSE
          ST5=-SQRT(1.-CT5*CT5)
        END IF
        RQ52=((ECM*ECM-EMH*EMH-EMQQ*EMQQ)**2-(2.*EMH*EMQQ)**2)/
     &     (4.*ECM*ECM)
        IF(RQ52.LT.0.)THEN
          GOTO 100
        ELSE
          RQ5=SQRT(RQ52)
        ENDIF
        P5(1)=0.
        P5(2)=RQ5*ST5
        P5(3)=RQ5*CT5
        P5(0)=SQRT(RQ52+EMH*EMH)
        DO I=1,3
          Q34(I)=-P5(I)
        END DO
        Q34(0)=SQRT(RQ52+EMQQ*EMQQ)
        RQ42=((EMQQ*EMQQ-EMQ*EMQ-ENQ*ENQ)**2-(2.*EMQ*ENQ)**2)/
     &     (4.*EMQQ*EMQQ)
        IF(RQ42.LT.0.)THEN
          GOTO 100
        ELSE
          RQ4=SQRT(RQ42)
        ENDIF
        Q4(1)=RQ4*ST4*CF4
        Q4(2)=RQ4*ST4*SF4
        Q4(3)=RQ4*CT4
        Q4(0)=SQRT(RQ42+ENQ*ENQ)
        PQ4=0.
        DO I=1,3
          PQ4=PQ4+Q34(I)*Q4(I)
        END DO
        P4(0)=(Q34(0)*Q4(0)+PQ4)/EMQQ
        P3(0)=Q34(0)-P4(0)
        DO I=1,3
          P4(I)=Q4(I)+Q34(I)*(P4(0)+Q4(0))/(Q34(0)+EMQQ)
          P3(I)=Q34(I)-P4(I)
        END DO
        IF(IMSSM.NE.0)THEN
          IF(IPROC.GE.1140)THEN
            IF(SQRT(P4(1)**2+P4(2)**2).LT.PTMIN)RETURN
          ELSE
            IF((IQ.NE.6).AND.(IQ.NE.12).AND.
     &         (JQ.NE.6).AND.(JQ.NE.12))THEN
              IF(SQRT(P3(1)**2+P3(2)**2).LT.PTMIN)RETURN
              IF(SQRT(P4(1)**2+P4(2)**2).LT.PTMIN)RETURN
            ELSE
              CONTINUE
            END IF
          END IF
        END IF
C...INITIAL STATE MOMENTA IN THE PARTONIC CM.
        PCM2=((SHAT-EMIN*EMIN-EMIN*EMIN)**2
     &         -(2.*EMIN*EMIN)**2)/(4.*SHAT)
        PCM=SQRT(PCM2)
        P1(0)=SQRT(PCM2+EMIN*EMIN)
        P1(1)=0.
        P1(2)=0.
        P1(3)=PCM
        P2(0)=SQRT(PCM2+EMIN*EMIN)
        P2(1)=0.
        P2(2)=0.
        P2(3)=-PCM
C...COLOR STRUCTURED ME SUMMED/AVERAGED OVER FINAL/INITIAL SPINS AND COLORS.
        IF(IPROC.GE.1140)THEN
          GRND=TANB
        ELSE
          IF(IMSSM.NE.0)THEN
            CONTINUE
          END IF
          GRND=ONE
        END IF
        FACGPM(1) = ENQ       *GRND
        FACGPM(2) = EMQ*PARITY/GRND
C...EW AND QCD COUPLINGS.
        EMSCA=EMQ+ENQ+EMH
        EMSC2=EMSCA*EMSCA
        ALPHA=HWUAEM(EMSC2)
        FIRST=.TRUE.
        GAUGE=.FALSE.
        E=SQRT(4.D0*PIFAC*ALPHA) 
        IF(IPROC.GE.1140)THEN
          IFL=IQ-1
          IF(IQ.EQ.7)IFL=IQ
          IF(IQ.EQ.8)IFL=IQ+1
          IF(IQ.EQ.9)IFL=IQ+2
          RM3=ENQ
          YM3=ENQ
          GAM3=0.D0
          RM4=EMQ 
          YM4=EMQ
          GAM4=GMQ
C...CHARGED HIGGSES
          Q3=-1.D0
          IF(IFL.LE.6)Q3=-1.D0/3.D0 
          JFL=0
          JH=IH
C...ASSIGN FERMION MOMENTA
          DO I=0,3
            F(I)=P4(I)  
            G(I)=P3(I)  
          END DO
        ELSE
          IFL=IQ
          IF(IQ.EQ.7)IFL=IQ
          IF(IQ.EQ.8)IFL=IQ+1
          IF(IQ.EQ.9)IFL=IQ+2
          RM3=EMQ
          YM3=EMQ
          GAM3=0.D0
          RM4=ENQ
          YM4=ENQ
          GAM4=0.D0
C...NEUTRAL HIGGSES
          IF((IFL.EQ.1).OR.(IFL.EQ.3).OR.(IFL.EQ.5 ))THEN
            Q3=-1.D0/3.D0
          ELSEIF((IFL.EQ.2).OR.(IFL.EQ.4).OR.(IFL.EQ.6 ))THEN
            Q3=+2.D0/3.D0
          ELSEIF((IFL.EQ.7).OR.(IFL.EQ.9).OR.(IFL.EQ.11))THEN
            Q3=-1.D0
          END IF 
          IF((IFL.EQ.1).OR.(IFL.EQ.3).OR.(IFL.EQ. 5).OR.
     &       (IFL.EQ.7).OR.(IFL.EQ.9).OR.(IFL.EQ.11))THEN
            JFL=1
          ELSEIF((IFL.EQ.2).OR.(IFL.EQ.4).OR.(IFL.EQ.6))THEN
            JFL=2
          END IF
          KHIGGS=IHIGGS
          IF(IHIGGS.NE.0)KHIGGS=IHIGGS-1
          JH=KHIGGS
C...ASSIGN FERMION MOMENTA
          DO I=0,3
            F(I)=P3(I)  
            G(I)=P4(I)  
          END DO
        END IF
        RM5=EMH
        GAM5=GMH
        S2W=SWEIN
        RMW=RMASS(198) 
        RMZ=RMASS(200) 
        GAMHL=HBAR/RLTIM(203)
        GAMHH=HBAR/RLTIM(204)
        GAMHA=HBAR/RLTIM(205)
        COLOUR=1.D0
        IF(IFL.LE.6)COLOUR=3.D0
C...MSSM COUPLINGS.
        IF(JH.LE.3)THEN
          HFC=ENHANC(IQ)
          HBC=ENHANC(10)
        ELSE
          HFC=ONE
          HBC=ONE
        END IF
C...ME.
        CALL HWH2HE(FIRST,GAUGE,JFL,JH,HFC,HBC,
     &     E,S2W,TANB,ALPHAH,RMW,S,Q3,F,G,P5,
     &     RM3,YM3,GAM3,RM4,YM4,GAM4,RM5,GAM5,
     &     RMHL,GAMHL,RMHH,GAMHH,RMHA,GAMHA,
     &     RMZ,GAMZ,COLOUR,M2EE)
C...CONSTANT FACTORS: PHI ALONG BEAM AND CONVERSION GEV^2->NB.
        FACT=2.*PIFAC*GEV2NB
C...PHASE SPACE JACOBIANS, PI'S AND FLUX.
        FACT=FACT*RQ4*RQ5/PCM/32./(2.*PIFAC)**5
     &      *((ECM-EMH)**2-(EMQ+ENQ)**2)
     &      /2./EMQQ/S
C...JACOBIANS FROM CT5 TO X(2).
        IF((IQ+JQ).EQ.18)THEN
          CONTINUE
        ELSE
          FACT=FACT*(TLMAX-TLMIN)/2./PCM/RCM*ABS(T)
          FACT=FACT*2.*ABS(ST4/CT4/SF4)
        END IF
C...CHARGE CONJUGATION.
        IF(IPROC.GE.1140)THEN
C...YES FOR CHARGED HIGGS.
          FACT=FACT*2.
        ELSE
C...NO FOR NEUTRAL HIGGSES.
          CONTINUE
        END IF
C...HIGGS RESONANCE.
        FACT=FACT*EMHWT
C...CONSTANT WEIGHT.
        FACT=FACT*WEIGHT
C...INCLUDE BR OF HIGGS.
        IF(IMSSM.EQ.0)THEN
          IDEC=MOD(IPROC,100)
          IF (IDEC.GT.0.AND.IDEC.LE.12) FACT=FACT*BRHIG(IDEC)
          IF (IDEC.EQ.0) THEN
            BRHIGQ=0.D0
            DO I=1,6
              BRHIGQ=BRHIGQ+BRHIG(I)
            END DO
            FACT=FACT*BRHIGQ
          ENDIF
          IF (IDEC.EQ.10) THEN
            CALL HWDBOZ(198,ID1,ID2,CV,CA,BR,1)
            CALL HWDBOZ(199,ID1,ID2,CV,CA,BR,1)
            FACT=FACT*BR
          ELSEIF (IDEC.EQ.11) THEN
            CALL HWDBOZ(200,ID1,ID2,CV,CA,BR,1)
            CALL HWDBOZ(200,ID1,ID2,CV,CA,BR,1)
            FACT=FACT*BR
          ENDIF
        END IF
      END IF
C...SET UP FLAVOURS IN FINAL STATE.
      IF(IPROC.GE.1140)THEN
        IF(HWRGEN(0).LT.0.5)THEN
          JHIGGS=207-201
          IIQ=IQ
          JJQ=JQ
          FLIP=0
        ELSE
          JHIGGS=206-201
          IIQ=IQ-1
          JJQ=JQ+1
          FLIP=1
        END IF
      ELSE
        JHIGGS=IHIGGS
        IIQ=IQ
        JJQ=JQ
        FLIP=0
      END IF
      HCS=FACT*M2EE
      IF (GENEV.AND.HCS.GT.RCS) THEN
C...GENERATE EVENT.
        IDN(1)=IDHW(1)
        IDN(2)=IDHW(2)
        IF(IIQ.LE.12.AND.JJQ.LE.12)THEN
          IDN(3)=IIQ
          IDN(4)=JJQ
        ELSE
          IDN(3)=2*IIQ-7+114
          IDN(4)=2*IIQ-7+114+IAD
        END IF
        IDN(5)=201+JHIGGS
C...INCOMING PARTONS: NOW MASSIVE.
        EMIN1=RMASS(IDN(1))
        EMIN2=RMASS(IDN(2))
C...REDO INITIAL STATE MOMENTA IN THE PARTONIC CM.
        PCM2=((SHAT-EMIN1*EMIN1-EMIN2*EMIN2)**2
     &         -(2.*EMIN1*EMIN2)**2)/(4.*SHAT)
        PCM=SQRT(PCM2)
        P1(0)=SQRT(PCM2+EMIN1*EMIN1)
        P1(1)=0.
        P1(2)=0.
        P1(3)=PCM
        P2(0)=SQRT(PCM2+EMIN2*EMIN2)
        P2(1)=0.
        P2(2)=0.
        P2(3)=-PCM
C...SETS UP INCOMING STATUS AND IDS ONLY FOR 2->1: USE HWEONE.
        IDCMF=15
        XX(1)=ONE
        XX(2)=ONE
        CALL HWEONE
        JDAHEP(1,NHEP  )=NHEP+1
        JDAHEP(2,NHEP  )=NHEP+3
        JMOHEP(1,NHEP+1)=NHEP
        JMOHEP(1,NHEP+2)=NHEP
        JMOHEP(1,NHEP+3)=NHEP
C...RANDOMLY ROTATE FINAL STATE MOMENTA AROUND BEAM AXIS.
        PHI=2.*PIFAC*HWRGEN(0)
        CPHI=COS(PHI)
        SPHI=SIN(PHI)
        ROT(1,1)=+CPHI
        ROT(1,2)=+SPHI
        ROT(1,3)=0.
        ROT(2,1)=-SPHI
        ROT(2,2)=+CPHI
        ROT(2,3)=0.
        ROT(3,1)=0.
        ROT(3,2)=0.
        ROT(3,3)=1.
        DO L=1,3
          DO M=1,3
            QAUX(M)=0.
            DO N=1,3
              IF(L.EQ.1)QAUX(M)=QAUX(M)+ROT(M,N)*P3(N)
              IF(L.EQ.2)QAUX(M)=QAUX(M)+ROT(M,N)*P4(N)
              IF(L.EQ.3)QAUX(M)=QAUX(M)+ROT(M,N)*P5(N)
            END DO
          END DO
          DO M=1,3
            IF(L.EQ.1)P3(M)=QAUX(M)
            IF(L.EQ.2)P4(M)=QAUX(M)
            IF(L.EQ.3)P5(M)=QAUX(M)
          END DO
        END DO
C...DO REAL INCOMING, OUTGOING MOMENTA IN THE LAB FRAME.
        DO M=NHEP-2,NHEP+3
          IF(M.EQ.NHEP  )GO TO 888
          DO N=0,3
            NN=N
            IF(N.EQ.0)NN=4 
            IF(M.EQ.NHEP-2)PHEP(NN,M)=P1(N)
            IF(M.EQ.NHEP-1)PHEP(NN,M)=P2(N)
            IF(M.EQ.NHEP+1)PHEP(NN,M)=P3(N)*(1-FLIP)+P4(N)*FLIP
            IF(M.EQ.NHEP+2)PHEP(NN,M)=P4(N)*(1-FLIP)+P3(N)*FLIP
            IF(M.EQ.NHEP+3)PHEP(NN,M)=P5(N)
          END DO
 888      CONTINUE
        END DO
C...NEEDS TO SET ALL FINAL STATE MASSES.
        PHEP(5,NHEP+1)=SQRT(ABS(PHEP(4,NHEP+1)**2
     &                         -PHEP(3,NHEP+1)**2
     &                         -PHEP(2,NHEP+1)**2
     &                         -PHEP(1,NHEP+1)**2))
        PHEP(5,NHEP+2)=SQRT(ABS(PHEP(4,NHEP+2)**2
     &                         -PHEP(3,NHEP+2)**2
     &                         -PHEP(2,NHEP+2)**2
     &                         -PHEP(1,NHEP+2)**2))
        PHEP(5,NHEP+3)=SQRT(ABS(PHEP(4,NHEP+3)**2
     &                         -PHEP(3,NHEP+3)**2
     &                         -PHEP(2,NHEP+3)**2
     &                         -PHEP(1,NHEP+3)**2))
C...SETS CMF.
        DO I=1,4
          PHEP(I,NHEP  )=PHEP(I,NHEP-2)+PHEP(I,NHEP-1)
        END DO
        PHEP(5,NHEP  )=SQRT(ABS(PHEP(4,NHEP  )**2
     &                         -PHEP(3,NHEP  )**2
     &                         -PHEP(2,NHEP  )**2
     &                         -PHEP(1,NHEP  )**2))
C...SETS UP OUTGOING STATUS AND IDS.
        ISTHEP(NHEP+1)=113
        ISTHEP(NHEP+2)=114
        ISTHEP(NHEP+3)=114
        IDHW(NHEP+1)=IDN(3)
        IDHEP(NHEP+1)=IDPDG(IDN(3))
        IDHW(NHEP+2)=IDN(4)
        IDHEP(NHEP+2)=IDPDG(IDN(4))
        IDHW(NHEP+3)=IDN(5)
        IDHEP(NHEP+3)=IDPDG(IDN(5))
C...SETS UP COLOUR CONNECTIONS.
        JMOHEP(2,NHEP+1)=NHEP+2
        JMOHEP(2,NHEP+2)=NHEP+1
        JMOHEP(2,NHEP-1)=NHEP-2
        JMOHEP(2,NHEP-2)=NHEP-1
        JMOHEP(2,NHEP+3)=NHEP+3
        JDAHEP(2,NHEP+1)=NHEP+2
        JDAHEP(2,NHEP+2)=NHEP+1
        JDAHEP(2,NHEP-1)=NHEP-1
        JDAHEP(2,NHEP-2)=NHEP-2
        JDAHEP(2,NHEP+3)=NHEP+3
        NHEP=NHEP+3
        IF(AZSPIN)THEN
C...SET TO ZERO THE COEFFICIENTS OF THE SPIN DENSITY MATRICES.
          CALL HWVZRO(7,GCOEF)
        END IF
      END IF
C...COLLECT WEIGHT.
      EVWGT=HCS
      RETURN
  999 END
CDECK  ID>, HWHIGH.
*CMZ :-        -26/11/00  17.21.55  by  Bryan Webber
*-- Author :  Kosuke Odagiri & Stefano Moretti
C-----------------------------------------------------------------------
C...Generate completely differential cross section (EVWGT) in the variables
C...X(I) with I=1,3 (see below) for the processes IPROC=3315,3325,3335,3355,
C...3365,3375 as described in the HERWIG 6 documentation file.
C...It includes interface to PDFs and takes into account color connections
C...among partons.
C
C...First release:  16-AUG-1999 by Kosuke Odagiri
C...Last modified:  26-SEP-1999 by Stefano Moretti
C-----------------------------------------------------------------------
      SUBROUTINE HWHIGH
C-----------------------------------------------------------------------
C     DRELL-YAN 2 PARTON -> 2 HIGGS PAIR (2HDM)
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION HWRGEN, HWUAEM, EPS, HCS, RCS, DIST, S, PF, QPE,
     & FACTR, SN2TH, MZ, MW, MNN(2,2), MCC(2), MCN(3), EMSC2, GW2, GZ2,
     & GHH(4), XWEIN, S2W, PT2MIN, ECM_MAX, X(3), XL(3),
     & XU(3), WEIGHT, ECM, SHAT, TAU, RMH1, RMH2, EMH1, EMH2,
     & EMHWT1, EMHWT2, EMHHWT
      INTEGER I, J, IQ, IQ1, IQ2, ID1, ID2, IH, JH, IH1, IH2
      EXTERNAL HWRGEN, HWUAEM
      SAVE HCS,MNN,MCC,MCN,EMHHWT,S,SHAT
      PARAMETER (EPS = 1.D-9)
      DOUBLE COMPLEX Z, GZ, A, D, E
      PARAMETER (Z = (0.D0,1.D0))
      EQUIVALENCE (MZ, RMASS(200)), (MW, RMASS(198))
C...process event.
      IF (GENEV) THEN
        RCS = HCS*HWRGEN(0)
      ELSE
        HCS = ZERO
        EVWGT = ZERO
C...minimum transverse momentum.
        PTMIN = ZERO
        PT2MIN = PTMIN**2
C...energy at hadron level.
        ECM_MAX=PBEAM1+PBEAM2
        S=ECM_MAX*ECM_MAX
C...phase space variables.
C...X(1)=COS(THETA_CM),
C...X(2)=(1./SHAT-1./ECM_MAX**2)/(1./(EMH1+EMH2)**2-1./ECM_MAX**2),
C...X(3)=(LOG(TAU)-LOG(X1))/LOG(TAU),
C...phase space borders.
        XL(1)=-1.
        XU(1)=1.
        XL(2)=0.
        XU(2)=1.
        XL(3)=0.
        XU(3)=1.
C...single phase space point.
 100    CONTINUE
        WEIGHT=1.
        DO I=1,3
          X(I)=XL(I)+(XU(I)-XL(I))*HWRGEN(0)
          WEIGHT=WEIGHT*ABS(XU(I)-XL(I))
        END DO
C...final state masses.
        IF((MOD(IPROC,10000).EQ.3365).OR.
     &     (MOD(IPROC,10000).EQ.3375))THEN
          JH  = IHIGGS-1
          ID1 = 205
          ID2 = 202 + JH
        ELSE IF(MOD(IPROC,10000).EQ.3355)THEN
          JH  = 4
          ID1 = 206
          ID2 = 207
        ELSE IF((MOD(IPROC,10000).EQ.3315).OR.
     &          (MOD(IPROC,10000).EQ.3325).OR.
     &          (MOD(IPROC,10000).EQ.3335))THEN
          JH  = IHIGGS-1
          ID1 = 206
          ID2 = 202 + JH
        END IF
        RMH1=RMASS(ID1)
        RMH2=RMASS(ID2)
        EMH1=RMH1
        EMH2=RMH2
        EMHWT1=1.
        EMHWT2=1.
        EMHHWT=EMHWT1*EMHWT2
C...energy at parton level.
        ECM=SQRT(1./(X(2)*(1./(EMH1+EMH2)**2-1./ECM_MAX**2)
     &                                      +1./ECM_MAX**2))
        IF((EMH1.LE.0.).OR.(EMH1.GE.ECM))RETURN
        IF((EMH2.LE.0.).OR.(EMH2.GE.ECM))RETURN
        SHAT=ECM*ECM
        TAU=SHAT/S
C...momentum fractions X1 and X2.
        XX(1) = EXP(LOG(TAU)*(1.-X(3)))
        XX(2) = TAU/XX(1)
        COSTH = X(1)
        SN2TH = 0.25D0 - 0.25D0*COSTH**2
        EMSCA = EMH1+EMH2
        EMSC2 = EMSCA*EMSCA
        CALL    HWSGEN(.FALSE.)
        EVWGT = ZERO
        FACTR = GEV2NB*PIFAC*(HWUAEM(EMSC2))**2/SHAT/CAFAC*SN2TH/2.
C...Jacobians from X1,X2 to X(2),X(3).
        FACTR = FACTR/S*(-LOG(TAU))*(1./(EMH1+EMH2)**2-1./ECM_MAX**2)
C...constant weight.
        FACTR = FACTR*WEIGHT
C...couplings and propagators.
        XWEIN = TWO*SWEIN
        S2W   = DSQRT(XWEIN*(TWO-XWEIN))
        GZ    = S2W*(SHAT-MZ**2+Z*SHAT*GAMZ/MZ)/SHAT
        GZ2   = DREAL(DCONJG(GZ)*GZ)
        GW2   = ((ONE-MW**2/SHAT)**2+(GAMW/MW)**2)*XWEIN**2
C...labels: 1 = h0, 2 = H0, 3 = A0, 4 = H+, 5 = H-.
        GHH(1)= COSBMA
        GHH(2)= SINBMA
        GHH(3)= ONE
        GHH(4)= ONE-XWEIN
C...set to zero all MEs.
        DO I=1,2
          MCC(I)=ZERO
          MCN(I)=ZERO
          DO J=1,2
            MNN(I,J)=ZERO
          END DO
        END DO
        MCN(3)=ZERO
C...start subprocesses.
        IF((MOD(IPROC,10000).EQ.3365).OR.
     &     (MOD(IPROC,10000).EQ.3375))THEN
c
c      _      o  o   o
c    q q  -> A  h / H
c
          DO IH = JH,JH
            QPE = SHAT-(EMH1+EMH2)**2
            IF (QPE.GT.ZERO) THEN
              PF = SQRT(QPE*(SHAT-(EMH1-EMH2)**2))/SHAT
              DO IQ = 1,2
                MNN(IH,IQ) =
     &          FACTR*PF**3*GHH(IH)**2*(LFCH(IQ)**2+RFCH(IQ)**2)/GZ2
              END DO
            ELSE
              CONTINUE
            END IF
          END DO
        ELSE IF(MOD(IPROC,10000).EQ.3355)THEN
c
c      _      +  -
c    q q  -> H  H
c
          IH = JH
          QPE = SHAT-(EMH1+EMH2)**2
          IF (QPE.GT.ZERO) THEN
            PF = SQRT(QPE*(SHAT-(EMH1-EMH2)**2))/SHAT
            DO IQ = 1,2
              A = GHH(IH)/GZ
              D = QFCH(IQ)+A*LFCH(IQ)
              E = QFCH(IQ)+A*RFCH(IQ)
              MCC(IQ)=FACTR*PF**3*DREAL(DCONJG(D)*D+DCONJG(E)*E)
            END DO
          ELSE
            CONTINUE
          END IF
        ELSE IF((MOD(IPROC,10000).EQ.3315).OR.
     &          (MOD(IPROC,10000).EQ.3325).OR.
     &          (MOD(IPROC,10000).EQ.3335))THEN
c
c      _      +-  o   o   o
c    q q' -> H   h / H / A
c
          DO IH = JH,JH
            QPE = SHAT-(EMH1+EMH2)**2
            IF (QPE.GT.ZERO) THEN
              PF = SQRT(QPE*(SHAT-(EMH1-EMH2)**2))/SHAT
              MCN(IH)=FACTR*PF**3/GW2*HALF*GHH(IH)**2
            ELSE
              CONTINUE
            END IF
          END DO
        END IF
      END IF
      HCS = 0.D0
C...start PDFs.
      DO 1 ID1 = 1, 12
       IF (DISF(ID1,1).LT.EPS) GOTO 1
       IF (ID1.GT.6) THEN
        ID2 = ID1 - 6
       ELSE
        ID2 = ID1 + 6
       END IF
       IQ  = ID1 - ((ID1-1)/2)*2
       IF (DISF(ID2,2).LT.EPS) GOTO 1
       DIST = DISF(ID1,1)*DISF(ID2,2)*S*SHAT
       IH1 = 205
       IH2 = 203
       HCS = HCS + DIST*EMHHWT*MNN(1,IQ)
       IF (GENEV.AND.HCS.GT.RCS) CALL HWHQCP(IH1,IH2,2134,1,*9)
       IH2 = 204
       HCS = HCS + DIST*EMHHWT*MNN(2,IQ)
       IF (GENEV.AND.HCS.GT.RCS) CALL HWHQCP(IH1,IH2,2134,2,*9)
       IH1 = 206
       IH2 = 207
       HCS = HCS + DIST*EMHHWT*MCC(IQ)
       IF (GENEV.AND.HCS.GT.RCS) CALL HWHQCP(IH1,IH2,2134,3,*9)
    1 CONTINUE
c      _     _       _     _
c     ud(+), ud(-), du(-), du(+)
c
      DO 2 IQ1 = 1, 3
      DO IQ2 = 1, 3
      IF(VCKM(IQ1,IQ2).GT.EPS) THEN
c      _
c     ud (+)
c
       ID1 = IQ1 * 2
       ID2 = IQ2 * 2 + 5
       IH1 = 206
       IF ((DISF(ID1,1).GT.EPS).AND.(DISF(ID2,2).GT.EPS)) THEN
        DIST = VCKM(IQ1,IQ2)*DISF(ID1,1)*DISF(ID2,2)*S*SHAT
        DO IH = 1,3
         IH2 = 202+IH
         HCS = HCS + DIST*EMHHWT*MCN(IH)
         IF (GENEV.AND.HCS.GT.RCS) CALL HWHQCP(IH1,IH2,2134,3+IH,*9)
        END DO
       END IF
c     _
c     du (+)
c
       ID1 = IQ2 * 2 + 5
       ID2 = IQ1 * 2
       IH1 = 206
       IF ((DISF(ID1,1).GT.EPS).AND.(DISF(ID2,2).GT.EPS)) THEN
        DIST = VCKM(IQ1,IQ2)*DISF(ID1,1)*DISF(ID2,2)*S*SHAT
        DO IH = 1,3
         IH2 = 202+IH
         HCS = HCS + DIST*EMHHWT*MCN(IH)
         IF (GENEV.AND.HCS.GT.RCS) CALL HWHQCP(IH1,IH2,2134,3+IH,*9)
        END DO
       END IF
c      _
c     du (-)
c
       ID1 = IQ2 * 2 - 1
       ID2 = IQ1 * 2 + 6
       IH1 = 207
       IF ((DISF(ID1,1).GT.EPS).AND.(DISF(ID2,2).GT.EPS)) THEN
        DIST = VCKM(IQ1,IQ2)*DISF(ID1,1)*DISF(ID2,2)*S*SHAT
        DO IH = 1,3
         IH2 = 202+IH
         HCS = HCS + DIST*EMHHWT*MCN(IH)
         IF (GENEV.AND.HCS.GT.RCS) CALL HWHQCP(IH1,IH2,2134,3+IH,*9)
        END DO
       END IF
c     _
c     ud (-)
c
       ID1 = IQ1 * 2 + 6
       ID2 = IQ2 * 2 - 1
       IH1 = 207
       IF ((DISF(ID1,1).GT.EPS).AND.(DISF(ID2,2).GT.EPS)) THEN
        DIST = VCKM(IQ1,IQ2)*DISF(ID1,1)*DISF(ID2,2)*S*SHAT
        DO IH = 1,3
         IH2 = 202+IH
         HCS = HCS + DIST*EMHHWT*MCN(IH)
         IF (GENEV.AND.HCS.GT.RCS) CALL HWHQCP(IH1,IH2,2134,3+IH,*9)
        END DO
       END IF
      END IF
      END DO
    2 CONTINUE
      EVWGT = HCS
      RETURN
C...generate event.
    9 IDN(1)=ID1
      IDN(2)=ID2
      IDCMF=15
      CALL HWETWO
      IF (AZSPIN) THEN
        CALL HWVZRO(7,GCOEF)
      END IF
      END
