
       SUBROUTINE runmcarlo(IRUN, ierr)

C run ARIADNE model based on lepto for DIS mode  
C from C++ interface 
C      IRUN=1 - initialize
C      IRUN=2 - run
C      IRUN=3 - terminate
C      ierr- no errors, event accepted 
C      written by S.Chekanov, May, 2003


       include "../mcarlo/inc/jetset74.inc"
       include "../mcarlo/inc/lepto65.inc"
       include "../mcarlo/inc/ariadne4.inc"
       include "../inc/hepevt_pythia57.inc"
       include "../inc/getevkin.inc"
       include "../inc/getseeds.inc"

       Integer I, J, N, nev, IPOSI
       Real pbeam(4), ebeam(4) 
       Integer IRUN,ierr,IPAR
       Save nev 



      goto (1000, 2000, 3000) IRUN
      return

*      IF (IRUN.eq.0) GOTO 100
*      IF (IRUN.eq.1) GOTO 200
*      IF (IRUN.eq.2) GOTO 300

 1000   CONTINUE 


      write(6,*) 'initialize RUNMC-lepto-ariadne'


       CALL LUGIVE('PARJ(72)=1000') ! mm maximum distance from the origin at
                     ! a decay is allowed to take place
       CALL LUGIVE('MSTJ(22)=3')  ! particle is decayed only if the decay vertex is
                     ! within a distance PARJ(72) of the origin
       write(6,*)PARJ(72),'mm maximum distance a decay is allowed'


C set seed number
      MRLU(1)=RUNMCseed1+RUNMCseed2
      write(6,*) "LEPTO-ARIADNE: new seed for this run = ",MRLU(1)


C...Initialize parameters in Ariadne and Jetset
      CALL ARTUNE('4.11')


*-take positron (default) 
       IPOSI=-11
       nev=0
       ierr=1
       xCross=0.
       eCross=0.
       CUT(1)=rXbj(2)  ! min X
       CUT(2)=rXbj(3)  ! max X
       CUT(3)=rYbj(2)  ! min Y 
       CUT(4)=rYbj(3)  ! max Y 
       CUT(5)=rQ2(2)  ! min Q2
       CUT(6)=rQ2(3)  ! max Q2
C       CUT(7)=rW(2)*rW(2)  ! min W 
C       CUT(8)=rW(3)*rW(2)  ! max W


        MSTU(11)=6
        LST(16)=2
        LST(18)=4
        IF (PDF1.eq.1.or.PDF2.eq.1)  LST(15)=10150 ! CTEQ61 (central value)
        IF (PDF1.eq.2.or.PDF2.eq.2)  LST(15)=20450 ! MRST2004FF4lo
        IF (PDF1.eq.3.or.PDF2.eq.3)  LST(15)=80051 ! GRV 98 NLO

        
* redefine initial lepton  
        IF (abs(PID1).le.14) THEN
             IPOSI=PID1
             ebeam(1)=0.
             ebeam(2)=0.
             ebeam(3)=-1*ENER1
             ebeam(4)=ENER1
           pbeam(1)=0.
           pbeam(2)=0.
           pbeam(3)=ENER2
           pbeam(4)=ENER2
         ENDIF
 
       IF (abs(PID2).le.14) THEN
             IPOSI=PID2
             ebeam(1)=0.
             ebeam(2)=0.
             ebeam(3)=-1*ENER2
             ebeam(4)=ENER2
           pbeam(1)=0.
           pbeam(2)=0.
           pbeam(3)=ENER1
           pbeam(4)=ENER1
         ENDIF


C...Suppress printouts from LEPTO
      LST(3)=1

C...Initialize Ariadne to run with LEPTO
      CALL ARINIT('LEPTO')

C...the parameters and switches in Ariadne
       MSTA(6)=1 


C set parameters via cards
       Call RunMC_Steer("arlepto.cards")
       Call RUNMCleptoariadnesteer

C set user initialisation
       CALL setLEPTOARIADNE


C...Initialize LEPTO for HERA
       CALL LINIT(0,IPOSI,ebeam(3),pbeam(3),4)

       write(6,*) ' FINISH INITIALIZATION'

      RETURN

 2000  CONTINUE  ! RUN 
************* Physical study *************** 

C...Call generate an event with LEPTO
        CALL LEPTO
        IF (LST(21).ne.0) THEN
         NHEP=-1
         goto 9999
        ENDIF

C...Apply the Dipole Cascade
        CALL AREXEC


        nev=nev+1
C copy kinematic varaibles
        ierr=0        
        rQ2(1)=Q2
        rXbj(1)=X
        rYbj(1)=Y 
        rW(1)=sqrt(W2)
          
C.. convert from JETSET common
        CALL LUHEPC(1)
C...Call a user supplied analysis routine
        if (nev.le.5)  CALL LULIST(1) 


 9999  Continue
* end of loop >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      RETURN


 3000 CONTINUE

      xCross=PARL(24)
      eCross=0
      write(6,*) 'RUNMC-lepto-ariadne: Cross section in pb',PARL(24)
      write(6,*) 'RUNMC-lepto-ariadne: ALL done!'

      RETURN      
      END  
 
