C
C
      SUBROUTINE EIKON(IP,B)
C*********************************************************************
C
C     calculation of unitarized amplitudes
C
C     input: IP               particle combination
C            B                impact parameter (mb**(1/2))
C            COMMON /SIGMAS/  input cross sections
C                   /GLOCMS/  cm energy
C                   /REGGE/   soft and hard parameters
C
C     output: COMMON /AMPLIT/
C             AMPEL           purely elastic amplitude
C             AMPVM           quasi-elastically vectormeson prod.
C             AMLMSD(2)       amplitudes of low mass sing. diffr.
C             AMHMSD(2)       amplitudes of high mass sing. diffr.
C             AMLMDD          amplitude of low mass double diffr.
C             AMHMDD          amplitude of high mass double diffr.
C
C*********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C  output common block
      COMPLEX*16      AMPEL,AMPVM,AMPSOF,AMPHAR,AMLMSD,AMHMSD,AMLMDD,
     &                AMHMDD,AMPDP,AMPD1,AMPD2
      COMMON /AMPLIT/ AMPEL,AMPVM(4,4),AMPSOF,AMPHAR,AMLMSD(2),
     &                AMHMSD(2),AMLMDD,AMHMDD,AMPDP,AMPD1,AMPD2
C
      PARAMETER ( MAXPRO = 16 )
      COMMON /XSECTP/ SIGTOT,SIGELA,SIGVM(0:4,0:4),SIGINE,SIGDIR,
     &                SIGLSD(2),SIGHSD(2),SIGLDD,SIGHDD,SIGCDF,
     &                SIGPOM,SIGREG,SIGHAR,SIGTR1,SIGTR2,SIGLOO,SIGDPO,
     &                SIG1SO,SIG1HA,SLOEL,SLOVM(4,4),SIGGEN(4),
     &                FSUP(2)
      COMPLEX*16      SIGP,SIGR,SIGHD,SIGHR,SIGT1,SIGT2,SIGL,SIGDP,
     &                SIGD1,SIGD2,DSIGH
      COMMON /SIGMAS/ SIGP,SIGR,SIGHD,SIGHR,SIGT1(2),SIGT2(2),SIGL,
     &                SIGDP(4),SIGD1(2),SIGD2(2),DSIGH(0:MAXPRO)
      COMPLEX*16      ZIGP,ZIGR,ZIGHD,ZIGHR,ZIGT1,ZIGT2,ZIGL,ZIGDP,
     &                ZIGD1,ZIGD2,
     &                BPOM,BREG,BHAR,BHAD,BTR1,BTR2,BLOO,BDP,BD1,BD2
      COMMON /ZIGMAS/ ZIGP,ZIGR,ZIGHD,ZIGHR,ZIGT1(2),ZIGT2(2),ZIGL,
     &                ZIGDP(4),ZIGD1(2),ZIGD2(2),
     &                BPOM,BREG,BHAR,BHAD,BTR1(2),BTR2(2),BLOO,BDP(4),
     &                BD1(2),BD2(2)
C  global CM system
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
C  CM system of Pomeron/Reggeon exchange
      COMMON /POMCMS/ ECMP,PCMP,PMASSP(2),PVIRTP(2),GAMBEP(4),
     &                SIDP,CODP,SIFP,COFP,NPOSP(2),
     &                IDPDG1,IDBAM1,IDPDG2,IDBAM2
C
      COMMON /REGGE/  ALPOM,ALPOMP,GP(2),B0POM(2),
     &                ALREG,ALREGP,GR(2),B0REG(2),
     &                GPPP,GPPR,B0PPP,B0PPR,
     &                VDMFAC(4),VDMQ2F(4),B0HAR,AKFAC
      COMMON /TWOCHA/ PHISUP(2),RMASS1,RMASS2,VAR
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
      COMMON /FITMOD/ IFMOD,IFHARD
C
      COMPLEX*16      CZERO,CONE,B24,AUXP,AUXR,AUXH,AUXD,AUXT1,AUXT2,
     &                AUXL,AMPR,AMPO,AMPP,AMPQ
C
      PARAMETER(ZERO=0.D0,
     &         IZERO=0,
     &          IONE=1,
     &          ITWO=2,
     &        ITHREE=3,
     &         IFOUR=4,
     &         IFIVE=5,
     &          ISIX=6,
     &         OHALF=0.5D0,
     &           ONE=1.D0,
     &           TWO=2.D0,
     &         THREE=3.D0,
     &          FOUR=4.D0,
     &          FIVE=5.D0,
     &         THOUS=1.D3,
     &        EXPMAX=70.D0,
     &          DEPS=1.D-20)
C
      PARAMETER(MDIM=5)
      COMMON /ZXEIKS/ XM(MDIM,MDIM),XOUT(MDIM,MDIM),
     &                XIN(MDIM),XOU(MDIM),
     &                ZXP(MDIM,MDIM),BXP(MDIM,MDIM),
     &                ZXR(MDIM,MDIM),BXR(MDIM,MDIM),
     &                ZXH(MDIM,MDIM),BXH(MDIM,MDIM),
     &                ZXD(MDIM,MDIM),BXD(MDIM,MDIM),
     &                ZXT1A(MDIM,MDIM),BXT1A(MDIM,MDIM),
     &                ZXT1B(MDIM,MDIM),BXT1B(MDIM,MDIM),
     &                ZXT2A(MDIM,MDIM),BXT2A(MDIM,MDIM),
     &                ZXT2B(MDIM,MDIM),BXT2B(MDIM,MDIM),
     &                ZXL(MDIM,MDIM),BXL(MDIM,MDIM),
     &                ZXDP(MDIM,MDIM),BXDP(MDIM,MDIM),
     &                ZXD1A(MDIM,MDIM),BXD1A(MDIM,MDIM),
     &                ZXD1B(MDIM,MDIM),BXD1B(MDIM,MDIM),
     &                ZXD2A(MDIM,MDIM),BXD2A(MDIM,MDIM),
     &                ZXD2B(MDIM,MDIM),BXD2B(MDIM,MDIM)
C
      DIMENSION PVOLD(2)
      DATA  ELAST / 0.D0 /
      DATA  IPOLD / -1 /
      DATA  PVOLD / -1.D0, -1.D0 /
      DATA  XMPOM / 0.766D0 /
      DATA  XMVDM / 0.766D0 /
C
      DCMPLX(X,Y) = CMPLX(X,Y)
C
C  calculation of ZIGmas and slopes
C
C  test for redundant calculation
      IF((ECM.NE.ELAST).OR.(PVIRT(1).NE.PVOLD(1))
     &   .OR.(PVIRT(2).NE.PVOLD(2)).OR.(IP.NE.IPOLD)) THEN
C  effective particle masses, VDM assumption
        XMASS1 = PMASS(1)
        XMASS2 = PMASS(2)
        IF(IFPAP(1).EQ.22) THEN
          XMASS1 = XMVDM
        ELSE IF(IFPAP(1).EQ.45) THEN
          XMASS1 = XMPOM
        ENDIF
        IF(IFPAP(2).EQ.22) THEN
          XMASS2 = XMVDM
        ELSE IF(IFPAP(2).EQ.45) THEN
          XMASS2 = XMPOM
        ENDIF
        IF(IP.EQ.2) THEN
          XMASS2 = XMPOM 
        ELSE IF(IP.EQ.3) THEN
          XMASS2 = XMPOM
        ELSE
          XMASS1 = XMPOM
          XMASS2 = XMPOM
        ENDIF
        PMASSP(1) = XMASS1
        PMASSP(2) = XMASS2
        ECMP = ECM
C
        CZERO    = DCMPLX(ZERO,ZERO)
        CONE     = DCMPLX(ONE,ZERO)
        ELAST    = ECM
        PVOLD(1) = PVIRT(1)
        PVOLD(2) = PVIRT(2)
        IPOLD    = IP
C
C  pure elastic scattering
        CALL INPCS(IP,XMASS1,XMASS2,XMASS1,XMASS2)
          ZXP(1,1) = ZIGP
          BXP(1,1) = BPOM
          ZXR(1,1) = ZIGR
          BXR(1,1) = BREG
          ZXH(1,1) = ZIGHR
          BXH(1,1) = BHAR
          ZXD(1,1) = ZIGHD
          BXD(1,1) = BHAD
          ZXT1A(1,1) = ZIGT1(1)
          BXT1A(1,1) = BTR1(1)
          ZXT1B(1,1) = ZIGT1(2)
          BXT1B(1,1) = BTR1(2)
          ZXT2A(1,1) = ZIGT2(1)
          BXT2A(1,1) = BTR2(1)
          ZXT2B(1,1) = ZIGT2(2)
          BXT2B(1,1) = BTR2(2)
          ZXL(1,1) = ZIGL
          BXL(1,1) = BLOO
          ZXDP(1,1) = ZIGDP(1)+ZIGDP(2)+ZIGDP(3)+ZIGDP(4)
          BXDP(1,1) = (BDP(1)+BDP(2)+BDP(3)+BDP(4))/FOUR
C  Born-graph cross sections
          SIGPOM = SIGP
          SIGREG = SIGR
          SIGTR1 = SIGT1(1)+SIGT1(2)
          SIGTR2 = SIGT2(1)+SIGT2(2)
          SIGLOO = SIGL
          SIGDPO = SIGDP(1)+SIGDP(2)+SIGDP(3)+SIGDP(4)
C
C  avoid further hard cross section calculation
        ITMP = IFHARD
        IFHARD = 1
C
        IF(ISWMDL(1).EQ.2) THEN
C
C  pure elastic scattering of low mass resonance 1
          CALL INPCS(IP,RMASS1,XMASS2,RMASS1,XMASS2)
            ZXP(2,2) = ZIGP
            BXP(2,2) = BPOM
            ZXR(2,2) = ZIGR
            BXR(2,2) = BREG
            ZXH(2,2) = ZIGHR
            BXH(2,2) = BHAR
            ZXD(2,2) = ZIGHD
            BXD(2,2) = BHAD
            ZXT1A(2,2) = ZIGT1(1)
            BXT1A(2,2) = BTR1(1)
            ZXT1B(2,2) = ZIGT1(2)
            BXT1B(2,2) = BTR1(2)
            ZXT2A(2,2) = ZIGT2(1)
            BXT2A(2,2) = BTR2(1)
            ZXT2B(2,2) = ZIGT2(2)
            BXT2B(2,2) = BTR2(2)
            ZXL(2,2) = ZIGL
            BXL(2,2) = BLOO
            ZXDP(2,2) = ZIGDP(1)+ZIGDP(2)+ZIGDP(3)+ZIGDP(4)
            BXDP(2,2) = (BDP(1)+BDP(2)+BDP(3)+BDP(4))/FOUR
C
C  pure elastic scattering of low mass resonance 2
          CALL INPCS(IP,XMASS1,RMASS2,XMASS1,RMASS2)
            ZXP(3,3) = ZIGP
            BXP(3,3) = BPOM
            ZXR(3,3) = ZIGR
            BXR(3,3) = BREG
            ZXH(3,3) = ZIGHR
            BXH(3,3) = BHAR
            ZXD(3,3) = ZIGHD
            BXD(3,3) = BHAD
            ZXT1A(3,3) = ZIGT1(1)
            BXT1A(3,3) = BTR1(1)
            ZXT1B(3,3) = ZIGT1(2)
            BXT1B(3,3) = BTR1(2)
            ZXT2A(3,3) = ZIGT2(1)
            BXT2A(3,3) = BTR2(1)
            ZXT2B(3,3) = ZIGT2(2)
            BXT2B(3,3) = BTR2(2)
            ZXL(3,3) = ZIGL
            BXL(3,3) = BLOO
            ZXDP(3,3) = ZIGDP(1)+ZIGDP(2)+ZIGDP(3)+ZIGDP(4)
            BXDP(3,3) = (BDP(1)+BDP(2)+BDP(3)+BDP(4))/FOUR
C
C  pure elastic scattering of both of the low mass resonances
          CALL INPCS(IP,RMASS1,RMASS2,RMASS1,RMASS2)
            ZXP(4,4) = ZIGP
            BXP(4,4) = BPOM
            ZXR(4,4) = ZIGR
            BXR(4,4) = BREG
            ZXH(4,4) = ZIGHR
            BXH(4,4) = BHAR
            ZXD(4,4) = ZIGHD
            BXD(4,4) = BHAD
            ZXT1A(4,4) = ZIGT1(1)
            BXT1A(4,4) = BTR1(1)
            ZXT1B(4,4) = ZIGT1(2)
            BXT1B(4,4) = BTR1(2)
            ZXT2A(4,4) = ZIGT2(1)
            BXT2A(4,4) = BTR2(1)
            ZXT2B(4,4) = ZIGT2(2)
            BXT2B(4,4) = BTR2(2)
            ZXL(4,4) = ZIGL
            BXL(4,4) = BLOO
            ZXDP(4,4) = ZIGDP(1)+ZIGDP(2)+ZIGDP(3)+ZIGDP(4)
            BXDP(4,4) = (BDP(1)+BDP(2)+BDP(3)+BDP(4))/FOUR
        ENDIF
C
C  low mass single diffractive scattering 1
        CALL INPCS(IP,XMASS1,XMASS2,RMASS1,XMASS2)
          ZXP(1,2) = ZIGP
          BXP(1,2) = BPOM
          ZXR(1,2) = ZIGR
          BXR(1,2) = BREG
          ZXH(1,2) = ZIGHR
          BXH(1,2) = BHAR
          ZXD(1,2) = ZIGHD
          BXD(1,2) = BHAD
          ZXT1A(1,2) = ZIGT1(1)
          BXT1A(1,2) = BTR1(1)
          ZXT1B(1,2) = ZIGT1(2)
          BXT1B(1,2) = BTR1(2)
          ZXT2A(1,2) = ZIGT2(1)
          BXT2A(1,2) = BTR2(1)
          ZXT2B(1,2) = ZIGT2(2)
          BXT2B(1,2) = BTR2(2)
          ZXL(1,2) = ZIGL
          BXL(1,2) = BLOO
          ZXDP(1,2) = ZIGDP(1)+ZIGDP(2)+ZIGDP(3)+ZIGDP(4)
          BXDP(1,2) = (BDP(1)+BDP(2)+BDP(3)+BDP(4))/FOUR
C
C  low mass single diffractive scattering 2
        CALL INPCS(IP,XMASS1,XMASS2,XMASS1,RMASS2)
          ZXP(1,3) = ZIGP
          BXP(1,3) = BPOM
          ZXR(1,3) = ZIGR
          BXR(1,3) = BREG
          ZXH(1,3) = ZIGHR
          BXH(1,3) = BHAR
          ZXD(1,3) = ZIGHD
          BXD(1,3) = BHAD
          ZXT1A(1,3) = ZIGT1(1)
          BXT1A(1,3) = BTR1(1)
          ZXT1B(1,3) = ZIGT1(2)
          BXT1B(1,3) = BTR1(2)
          ZXT2A(1,3) = ZIGT2(1)
          BXT2A(1,3) = BTR2(1)
          ZXT2B(1,3) = ZIGT2(2)
          BXT2B(1,3) = BTR2(2)
          ZXL(1,3) = ZIGL
          BXL(1,3) = BLOO
          ZXDP(1,3) = ZIGDP(1)+ZIGDP(2)+ZIGDP(3)+ZIGDP(4)
          BXDP(1,3) = (BDP(1)+BDP(2)+BDP(3)+BDP(4))/FOUR
C
C  low mass double diffractive scattering
        CALL INPCS(IP,XMASS1,XMASS2,RMASS1,RMASS2)
          ZXP(1,4) = ZIGP
          BXP(1,4) = BPOM
          ZXR(1,4) = ZIGR
          BXR(1,4) = BREG
          ZXH(1,4) = ZIGHR
          BXH(1,4) = BHAR
          ZXD(1,4) = ZIGHD
          BXD(1,4) = BHAD
          ZXT1A(1,4) = ZIGT1(1)
          BXT1A(1,4) = BTR1(1)
          ZXT1B(1,4) = ZIGT1(2)
          BXT1B(1,4) = BTR1(2)
          ZXT2A(1,4) = ZIGT2(1)
          BXT2A(1,4) = BTR2(1)
          ZXT2B(1,4) = ZIGT2(2)
          BXT2B(1,4) = BTR2(2)
          ZXL(1,4) = ZIGL
          BXL(1,4) = BLOO
          ZXDP(1,4) = ZIGDP(1)+ZIGDP(2)+ZIGDP(3)+ZIGDP(4)
          BXDP(1,4) = (BDP(1)+BDP(2)+BDP(3)+BDP(4))/FOUR
C
       IF(ISWMDL(1).EQ.2) THEN
C
C  low mass mixed single diffractive scattering
          CALL INPCS(IP,RMASS1,XMASS2,XMASS1,RMASS2)
            ZXP(2,3) = ZIGP
            BXP(2,3) = BPOM
            ZXR(2,3) = ZIGR
            BXR(2,3) = BREG
            ZXH(2,3) = ZIGHR
            BXH(2,3) = BHAR
            ZXD(2,3) = ZIGHD
            BXD(2,3) = BHAD
            ZXT1A(2,3) = ZIGT1(1)
            BXT1A(2,3) = BTR1(1)
            ZXT1B(2,3) = ZIGT1(2)
            BXT1B(2,3) = BTR1(2)
            ZXT2A(2,3) = ZIGT2(1)
            BXT2A(2,3) = BTR2(1)
            ZXT2B(2,3) = ZIGT2(2)
            BXT2B(2,3) = BTR2(2)
            ZXL(2,3) = ZIGL
            BXL(2,3) = BLOO
            ZXDP(2,3) = ZIGDP(1)+ZIGDP(2)+ZIGDP(3)+ZIGDP(4)
            BXDP(2,3) = (BDP(1)+BDP(2)+BDP(3)+BDP(4))/FOUR
C
C  low mass single to double diffractive scattering 1
          CALL INPCS(IP,RMASS1,XMASS2,RMASS1,RMASS2)
            ZXP(2,4) = ZIGP
            BXP(2,4) = BPOM
            ZXR(2,4) = ZIGR
            BXR(2,4) = BREG
            ZXH(2,4) = ZIGHR
            BXH(2,4) = BHAR
            ZXD(2,4) = ZIGHD
            BXD(2,4) = BHAD
            ZXT1A(2,4) = ZIGT1(1)
            BXT1A(2,4) = BTR1(1)
            ZXT1B(2,4) = ZIGT1(2)
            BXT1B(2,4) = BTR1(2)
            ZXT2A(2,4) = ZIGT2(1)
            BXT2A(2,4) = BTR2(1)
            ZXT2B(2,4) = ZIGT2(2)
            BXT2B(2,4) = BTR2(2)
            ZXL(2,4) = ZIGL
            BXL(2,4) = BLOO
            ZXDP(2,4) = ZIGDP(1)+ZIGDP(2)+ZIGDP(3)+ZIGDP(4)
            BXDP(2,4) = (BDP(1)+BDP(2)+BDP(3)+BDP(4))/FOUR
C
C  low mass single to double diffractive scattering 2
          CALL INPCS(IP,XMASS1,RMASS2,RMASS1,RMASS2)
            ZXP(3,4) = ZIGP
            BXP(3,4) = BPOM
            ZXR(3,4) = ZIGR
            BXR(3,4) = BREG
            ZXH(3,4) = ZIGHR
            BXH(3,4) = BHAR
            ZXD(3,4) = ZIGHD
            BXD(3,4) = BHAD
            ZXT1A(3,4) = ZIGT1(1)
            BXT1A(3,4) = BTR1(1)
            ZXT1B(3,4) = ZIGT1(2)
            BXT1B(3,4) = BTR1(2)
            ZXT2A(3,4) = ZIGT2(1)
            BXT2A(3,4) = BTR2(1)
            ZXT2B(3,4) = ZIGT2(2)
            BXT2B(3,4) = BTR2(2)
            ZXL(3,4) = ZIGL
            BXL(3,4) = BLOO
            ZXDP(3,4) = ZIGDP(1)+ZIGDP(2)+ZIGDP(3)+ZIGDP(4)
            BXDP(3,4) = (BDP(1)+BDP(2)+BDP(3)+BDP(4))/FOUR
        ENDIF
C
C  restore IFHARD value
        IFHARD = ITMP
      ENDIF
C
      B24=DCMPLX(B**2,ZERO)/FOUR
C
      AMPEL      = CZERO
      AMPR      = CZERO
      AMPO      = CZERO
      AMPP      = CZERO
      AMPQ      = CZERO
      AMLMSD(1) = CZERO
      AMLMSD(2) = CZERO
      AMHMSD(1) = CZERO
      AMHMSD(2) = CZERO
      AMLMDD    = CZERO
      AMHMDD    = CZERO
C
C  different models
C
      IF(ISWMDL(1).LT.3) THEN
C  pomeron
        AUXP  = ZXP(1,1)*EXP(-B24/BXP(1,1))
C  reggeon
        AUXR  = ZXR(1,1)*EXP(-B24/BXR(1,1))
C  hard resolved processes
        AUXH  = ZXH(1,1)*EXP(-B24/BXH(1,1))
C  hard direct processes
        AUXD  = ZXD(1,1)*EXP(-B24/BXD(1,1))
C  triple-Pomeron: baryon high mass diffraction
        AUXT1 = ZXT1A(1,1)*EXP(-B24/BXT1A(1,1))
     &        + ZXT1B(1,1)*EXP(-B24/BXT1B(1,1))
C  triple-Pomeron: photon/meson high mass diffraction
        AUXT2 = ZXT2A(1,1)*EXP(-B24/BXT2A(1,1))
     &        + ZXT2B(1,1)*EXP(-B24/BXT2B(1,1))
C  loop-Pomeron
        AUXL  = ZXL(1,1)*EXP(-B24/BXL(1,1))
      ENDIF
C
C
      IF(ISWMDL(1).EQ.IZERO) THEN
        AMPEL = OHALF*((VDMQ2F(1)+VDMQ2F(2)+VDMQ2F(3)+VDMQ2F(4))
     &                 *(CONE-EXP(-AUXR-AUXP-AUXH+AUXT1+AUXT2+AUXL))
     &        +(CONE-(VDMQ2F(1)-VDMQ2F(2)-VDMQ2F(3)-VDMQ2F(4)))*AUXD
     &               )
        AMPR = OHALF*SQRT(VDMQ2F(1))*(CONE-EXP(-AUXR-AUXP-AUXH
     &                                      +AUXT1+AUXT2+AUXL))
        AMPO = OHALF*SQRT(VDMQ2F(2))*(CONE-EXP(-AUXR-AUXP-AUXH
     &                                      +AUXT1+AUXT2+AUXL))
        AMPP = OHALF*SQRT(VDMQ2F(3))*(CONE-EXP(-AUXR-AUXP-AUXH
     &                                      +AUXT1+AUXT2+AUXL))
        AMPQ = OHALF*SQRT(VDMQ2F(4))*(CONE-EXP(-AUXR-AUXP-AUXH
     &                                      +AUXT1+AUXT2+AUXL))
C
C
      ELSE IF(ISWMDL(1).EQ.1) THEN
        AMPR = OHALF*SQRT(VDMQ2F(1))*
     &         ( CONE-EXP(-AUXR-AUXP-AUXH*VDMQ2F(1)) )
        AMPO = OHALF*SQRT(VDMQ2F(2))*
     &         ( CONE-EXP(-3.D0*AUXR-AUXP-AUXH*VDMQ2F(2)) )
        AMPP = OHALF*SQRT(VDMQ2F(3))*
     &         ( CONE-EXP(-AUXP-AUXH*VDMQ2F(3)) )
        AMPQ = OHALF*SQRT(VDMQ2F(4))*
     &         ( CONE-EXP(-AUXR-AUXP-AUXH*VDMQ2F(4)) )
        AMPEL = SQRT(VDMQ2F(1))*AMPR
     &         + SQRT(VDMQ2F(2))*AMPO
     &         + SQRT(VDMQ2F(3))*AMPP
     &         + SQRT(VDMQ2F(4))*AMPQ
     &         + AUXD/2.D0
C
C  simple analytic two channel model (version A)
      ELSE IF(ISWMDL(1).EQ.3) THEN
        CALL CHAN2A(B)
C
      ELSE
        WRITE(6,'(1X,A,I2)')
     &       'EIKON: ERROR: unsupported model ISWMDL(1) ',ISWMDL(1)
        STOP
      ENDIF
C
      END
