C
C
      SUBROUTINE GPHERA(NEVENT,EE1,EE2)
C**********************************************************************
C
C     interface to call PHOJET (variable energy run) with
C     HERA kinematics, photon as particle 2
C
C     equivalen photon approximation to get photon flux
C
C     input:     NEVENT  number of events to generate
C                EE1     proton energy (LAB system)
C                EE2     electron energy (LAB system)
C             from COMMON /LEPCUT/:
C                YMIN2    lower limit of Y
C                        (energy fraction taken by photon from electron)
C                YMAX2    upper limit of Y
C                Q2MIN2   lower limit of photon virtuality
C                Q2MAX2   upper limit of photon virtuality
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER ( ZERO = 0.D0,
     &            ONE  = 1.D0,
     &            TWO  = 2.D0,
     &            DEPS = 1.D-10,
     &            PI   = 3.14159265359D0 )
C
C  lepton/hadron-photon kinematics
      COMMON /PHOSRC/ PINI(5,2),PFIN(5,2),PGAM(5,2),
     &                GYY(2),GQ2(2),GGECM,GAIMP(2),PFTHE(2),PFPHI(2),
     &                IDPSRC(2),IDBSRC(2),RADSRC(2),AMSRC(2),GAMSRC(2)
      COMMON /LEPCUT/ ECMIN,ECMAX,EEMIN1,EEMIN2,
     &                YMIN1,YMAX1,YMIN2,YMAX2,
     &                Q2MIN1,Q2MAX1,Q2MIN2,Q2MAX2,
     &                THMIN1,THMAX1,THMIN2,THMAX2
C
      DIMENSION P1(4),P2(4)
      CHARACTER*72 TITLE
C
      WRITE(6,'(//1X,A,I10)') 'GPHERA:DEBUG:EVENTS TO PROCESS',NEVENT
C  assign particle momenta according to HERA kinematics
C  electron data
      ELEM = 0.512D-03
      ELEM2 = ELEM**2
      IDPSRC(1) = 0
      IDBSRC(1) = 0
      IDPSRC(2) = 11
      IDBSRC(2) = 3
C  proton data
      PROM = POPAMA(1,0)
      PROM2 = PROM**2
C
      Q2MIN = Q2MIN2
      Q2MAX = Q2MAX2
C
      XIMAX = LOG(YMAX2)
      XIMIN = LOG(YMIN2)
      XIDEL = XIMAX-XIMIN
C
      MAXTAB = 50
      DELLY = LOG(YMAX2/YMIN2)/DBLE(MAXTAB-1)
      FLUX = 0.D0
*     WRITE(6,'(1X,A,I5)')'GPHERA:DEBUG:TABLE OF PHOTON FLUX',MAXTAB
      DO 100 I=1,MAXTAB
        Y = EXP(XIMIN+DELLY*DBLE(I-1))
        Q2LOW = MAX(Q2MIN,ELEM2*Y**2/(ONE-Y))
        FF1 = ((ONE+(ONE-Y)**2)/Y*LOG(Q2MAX/Q2LOW)
     &         -TWO*ELEM2*Y*(ONE/Q2LOW-ONE/Q2MAX))/(TWO*PI*137.D0)
        FF2 = ((ONE+(ONE-Y)**2)/Y*LOG(Q2MAX/Q2LOW)
     &         -TWO*(ONE-Y)/Y*(ONE-Q2LOW/Q2MAX))/(TWO*PI*137.D0)
        FLUX = FLUX+Y*FF1
*       WRITE(6,'(5X,3E15.4)') Y,FF1,FF2
 100  CONTINUE
      FLUX = FLUX*DELLY
      WRITE(6,'(1X,A,E12.4)') 'GPHERA:DEBUG:INTEGRATED FLUX:',FLUX
C
      AY = ZERO
      AY2 = ZERO
      YY = YMIN2
      Q2LOW = MAX(Q2MIN,ELEM2*YY**2/(ONE-YY))
*     WGMAX = (ONE+(ONE-YY)**2)*LOG(Q2MAX/Q2LOW)
*    &        -TWO*(ONE-YY)*(ONE-Q2LOW/Q2MAX)
      WGMAX = (ONE+(ONE-YY)**2)*LOG(Q2MAX/Q2LOW)
     &        -TWO*ELEM2*YY*(ONE/Q2LOW-ONE/Q2MAX)*YY
C
C  initialization of PHOJET at upper energy limit
C  proton momentum
      P1(1) = ZERO
      P1(2) = ZERO
      P1(3) = SQRT(EE1**2-PROM2+DEPS)
      P1(4) = EE1
C  photon momentum
      EGAM = YMAX2*EE2
      P2(1) = ZERO
      P2(2) = ZERO
      P2(3) = -EGAM
      P2(4) = EGAM
      CALL SETPAR(1,2212,0,ZERO)
      CALL SETPAR(2,22,0,ZERO)
      CALL EVENT(-1,P1,P2,SIGMAX,IREJ)
      CALL POHIST(-1,WEIGHT)
      CALL POLUHI(-1,WEIGHT)
C
C  generation of events, flux calculation
      CALL NEWHIS(YMIN2,YMAX2,ZERO,P1,49,IHFLX1)
      CALL NEWHIS(YMIN2,YMAX2,ZERO,P1,49,IHFLX2)
      AY = ZERO
      NITER = NEVENT
      ITRY = 0
      ITRW = 0
      AY = ZERO
      AY2 = ZERO
      Q22MIN = 1.D30
      Q22AVE = 0.D0
      Q22AV2 = 0.D0
      Q22MAX = 0.D0
      AN2MIN = 1.D30
      AN2MAX = 0.D0
      YY2MIN = 1.D30
      YY2MAX = 0.D0
      DO 200 I=1,NITER
 150    CONTINUE
C  sample y
        ITRY = ITRY+1
 175    CONTINUE
          ITRW = ITRW+1
          YY = EXP(XIDEL*RNDM(AY)+XIMIN)
          Q2LOW = MAX(Q2MIN,ELEM2*YY**2/(ONE-YY))
          Q2LOG = LOG(Q2MAX/Q2LOW)
*         WGH = (ONE+(ONE-YY)**2)*Q2LOG
*    &          -TWO*(ONE-YY)*(ONE-Q2LOW/Q2MAX)
          WGH = (ONE+(ONE-YY)**2)*Q2LOG
     &          -TWO*ELEM2*YY*(ONE/Q2LOW-ONE/Q2MAX)*YY
          IF(WGMAX.LT.WGH) THEN
            WRITE(6,'(1X,A,3E12.5)')
     &        'GPHERA:WEIGHT ERROR:',YY,WGMAX,WGH
          ENDIF
        IF(RNDM(AY2)*WGMAX.GT.WGH) GOTO 175
C  sample Q2
        YEFF = ONE+(ONE-YY)**2
 185    CONTINUE
          Q2 = Q2LOW*EXP(Q2LOG*RNDM(YY))
          WEIGHT = (YEFF-2.D0*(ONE-YY)*Q2LOW/Q2)/YEFF
        IF(WEIGHT.LT.RNDM(Q2)) GOTO 185
C
        CALL FILHIS(YY,ONE,IHFLX1)
        CALL ADDHIS(IHFLX1)
C  incoming electron
        PINI(1,2) = ZERO
        PINI(2,2) = ZERO
        PINI(3,2) = -EE2
        PINI(4,2) = EE2
        PINI(5,2) = ZERO
C  outgoing electron
        YQ2 = SQRT((ONE-YY)*Q2)
        Q2E = Q2/(4.D0*EE2)
        E1Y = EE2*(ONE-YY)
        CALL SFECFE(SIF,COF)
        PFIN(1,2) = YQ2*COF
        PFIN(2,2) = YQ2*SIF
        PFIN(3,2) = -E1Y+Q2E
        PFIN(4,2) = E1Y+Q2E
        PFIN(5,2) = ZERO
C  set /PHOSRC/
        GYY(2) = YY
        GQ2(2) = Q2
        PFPHI(2) = ATAN2(SIF,COF)
        PFTHE(2) = ACOS((Q2E-E1Y)/(Q2E+E1Y))
C  electron tagger
        IF(PFIN(4,2).GT.EEMIN2) THEN
          IF((PFTHE(2).LT.THMIN2).OR.(PFTHE(2).GT.THMAX2)) GOTO 175
        ENDIF
C  photon momentum
        P2(1) = -PFIN(1,2)
        P2(2) = -PFIN(2,2)
        P2(3) = PINI(3,2)-PFIN(3,2)
        P2(4) = PINI(4,2)-PFIN(4,2)
*       QT2 = Q2*(ONE-P2(4)*PINI(4,2)/PINI(3,2)**2)
*    &        -P2(4)**2*ELEM2/PINI(3,2)**2
*    &        -Q2**2/(4.D0*PINI(3,2)**2)
C  proton momentum
        P1(1) = ZERO
        P1(2) = ZERO
        P1(3) = SQRT(EE1**2-PROM2)
        P1(4) = EE1
C  ECMS cut
        GGECM = (P1(4)+P2(4))**2-(P1(1)+P2(1))**2
     &         -(P1(2)+P2(2))**2-(P1(3)+P2(3))**2
        IF(GGECM.LT.0.1D0) GOTO 175
        GGECM = SQRT(GGECM)
        IF((GGECM.LT.ECMIN).OR.(GGECM.GT.ECMAX)) GOTO 175
C
        PGAM(1,2) = P2(1)
        PGAM(2,2) = P2(2)
        PGAM(3,2) = P2(3)
        PGAM(4,2) = P2(4)
        PGAM(5,2) = -SQRT(Q2)
        CALL PRESEL(5,IREJ)
        IF(IREJ.NE.0) GOTO 175
C  event generation
        CALL EVENT(1,P1,P2,SIGCUR,IREJ)
        IF(IREJ.NE.0) GOTO 150
        CALL FILHIS(YY,ONE,IHFLX2)
        CALL ADDHIS(IHFLX2)
C  statistics
        AY = AY+YY
        AY2 = AY2+YY*YY
        YY2MIN = MIN(YY2MIN,YY)
        YY2MAX = MAX(YY2MAX,YY)
        Q22MIN = MIN(Q22MIN,Q2)
        Q22MAX = MAX(Q22MAX,Q2)
        Q22AVE = Q22AVE+Q2
        Q22AV2 = Q22AV2+Q2*Q2
        AN2MIN = MIN(AN2MIN,PFTHE(2))
        AN2MAX = MAX(AN2MAX,PFTHE(2))
C  histograms
        CALL POHIST(1,ONE)
        CALL POLUHI(1,ONE)
 200  CONTINUE
C
      WGY = WGMAX*DBLE(ITRY)/DBLE(ITRW)/(137.D0*TWO*PI)
      WGY = WGY*LOG(YMAX2/YMIN2)
      AY  = AY/DBLE(NITER)
      AY2 = AY2/DBLE(NITER)
      DAY = SQRT((AY2-AY**2)/DBLE(NITER))
      Q22AVE = Q22AVE/DBLE(NITER)
      Q22AV2 = Q22AV2/DBLE(NITER)
      Q22AV2 = SQRT((Q22AV2-Q22AVE**2)/DBLE(NITER))
      WEIGHT = WGY*SIGMAX*DBLE(NITER)/DBLE(ITRY)
C  output of histograms
      WRITE(6,'(//1X,A,/1X,A,1PE12.3,A,/1X,A)')
     &'=========================================================',
     &' *****   simulated cross section: ',WEIGHT,' mb  *****',
     &'========================================================='
      WRITE(6,'(//1X,A,3I10)')
     &  'GPHERA:SUMMARY:NITER,ITRY,ITRW',NITER,ITRY,ITRW
      WRITE(6,'(1X,A,1P2E12.4)') 'EFFECTIVE WEIGHT (FLUX,TOTAL)',
     &  WGY,WEIGHT
      WRITE(6,'(1X,A,1P2E12.4)') 'AVERAGE Y,DY                 ',AY,DAY
      WRITE(6,'(1X,A,1P2E12.4)') 'SAMPLED Y RANGE PHOTON       ',
     &  YY2MIN,YY2MAX
      WRITE(6,'(1X,A,1P2E12.4)') 'AVERAGE Q2,DQ2               ',
     &  Q22AVE,Q22AV2
      WRITE(6,'(1X,A,1P2E12.4)') 'SAMPLED Q2 RANGE PHOTON      ',
     &  Q22MIN,Q22MAX
      WRITE(6,'(1X,A,1P4E12.4)') 'SAMPLED THETA RANGE ELECTRON ',
     &  AN2MIN,AN2MAX,PI-AN2MAX,PI-AN2MIN
C
      CALL EVENT(-2,P1,P2,WEIGHT,IREJ)
      IF(NITER.GT.1) THEN
        CALL POHIST(-2,WEIGHT)
        CALL POLUHI(-2,WEIGHT)
      ELSE
        WRITE(6,'(1X,A,I4)') 'GPHERA:NO OUTPUT OF HISTOGRAMS',NITER
      ENDIF
C
      TITLE = ' EP APPROXIMATION PHOTON FLUX'
      CALL OUTHIS(IHFLX1,1,TITLE,WGY,1)
      TITLE = ' EFFECTIVE PHOTON FLUX (CROSS SECTION WEIGHTED)'
      CALL OUTHIS(IHFLX2,1,TITLE,WGY,1)
      END
