C
C
      INTEGER FUNCTION IPOCH3(INDEX,MODE)
C**********************************************************************
C
C     output of three times the electric charge
C
C     index:  MODE
C             0   INDEX gives CPC particle number
C             1   INDEX gives PDG particle number
C             2   INDEX gives position of particle in HEPEVS

C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           THREE  =  3.D0,
     &           TWOTHR =  TWO/THREE,
     &           OTHR   =  ONE/THREE,
     &           OHALF  =  0.5D0,
     &           DEPS   =  1.D-05)
C
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVS/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      COMMON/HEPEVE/IMPART(NMXHEP),IPHIST(2,NMXHEP),ICOLOR(2,NMXHEP)
C
      CHARACTER*8 ANAME
      COMMON/POPART/ANAME(187),AM(187),GA(187),TAU(187),ICH(187),
     &              IBAR(187),K1(187),K2(187)
C
      IPOCH3 = 0
C
      IF(MODE.EQ.0) THEN
        IDBAM = INDEX
        IDPDG = MPDGHA(INDEX)
        ILINE = 0
      ELSE IF(MODE.EQ.1) THEN
        IDPDG = INDEX
        IDBAM = 0
        ILINE = 0
      ELSE IF(MODE.EQ.2) THEN
        IDPDG = IDHEP(INDEX)
        IDBAM = IMPART(INDEX)
        ILINE = INDEX
      ELSE
        WRITE(6,'(1X,A,2I5)') 
     &    'IPOCH3:ERROR:INVALID ARGUMENTS',INDEX,MODE
        RETURN
      ENDIF
C
C  CPC particle
      IF((IDBAM.GT.0).AND.(IDBAM.LE.187)) THEN
        IPOCH3 = 3*ICH(IDBAM)
C  parton
      ELSE IF((IDPDG.GE.-6).AND.(IDPDG.LE.6)) THEN
        ICH1 = - MOD(ABS(IDPDG),2)
     &       + MOD(ABS(IDPDG)+1,2)*2
        IF(IDPDG.LT.0) ICH1 = -ICH1
        IPOCH3 = ICH1
      ELSE IF((IDPDG.EQ.21).OR.(IDPDG.EQ.9)) THEN
        IPOCH3 = ZERO
      ELSE IF((ABS(IDPDG).EQ.1103).OR.
     &        (ABS(IDPDG).EQ.3101).OR.
     &        (ABS(IDPDG).EQ.3103).OR.
     &        (ABS(IDPDG).EQ.3303)) THEN
        IPOCH3 = -SIGN(2,IDPDG)
      ELSE IF((ABS(IDPDG).EQ.2101).OR.
     &        (ABS(IDPDG).EQ.2103).OR.
     &        (ABS(IDPDG).EQ.3201).OR.
     &        (ABS(IDPDG).EQ.3203)) THEN
        IPOCH3 = SIGN(1,IDPDG)
      ELSE IF(ABS(IDPDG).EQ.2203) THEN
        IPOCH3 =  SIGN(4,IDPDG)
      ELSE IF(ILINE.GT.0) THEN
C  comment line
        IF(ISTHEP(ILINE).GE.11) THEN
          RETURN
C  chain system
        ELSE IF((IDPDG.EQ.6666)
     &      .OR.(IDPDG.EQ.7777)
     &      .OR.(IDPDG.EQ.8888)) THEN
            IPOCH3 = ICOLOR(1,ILINE)
        ENDIF
      ELSE
        IDBAM = MCIHAD(IDPDG)
        IF(IDBAM.EQ.99999) THEN
          WRITE(6,'(/,1X,A,I6)') 'IPOCH3:WARNING:UNKNOWN PARTICLE',
     &      IDPDG
        ELSE
          IPOCH3 = 3*ICH(IDBAM)
        ENDIF
      ENDIF
      END
