C
C
      INTEGER FUNCTION NDIQU(K1,K2)
C**********************************************************************
C
C     determine PDG diquark number from quark numbers K1, K2
C
C     K1, K2:  1   d  (anti --> neg.)
C              2   u
C              3   s
C              4   c
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      DIMENSION NDIQ(4,4)
      DATA NDIQ /
     &   1103, 2101, 3101, 4101,
     &   2103, 2203, 3201, 4201,
     &   3103, 3203, 3303, 4301,
     &   4103, 4203, 4303, 4403 /
C
      K = K1*K2
      IF((K.GE.1).AND.(K.LE.16)) THEN
        NDIQU = SIGN(NDIQ(ABS(K1),ABS(K2)),K1)
      ELSE
        WRITE(6,'(/1X,A,2I8)') 'NDIQU:WARNING: QUARK-ID OUT OF RANGE',
     &    K1,K2
        NDIQU = 0
        CALL POABRT
      ENDIF
      END
