      SUBROUTINE PHOFIT
C**********************************************************************
C
C     fit program to adjust free parameters of the model
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
      COMMON /REGGE/  ALPOM,ALPOMP,GP(2),B0POM(2),
     &                ALREG,ALREGP,GR(2),B0REG(2),
     &                GPPP,GPPR,B0PPP,B0PPR,
     &                VDMFAC(4),VDMQ2F(4),B0HAR,AKFAC
      COMMON /TWOCHA/ PHISUP(2),RMASS1,RMASS2,VAR
C
      PARAMETER ( MAXPRO = 16 )
      COMPLEX*16      SIGP,SIGR,SIGHD,SIGHR,SIGT1,SIGT2,SIGL,SIGDP,
     &                SIGD1,SIGD2,DSIGH
      COMMON /SIGMAS/ SIGP,SIGR,SIGHD,SIGHR,SIGT1(2),SIGT2(2),SIGL,
     &                SIGDP(4),SIGD1(2),SIGD2(2),DSIGH(0:MAXPRO)
C
      COMMON /XSECTP/ SIGTOT,SIGELA,SIGVM(0:4,0:4),SIGINE,SIGDIR,
     &                SIGLSD(2),SIGHSD(2),SIGLDD,SIGHDD,SIGCDF,
     &                SIGPOM,SIGREG,SIGHAR,SIGTR1,SIGTR2,SIGLOO,SIGDPO,
     &                SIG1SO,SIG1HA,SLOEL,SLOVM(4,4),SIGGEN(4),
     &                FSUP(2)
C
      PARAMETER(NECM=200,NPAR=30)
      CHARACTER*6 HINT
      COMMON /FITMOD/ IFMOD,IFHARD
      COMMON /FITTYP/IFIT,NIST,ECMS(NECM),XTOT(NECM),XTOTE(NECM),
     &               XELA(NECM),XELAE(NECM),XINE(NECM),
     &               XINEE(NECM),XSDI(NECM),XSDIE(NECM),
     &               SLO(NECM),SLOE(NECM),XPRO(3,NECM),XPROE(3,NECM),
     &               XI(NPAR),XINC(NPAR),NFITP,HINT(NPAR),IFITF(NPAR)
      COMMON /CONTRL/XSTEP,NFUN
C
      PARAMETER(THOUS=1000,
     &          IZERO=0,
     &          ZERO =0.D0,
     &          ONE  =1.D0,
     &          IONE =1)
      PARAMETER(NDUM=50000)
      DIMENSION XVAR(NPAR),DXVAR(NPAR)
      DIMENSION WDUMMY(NDUM),YI(1000),SIGSDI(2)
C
C  external chi**2 determination (FCN)
      EXTERNAL AMPFIT,TESTF
C
      CHARACTER*10 CNAME
      CHARACTER*70 NUMBER
      CHARACTER*12 FILENA
C
      DATA ICALLF /0/
C  control output
      DATA IOPEN /0/
C  control output
      DATA IPRINT /1/
C  print covariance matrix
      DATA COV /1/
C  minimal increment
      DATA EPS /1.D-5/
C  minimization strategy
      DATA ISTRAT /1/
C
 14   FORMAT(A10,A70)
 15   FORMAT(A12)
      WRITE(6,*) ' ******** START OF PHOJET PARAMETER FIT *********'
      IF(ICALLF.EQ.0) CALL FITDAT
      ICALLF = ICALLF+1
      CALL FITPAR(0)
C
 1200 CONTINUE
        READ(5,14) CNAME,NUMBER
        IF(CNAME.EQ.'ENDFIT    ') GOTO 1300
        IF(CNAME.EQ.'SUSPENDFIT') GOTO 1400
        IF(CNAME.EQ.'COMMENT   ') THEN
          WRITE(6,*) ' COMMENT  ',NUMBER
        ELSE IF(CNAME.EQ.'INPUTFILE ') THEN
          READ(NUMBER,15) FILENA
          WRITE(6,*) '  Input File: ',FILENA
C  read cross section data cards
          CALL XINP(FILENA)
        ELSE IF(CNAME.EQ.'SUMMARY   ') THEN
          READ(NUMBER,15) FILENA
          WRITE(6,*) '  Output File: ',FILENA
C  open output file for summary
          IF(IOPEN.EQ.1) THEN
            CLOSE(10)
            IOPEN=0
          ENDIF
          OPEN(10,FILE=FILENA,STATUS='UNKNOWN',ERR=900)
          IOPEN=1
          WRITE(10,*) ' --------------- summary file ----------------'
        ELSE IF(CNAME.EQ.'NITER     ') THEN
          READ(NUMBER,*) NFUN
          WRITE(6,*) '  NFUN (NITER)   ',NFUN
        ELSE IF(CNAME.EQ.'IPRINT    ') THEN
          READ(NUMBER,*) IPRINT
          WRITE(6,*) '  IPRINT         ',IPRINT
        ELSE IF(CNAME.EQ.'FITMODE   ') THEN
          READ(NUMBER,*) IFMOD
          WRITE(6,*) '  FITMODE        ',IFMOD
        ELSE IF(CNAME.EQ.'STRATEGY  ') THEN
          READ(NUMBER,*) ISTRAT
          WRITE(6,*) '  STRATEGY       ',ISTRAT
        ELSE IF(CNAME.EQ.'NFITP     ') THEN
          READ(NUMBER,*) NFITP
          WRITE(6,*) '  NFITP (number of fit parameters) = ',NFITP
        ELSE IF(CNAME.EQ.'XINCREMENT') THEN
          READ(NUMBER,*) (XINC(IFITF(I)),I=1,NFITP)
          DO 110 I=1,NFITP
             WRITE(6,*) '  XINC(',IFITF(I),')=',XINC(IFITF(I))
             IF(XINC(IFITF(I)).LT.EPS) THEN
               WRITE(6,*) ' *** Error reading Xincrement ***'
     &                   ,' (value to small)'
               STOP
             ENDIF
 110      CONTINUE
        ELSE IF(CNAME.EQ.'XSTEP     ') THEN
          READ(NUMBER,*) XSTEP
          WRITE(6,*) '  XSTEP = ',XSTEP
        ELSE IF(CNAME.EQ.'PARAMETER') THEN
          WRITE(6,*) '  selected fit parameters:'
          READ(NUMBER,*) (IFITF(I),I=1,NFITP)
          DO 100 I=1,NFITP
             WRITE(6,*) '  IFITF(',I,')=',IFITF(I),
     &                  '   --> ',HINT(IFITF(I))
             IF((IFITF(I).LT.1).OR.(IFITF(I).GT.NPAR)) THEN
               WRITE(6,*)
     &          ' *** Error reading selected fit parameter ***'
               STOP
             ENDIF
 100      CONTINUE
C
C  perform simple fit using MINSQ of CERN library
        ELSE IF(CNAME.EQ.'AMPFIT    ') THEN
          WRITE(6,*)
     &    ' **** start of AMPFIT program ****'
          WRITE(10,*)
     &    ' **** start of AMPFIT program ****'
          IF(NFITP.LE.0) THEN
            WRITE(6,*) '  *** Error: select first fit parameter ***'
            STOP
          ENDIF
C  initial parameter settings
          CALL FITPAR(1)
          XI(1)=ALPOM
          XI(2)=ALPOMP
          XI(3)=GP(1)
          XI(4)=GP(2)
          XI(5)=B0POM(1)
          XI(6)=B0POM(2)
          XI(7)=ALREG
          XI(8)=ALREGP
          XI(9)=GR(1)
          XI(10)=B0REG(1)
          XI(11)=GPPP
          XI(12)=B0PPP
          XI(13)=VDMFAC(1)
          XI(14)=VDMFAC(2)
          XI(15)=VDMFAC(3)
          XI(16)=VDMFAC(4)
          XI(17)=B0HAR
          XI(18)=AKFAC
          XI(19)=PHISUP(1)
          XI(20)=PHISUP(2)
          XI(21)=RMASS1
          XI(22)=RMASS2
          XI(23)=GPPR
          XI(24)=B0PPR
*         GR(2)    = GP(2)/GP(1)*GR(1)
*         B0REG(2) = B0POM(2)/B0POM(1)*B0REG(1)
C  control length of auxiliary field
          NW=NFITP+IFIT*(NFITP+1)+(3*NFITP*(NFITP+1))/2+1
          IF(NW.GT.NDUM) THEN
            WRITE(6,*)
     &       ' PHOFIT: ERROR: size of aux. field WDUMMY to small'
            STOP
          ELSE
            NW=NDUM
          ENDIF
C  prepare parameter input field
          DO 120 I=1,NFITP
             XVAR(I)=XI(IFITF(I))
             DXVAR(I)=XINC(IFITF(I))
 120      CONTINUE
C  call to CERN fit subroutine
          WRITE(6,*) ' **** start of fit program ****'
          WRITE(10,*) ' **** start of fit program ****'
          CALL DATINP(10,1)
          CALL DATINP(6,1)
          CALL MINSQ(IFIT,NFITP,YI,XVAR,DXVAR,IPRINT,NFUN,NW,
     &                WDUMMY,COV,XSTEP,AMPFIT)
          IFHARD = 0
          CALL DATINP(10,0)
          CALL DATINP(6,0)
          WRITE(6,*) ' **** end of fit program ****'
          WRITE(10,*) ' **** end of fit program ****'
C
C  output of graphic tables, energy dependence
        ELSE IF(CNAME.EQ.'ECM-TABLE ') THEN
          READ(NUMBER,*) ELOWER,EUPPER,NTAB
          WRITE(6,*)
     &    ' **** begin of energy table ****'
          WRITE(10,*)
     &    ' **** begin of energy table ****'
          WRITE(6,*) '  E_min = ',ELOWER
          WRITE(6,*) '  E_max = ',EUPPER
          WRITE(6,*) '  Steps = ',NTAB
          CALL FITPAR(1)
          DELTA=(LOG(EUPPER)-LOG(ELOWER))/DBLE(NTAB)
          ETAB=LOG(ELOWER)-DELTA
          F = 1.D0
          IF(IFPAP(1).EQ.22) F = F*1000.D0
          IF(IFPAP(2).EQ.22) F = F*1000.D0
C  write out data
          WRITE(6,*)
     &' ECMS / W / SIGTOT/SIGEL/SIGIN / SIGSD,SIGSD(1,2),SIGDD / SLOPE'
          WRITE(10,*)
     &' ECMS / W / SIGTOT/SIGEL/SIGIN / SIGSD,SIGSD(1,2),SIGDD / SLOPE'
 18       FORMAT(10E11.4)
          DO 2000 I=1,NTAB+1
             ETAB=ETAB+DELTA
             EE=EXP(ETAB)
             ECM = EE
             CALL POXSEC(1,EE)
             SIGSDI(1) = SIGLSD(1)+SIGHSD(1)
             SIGSDI(2) = SIGLSD(2)+SIGHSD(2)
             SIGDDI = SIGLDD+SIGHDD
             WRITE(10,18) EE,EE*EE,SIGTOT*F,SIGELA*F,
     &         SIGINE*F,(SIGSDI(1)+SIGSDI(2))*F,
     &         SIGSDI(1)*F,SIGSDI(2)*F,SIGDDI*F,SLOEL
             WRITE(6,18) EE,EE*EE,SIGTOT*F,SIGELA*F,
     &         SIGINE*F,(SIGSDI(1)+SIGSDI(2))*F,
     &         SIGSDI(1)*F,SIGSDI(2)*F,SIGDDI*F,SLOEL
 2000     CONTINUE
          ETAB=LOG(ELOWER)-DELTA
          WRITE(6,*)
     &' ECMS / W / SIGEL / RHO / OMEGA / PHI / SIGCDD / LMSD / HMSD '
          WRITE(10,*)
     &' ECMS / W / SIGEL / RHO / OMEGA / PHI / SIGCDD / LMSD / HMSD '
 19       FORMAT(11E11.4)
          DO 2005 I=1,NTAB+1
             ETAB=ETAB+DELTA
             EE=EXP(ETAB)
             ECM = EE
             CALL POXSEC(1,EE)
             WRITE(10,19) EE,EE*EE,SIGELA*F,(SIGVM(K,0)*F,K=1,3),
     &         SIGCDF*F,SIGLSD(1)*F,SIGLSD(2)*F,SIGHSD(1)*F,
     &         SIGHSD(2)*F
             IF(IFPAP(1).EQ.22) THEN
               WRITE(6,19)  EXP(ETAB),SIGELA*F,(SIGVM(K,0)*F,K=1,3),
     &           SIGCDF*F,SIGLSD(1)*F,SIGLSD(2)*F,SIGHSD(1)*F,
     &           SIGHSD(2)*F
             ELSE IF(IFPAP(2).EQ.22) THEN
               WRITE(6,19) EE,EE*EE,SIGELA*F,(SIGVM(0,K)*F,K=1,3),
     &           SIGCDF*F,SIGLSD(1)*F,SIGLSD(2)*F,SIGHSD(1)*F,
     &           SIGHSD(2)*F
             ENDIF
 2005     CONTINUE
          WRITE(6,*) ' **** end of energy table ****'
          WRITE(10,*) ' **** end of energy table ****'
C
C  output of graphic tables, virtuality dependence
        ELSE IF(CNAME.EQ.'VIR-TABLE ') THEN
          READ(NUMBER,*) EE,ISIDE,VLOWER,VUPPER,NTAB
          VLOWER = ABS(VLOWER)
          VUPPER = ABS(VUPPER)
          WRITE(6,*)
     &    ' **** begin of virtuality table ****'
          WRITE(10,*)
     &    ' **** begin of virtuality table ****'
          WRITE(6,*) '  Energy   = ',EE
          WRITE(6,*) '  Side     = ',ISIDE
          WRITE(6,*) '  P**2_min = ',VLOWER
          WRITE(6,*) '  P**2_max = ',VUPPER
          WRITE(6,*) '  Steps    = ',NTAB
          WRITE(10,*) '  Energy   = ',ECM
          WRITE(10,*) '  Side     = ',ISIDE
          CALL FITPAR(1)
          DELTA=(LOG(VUPPER)-LOG(VLOWER))/DBLE(NTAB)
          VTAB=LOG(VLOWER)-DELTA
          ECM = EE
          F = 1.D0
          IF(IFPAP(1).EQ.22) F = F*1000.D0
          IF(IFPAP(2).EQ.22) F = F*1000.D0
C  write out data
          WRITE(6,*)
     &' P**2 / SIGTOT / SIGEL / SIGIN / SIGSD,SIGSD(1,2),SIGDD / SLOPE'
          WRITE(10,*)
     &' P**2 / SIGTOT / SIGEL / SIGIN / SIGSD,SIGSD(1,2),SIGDD / SLOPE'
          DO 2010 I=1,NTAB+1
             VTAB=VTAB+DELTA
             PVIRT(ISIDE)=SQRT(EXP(VTAB))
             CALL POXSEC(1,EE)
             SIGSDI(1) = SIGLSD(1)+SIGHSD(1)
             SIGSDI(2) = SIGLSD(2)+SIGHSD(2)
             SIGDDI = SIGLDD+SIGHDD
             WRITE(10,18) EXP(VTAB),SIGTOT*F,SIGELA*F,
     &         SIGINE*F,(SIGSDI(1)+SIGSDI(2))*F,
     &         SIGSDI(1)*F,SIGSDI(2)*F,SIGDDI*F,SLOEL
             WRITE(6,18)  EXP(VTAB),SIGTOT*F,SIGELA*F,
     &         SIGINE*F,(SIGSDI(1)+SIGSDI(2))*F,
     &         SIGSDI(1)*F,SIGSDI(2)*F,SIGDDI*F,SLOEL
 2010     CONTINUE
          VTAB=LOG(VLOWER)-DELTA
          WRITE(6,*)
     &' Table: P**2 / SIGEL / RHO / OMEGA / PHI / LMSD / HMSD '
          WRITE(10,*)
     &' Table: P**2 / SIGEL / RHO / OMEGA / PHI / LMSD1,2 / HMSD1,2 '
          DO 2015 I=1,NTAB+1
             VTAB=VTAB+DELTA
             PVIRT(ISIDE)=SQRT(EXP(VTAB))
             CALL POXSEC(1,EE)
             WRITE(10,19) EXP(VTAB),SIGELA*F,(SIGVM(K,0)*F,K=1,3),
     &         SIGLSD(1)*F,SIGLSD(2)*F,SIGHSD(1)*F,SIGHSD(2)*F
             IF(IFPAP(1).EQ.22) THEN
               WRITE(6,19)  EXP(VTAB),SIGELA*F,(SIGVM(K,0)*F,K=1,3),
     &           SIGLSD(1)*F,SIGLSD(2)*F,SIGHSD(1)*F,SIGHSD(2)*F
             ELSE IF(IFPAP(2).EQ.22) THEN
               WRITE(6,19)  EXP(VTAB),SIGELA*F,(SIGVM(0,K)*F,K=1,3),
     &           SIGLSD(1)*F,SIGLSD(2)*F,SIGHSD(1)*F,SIGHSD(2)*F
             ENDIF
 2015     CONTINUE
          WRITE(6,*) ' **** end of virtuality table ****'
          WRITE(10,*) ' **** end of virtuality table ****'
C
C  test run to produce output table of input cross sections
        ELSE IF(CNAME.EQ.'INP-TABLE ') THEN
 20       FORMAT(10E11.4)
          READ(NUMBER,*) ELOWER,EUPPER,NTAB
          WRITE(6,*)
     &    ' **** begin of input cross section table ****'
          WRITE(10,*)
     &    ' **** begin of input cross section table ****'
          CALL FITPAR(1)
          WRITE(6,*) '  E_min = ',ELOWER
          WRITE(6,*) '  E_max = ',EUPPER
          WRITE(6,*) '  Steps = ',NTAB
          DELTA=(LOG(EUPPER)-LOG(ELOWER))/DBLE(NTAB)
          ETAB=LOG(ELOWER)-DELTA
          FAC = (VDMQ2F(1)+VDMQ2F(2))*(VDMQ2F(3)+VDMQ2F(4))
          F = 1.D0
          IF(IFPAP(1).EQ.22) F = F*1000.D0
          IF(IFPAP(2).EQ.22) F = F*1000.D0
          FF = F*FAC
          PMASS1 = PMASS(1)
          IF(IFPAP(1).EQ.22) PMASS1 = 0.766D0
          PMASS2 = PMASS(2)
          IF(IFPAP(2).EQ.22) PMASS2 = 0.766D0
          WRITE(6,*)
     &      ' E, SIGP, SIGR, SIGHD, SIGHR, SIGT1, SIGT2, SIGL'
          WRITE(10,*)
     &      ' E, SIGP, SIGR, SIGHD, SIGHR, SIGT1, SIGT2, SIGL'
          DO 3000 I=1,NTAB+1
             ETAB = ETAB+DELTA
             ECM = EXP(ETAB)
             CALL INPCS(1,PMASS1,PMASS2,PMASS1,PMASS2)
             SIGHD=DSIGH(15)
             SIGHR=DSIGH(9)
             WRITE(6,20)
     &         EXP(ETAB),DREAL(SIGP)*FF,DREAL(SIGR)*FF,DREAL(SIGHD)*F,
     &         DREAL(SIGHR)*F,DREAL(SIGT1(1))*FF,DREAL(SIGT1(2))*FF,
     &         DREAL(SIGT2(1))*FF,DREAL(SIGT2(2))*FF,
     &         DREAL(SIGL)*FF
             WRITE(10,20)
     &         EXP(ETAB),DREAL(SIGP)*FF,DREAL(SIGR)*FF,DREAL(SIGHD)*F,
     &         DREAL(SIGHR)*F,DREAL(SIGT1(1))*FF,DREAL(SIGT1(2))*FF,
     &         DREAL(SIGT2(1))*FF,DREAL(SIGT2(2))*FF,
     &         DREAL(SIGL)*FF
 3000     CONTINUE
          WRITE(6,*)
     &    ' **** end of input cross section table ****'
          WRITE(10,*)
     &    ' **** end of input cross section table ****'
C  write out parameter table for file fitpar.dat
        ELSE IF(CNAME.EQ.'PAR-TABLE ') THEN
          CALL PARTAB(10)
          CALL PARTAB(6)
C
C  unknown data card:
        ELSE
          WRITE(6,*) ' PHOFIT: unknown data card, ENDFIT assumed'
          WRITE(6,*) '         last input: ',CNAME,NUMBER
          GOTO 1300
        ENDIF
      GOTO 1200
  900 CONTINUE
        WRITE(6,*) ' PHOFIT: ERROR: opening file ',FILENA,' ***'
        STOP
 1300 CONTINUE
      IF(IOPEN.EQ.1) THEN
C       CALL INPOUT(10)
        CLOSE(10)
      ENDIF
 1400 CONTINUE
      WRITE(6,*) ' ******** END OF PHOJET PARAMETER FIT *********'
      END
