C
C
      SUBROUTINE SDECY3(UMO,AM1,AM2,AM3,ISP)
C**********************************************************************
C
C     isotropic/anisotropic three particle decay in CM system,
C     (transversally polarized boson into three pseudo-scalar mesons)
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO   = 0.D0,
     &           OHALF  = 0.5D0,
     &           ONE    = 1.D0,
     &           TWO    = 2.D0,
     &           DEPS   = 1.D-30,
     &           EPS    = 1.D-15 )
C
      COMMON /DECPHS/ ECM(3),PCM(3),COD(3),COF(3),SIF(3)
      DIMENSION F(5),XX(5)
C
C  calculation of maximum of S2 phase space weight
      UMOO=UMO+UMO
      GU=(AM2+AM3)**2
      GO=(UMO-AM1)**2
      UFAK=1.0000000000001D0
      IF (GU.GT.GO) UFAK=0.99999999999999D0
      OFAK=TWO-UFAK
      GU=GU*UFAK
      GO=GO*OFAK
      DS2=(GO-GU)/99.D0
      AM11=AM1*AM1
      AM22=AM2*AM2
      AM33=AM3*AM3
      UMO2=UMO*UMO
      RHO2=ZERO
      S22=GU
      DO 124 I=1,100
        S21=S22
        S22=GU+(I-1.D0)*DS2
        RHO1=RHO2
        RHO2=XLAMB(S22,UMO2,AM11)*XLAMB(S22,AM22,AM33)/(S22+EPS)
        IF(RHO2.LT.RHO1) GOTO 125
  124 CONTINUE
C
  125 CONTINUE
      S2SUP=(S22-S21)/2.D0+S21
      SUPRHO=XLAMB(S2SUP,UMO2,AM11)*XLAMB(S2SUP,AM22,AM33)
     &       /(S2SUP+EPS)
      SUPRHO=SUPRHO*1.05D0
      XO=S21-DS2
      IF(GU.LT.GO.AND.XO.LT.GU) XO=GU
      IF(GU.GT.GO.AND.XO.GT.GU) XO=GU
      XX(1)=XO
      XX(3)=S22
      X1=(XO+S22)*OHALF
      XX(2)=X1
      F(3)=RHO2
      F(1)=XLAMB(XO,UMO2,AM11)*XLAMB(XO,AM22,AM33)/(XO+EPS)
      F(2)=XLAMB(X1,UMO2,AM11)*XLAMB(X1,AM22,AM33)/(X1+EPS)
      DO 126 I=1,16
        X4=(XX(1)+XX(2))*OHALF
        X5=(XX(2)+XX(3))*OHALF
        F(4)=XLAMB(X4,UMO2,AM11)*XLAMB(X4,AM22,AM33)/(X4+EPS)
        F(5)=XLAMB(X5,UMO2,AM11)*XLAMB(X5,AM22,AM33)/(X5+EPS)
        XX(4)=X4
        XX(5)=X5
        DO 128 II=1,5
          IA=II
          DO 131 III=IA,5
            IF(F(II).LT.F(III)) THEN
              FH=F(II)
              F(II)=F(III)
              F(III)=FH
              FH=XX(II)
              XX(II)=XX(III)
              XX(III)=FH
            ENDIF
 131      CONTINUE
 128    CONTINUE
        SUPRHO=F(1)
        S2SUP=XX(1)
        DO 129 II=1,3
          IA=II
          DO 130 III=IA,3
            IF (XX(II).LT.XX(III)) THEN
              FH=F(II)
              F(II)=F(III)
              F(III)=FH
              FH=XX(II)
              XX(II)=XX(III)
              XX(III)=FH
            ENDIF
 130      CONTINUE
 129    CONTINUE
 126  CONTINUE
C
      AM23=(AM2+AM3)**2
C
C  selection of S1
      ITH=0
 200  CONTINUE
        ITH=ITH+1
        IF(ITH.GT.200) THEN
          WRITE(6,'(/1X,A,I10)') 'SDECY3:ERROR:TOO MANY ITERATIONS',
     &      ITH
          CALL POABRT
        ENDIF
        S2=AM23+RNDM(AM2)*((UMO-AM1)**2-AM23)
        Y=RNDM(AM23)*SUPRHO
        RHO=XLAMB(S2,UMO2,AM11)*XLAMB(S2,AM22,AM33)/S2
      IF(Y.GT.RHO) GOTO 200
C
C  selection of S2
      S1=RNDM(AM2)*RHO+AM11+AM22-(S2-UMO2+AM11)*(S2+AM22-AM33)
     &   /(2.D0*S2)-RHO/TWO
      S3=UMO2+AM11+AM22+AM33-S1-S2
      ECM(1)=(UMO2+AM11-S2)/UMOO
      ECM(2)=(UMO2+AM22-S3)/UMOO
      ECM(3)=(UMO2+AM33-S1)/UMOO
      PCM(1)=SQRT((ECM(1)+AM1)*(ECM(1)-AM1))
      PCM(2)=SQRT((ECM(2)+AM2)*(ECM(2)-AM2))
      PCM(3)=SQRT((ECM(3)+AM3)*(ECM(3)-AM3))
C
C  calculation of angles: TH between p1,p2; TH1 p3,p1; TH2 p3,p2
      IF((PCM(1).LE.EPS).OR.(PCM(2).LE.EPS)) THEN
        COSTH=(RNDM(S1)-OHALF)*TWO
      ELSE
        COSTH=(ECM(1)*ECM(2)+OHALF*(AM11+AM22-S1))/(PCM(1)*PCM(2))
      ENDIF
*     IF(ABS(COSTH).GT.0.999999999999D0)
*    &  COSTH=SIGN(0.99999999999D0,COSTH)
      COSTH2=(PCM(3)*PCM(3)+PCM(2)*PCM(2)-PCM(1)*PCM(1))
     &        /(TWO*PCM(2)*PCM(3))
*     IF(ABS(COSTH2).GT.0.99999999999D0)
*    &  COSTH2=SIGN(0.9999999999D0,COSTH2)
      SINTH2=SQRT(ONE-COSTH2*COSTH2)
      SINTH1=COSTH2*SQRT(ONE-COSTH*COSTH)-COSTH*SINTH2
      COSTH1=COSTH*COSTH2+SINTH2*SQRT(ONE-COSTH*COSTH)
C
C  selection of the sperical coordinates of particle 3
      CALL SFECFE(SIF(3),COF(3))
      IF(ISP.EQ.0) THEN
C  no polarization
        COD(3)  = TWO*RNDM(S2)-ONE
      ELSE IF(ISP.EQ.1) THEN
C  transverse polarization
 400    CONTINUE
          COD(3)  = TWO*RNDM(S1)-ONE
          SID32 = ONE-COD(3)*COD(3)
        IF(SID32.LT.RNDM(COSTH)) GOTO 400
      ELSE IF(ISP.EQ.2) THEN
C  longitudinal polarization
 500    CONTINUE
          COD(3)  = TWO*RNDM(COSTH2)-ONE
          COD32 = COD(3)*COD(3)
        IF(COD32.LT.RNDM(SINTH1)) GOTO 500
      ELSE
        WRITE(6,'(/1X,A,I3)') 'SDECY3:ERROR:INVALID POLARIZATION',ISP
        CALL POABRT
      ENDIF
C
C  selection of the rotation angle of p1-p2 plane along p3
      IF(ISP.EQ.0) THEN
        CALL SFECFE(SFE,CFE)
      ELSE
        SFE = ZERO
        CFE = ONE
      ENDIF
      CX11=-COSTH1
      CY11=SINTH1*CFE
      CZ11=SINTH1*SFE
      CX22=-COSTH2
      CY22=-SINTH2*CFE
      CZ22=-SINTH2*SFE
C
      SID3 = SQRT((ONE+COD(3))*(ONE-COD(3)))
      COD(1)=CX11*COD(3)+CZ11*SID3
      IF((ONE-COD(1)*COD(1)).LT.DEPS) THEN
        WRITE(6,'(1X,A,5E12.4)') 'SDECY3:WARNING:COS(TH1) > 1',
     &    COD(1),COF(3),SID3,CX11,CZ11
        CALL POPREV(-1)
      ENDIF
      SID1=SQRT((ONE+COD(1))*(ONE-COD(1)))
      COF(1)=(CX11*SID3*COF(3)-CY11*SIF(3)-CZ11*COD(3)*COF(3))/SID1
      SIF(1)=(CX11*SID3*SIF(3)+CY11*COF(3)-CZ11*COD(3)*SIF(3))/SID1
      COD(2)=CX22*COD(3)+CZ22*SID3
      SID2=SQRT((ONE+COD(2))*(ONE-COD(2)))
      COF(2)=(CX22*SID3*COF(3)-CY22*SIF(3)-CZ22*COD(3)*COF(3))/SID2
      SIF(2)=(CX22*SID3*SIF(3)+CY22*COF(3)-CZ22*COD(3)*SIF(3))/SID2
      END
