C
C
      SUBROUTINE SEAFLA(IPAR,IFL1,IFL2,CHMASS)
C**********************************************************************
C
C     selection of sea flavour content of particle IPAR
C
C     input:    IPAR    particle index in common HEPEVS
C               CHMASS  available invariant chain mass
C                       positive mass --> use BAMJET method
C                       negative mass --> SU(3) symmetric sea according
C                       to values given in PARMDL(1-6)
C               IPAR    -1 initialization
C                       -2 output of statistics
C
C     output:   sea flavours according to PDG conventions
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           THREE  =  3.D0,
     &           OHALF  =  0.5D0,
     &           EPS    =  0.1D0,
     &           DEPS   =  1.D-40)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
      COMMON /HADRON/ QMASS(6),BET,PCOUDI,PNORM,VALPRG(2),NFS
C
      IF(IPAR.GT.0) THEN
        IF((ISWMDL(20).EQ.1).OR.(CHMASS.LT.ZERO)) THEN
C  constant weights for sea
          SUM = ZERO
          DO 40 K=1,NFSEA
            SUM = SUM + PARMDL(K)
 40       CONTINUE
          XI = RNDM(SUM)*SUM
          SUM = ZERO
          DO 50 K=1,NFSEA
            SUM = SUM + PARMDL(K)
            IF(XI.LE.SUM) GOTO 55
 50       CONTINUE
 55       CONTINUE
          K = MIN(K,NFSEA)
        ELSE
C  mass dependent flavour sampling
 10       CONTINUE
            CALL FLAUX(CHMASS,K)
          IF(K.GT.NFSEA) GOTO 10
        ENDIF
        IF(RNDM(CHMASS).GT.OHALF) K = -K
        IFL1 = K
        IFL2 = -K
        IF(IDEB(46).GE.10) THEN
          WRITE(6,'(1X,A,3I5,E12.4)') 'SEAFLA:IPAR,IFL1,IFL2,MASS',
     &      IPAR,IFL1,IFL2,CHMASS
        ENDIF
      ELSE IF(IPAR.EQ.-1) THEN
C  initialization
        NFSEA = NFS
      ELSE IF(IPAR.EQ.-2) THEN
C  output of statistics
      ELSE
        WRITE(6,'(1X,A,I10)') 'SEAFLA:ERROR:INVALID IPAR',IPAR
        CALL POABRT
      ENDIF
      END
