C
C
      SUBROUTINE SELSX2(XPOT1,XPOT2,XSUM1,XSUM2,XMAX1,XMAX2,
     &                  XS1,XS2,IREJ)
C***********************************************************************
C
C    select x values of soft chain ends using BETARN
C
C***********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      DIMENSION XPOT1(50),XPOT2(50),XS1(50),XS2(50)
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      COMMON /HASCA / PTWANT,AS,AH,ALNS,ALNH,Z1MAX,Z1DIF,Z2MAX,Z2DIF,
     &                PT,ETAC,ETAD,X1,X2,V,U,QQPD,QQAL,
     &                W,W1,AXX,WEIGHT,MSPR,IREJSC
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
      COMMON /CUTOFF/ PTCUT(4),CUTMU(4),FPS(4),FPH(4),PSOMIN,XSOMIN
C
      IF(IDEB(32).GE.10) THEN
        WRITE(6,'(1X,A)') 'SELSX2:DEBUG:'
        WRITE(6,'(5X,A,5E11.3)') 'AS,XSUM1,2,XMAX1,2',
     &    AS,XSUM1,XSUM2,XMAX1,XMAX2
        DO 30 I=1,2
          WRITE(6,'(5X,A,I4,2E12.3)') 'EXPONENTS',I,XPOT1(I),XPOT2(I)
 30     CONTINUE
      ENDIF
C
      XMIN  = MAX(PSOMIN/ECM*TWO,XSOMIN)
      XMIN1 = MAX(AS/XMAX2,XMIN)
      XMIN2 = MAX(AS/XMAX1,XMIN)
      IF((XMIN1.GE.XMAX1).OR.(XMIN2.GE.XMAX2)) THEN
        IF(IDEB(32).GE.1) THEN
          WRITE (6,'(1X,A,4E12.3)')
     &      'SELSX2:WARNING:XMIN>XMAX (XMIN1,2/XMAX1,2)',
     &      XMIN1,XMIN2,XMAX1,XMAX2
          CALL POPREV(-1)
        ENDIF
        IREJ = 1
        RETURN
      ENDIF
C
      IREJ = 0
      FAC1 = ONE-XSUM1
      FAC2 = ONE-XSUM2
      FAC = FAC1*FAC2
      GAM1 = XPOT1(1)+ONE
      GAM2 = XPOT2(1)+ONE
      BET1 = XPOT1(2)+ONE
      BET2 = XPOT2(2)+ONE
C
      DO 100 I=1,100
 10     CONTINUE
        X1 = BETARN(GAM1,BET1)
        X2 = BETARN(GAM2,BET2)
        X3 = ONE - X1
        X4 = ONE - X2
        IF(X1*X2*FAC.GT.AS) THEN
          IF(X3*X4*FAC.GT.AS) THEN
            XS1(1) = X1*FAC1
            XS1(2) = X3*FAC1
            XS2(1) = X2*FAC2
            XS2(2) = X4*FAC2
            XSUM1 = XSUM1+XS1(2)
            XSUM2 = XSUM2+XS2(2)
            GOTO 300
          ENDIF
        ENDIF
 100  CONTINUE
      IREJ = 1
      IF(IDEB(32).GE.2)
     &  WRITE(6,'(1X,A,I9)') 'SELSX2:REJECTION:EVENT',KEVENT
 300  CONTINUE
C  debug output
      IF(IDEB(32).GE.10) THEN
        WRITE(6,'(1X,A,2E12.4)') 'SELSX2:DEBUG:XSUM1,2:',XSUM1,XSUM2
        DO 20 I=1,2
          WRITE(6,'(5X,A,I4,2E12.3)') '     XSOFT',I,XS1(I),XS2(I)
 20     CONTINUE
      ENDIF
      END
