
      SUBROUTINE GRAGEN

*#**********************************************************************
*#
*#    SUBROUTINE GRAGEN
*#
*# PURPOSE: PROVIDES INFORMATION DERIVED FROM RAPGAP 2.03/06 FOR GENOUT
*#          common /CGEN/
*#
*# INPUT: GENOUT/JETSET common /HEPEVT/
*#
*# OUTPUT: GENOUT common /CGEN/
*#
*# CALLED BY: GENFIL
*#
*# AUTHOR: Guenter Grindhammer             CREATED AT: 91/06/07
*#
*# CHANGED BY: H. JUNG                             AT:94/01/11
*# REASON: UPDATED FOR RAPGAP
*#
*# CHANGED BY: J.P.Phillips                        AT:96/09/13
*# REASON: Modified to take account of REAL*8 PHEP (plus ca change...)
*#
*#**********************************************************************

C---JETSET and GENOUT common
#include "hepevt.inc"
C---GENOUT commons
#include "h1mcutil/comdef/cgen.inc"

C---find index of the incident lepton beam/target (e-+ or mu-+) and
C   proton beam/target or skip routine
      ID1 = IABS(IDHEP(1))
      ID2 = IABS(IDHEP(2))
      IF (ID1.EQ.11 .OR. ID1.EQ.13 .OR. ID1.EQ.22) THEN
         INLEP = 1
         INPRO = 2
      ELSEIF (ID2.EQ.11 .OR. ID2.EQ.13 .OR. ID2.EQ.22) THEN
         INLEP = 2
         INPRO = 1
      ELSE
         PLBEAM = -99999.
         PPBEAM = -99999.
         POL = -99999.
         BFIELD = -99999.
         RETURN
      ENDIF

C---incident lepton and proton beam momentum (before radiation)
C      WRITE(6,*)'INLEP,INPRO',INLEP,INPRO

C      WRITE(6,*)'PROTON',PHEP(1,INPRO),PHEP(2,INPRO),PHEP(3,INPRO),
C     &                   PHEP(4,INPRO)
C      WRITE(6,*)'LEPTON',PHEP(1,INLEP),PHEP(2,INLEP),PHEP(3,INLEP),
C     &                   PHEP(4,INLEP)

      PLBEAM = -SNGL(DSQRT(PHEP(1,INLEP)**2
     &                   +PHEP(2,INLEP)**2+PHEP(3,INLEP)**2))
      PPBEAM = SNGL(DSQRT(PHEP(1,INPRO)**2
     &                   +PHEP(2,INPRO)**2+PHEP(3,INPRO)**2))
C      WRITE(6,*)'PLBEAM,PPBEAM',PLBEAM,PPBEAM
      POL = 0.0
      BFIELD = 0.0

      RETURN
      END

