
      SUBROUTINE GRAPGA


*#**********************************************************************
*#
*#    SUBROUTINE GRAPGA
*#
*# PURPOSE: Main steering routine for the generation of (e-p) events
*#          WITH RAPGAP
*#
*# CALLED BY: H1GEN
*#
*# CALLING: GRAINI,GRACHA,GRAINI,GJECHA,GENFIL,GUBEG,EVENT,
*#          GUANA,GRAEND,GUEND,MODULS,MDB,MODULF,LULIST,BPRNT
*#
*# AUTHOR: HANNES  JUNG            CREATED AT: 94/01/11
*#
*# CHANGED BY: Julian Phillips             AT: 96/10/01
*# REASON: Add output variable IWRITE to specify write to BOSOUTPUT
*#         (used for simple weighting in Q2)
*#
*#**********************************************************************

#include "h1mcutil/comdef/cbosmdl.inc"
#include "h1util/jobnr/cjobnr.inc"
#include "h1util/jobnr/h1unit.inc"
#include "h1mcutil/comdef/cbcs.inc"
#include "rgluco.inc"
      logical writeevent 
      COMMON/DIVO/ NDIM,NPOIN

      CHARACTER*8     VERSQQ
      INTEGER         IEV,IVERSQ,IDATQQ,ITIMQQ,MDB,IWRITE

      DATA IEV /0/

#include "versqq.inc"
c        External pydata

C  status of random number generator draprn is written before event to
C  bank MODR if IVERSQ < 0
      CALL MODULS('GRAP',-IVERSQ,'0')

      BEGRUN = BEGJOB
      ENDRUN = ENDJOB
      REVENT = .NOT.BEGJOB .AND. .NOT.ENDJOB
      OTHDAT = .FALSE.

C Return to specify write to BOSOUTPUT
      IWRITE = 1

      IF (BEGJOB) THEN

#include "dateqq.inc"
#include "timeqq.inc"

         WRITE(6,10000) VERSQQ,IDATQQ,ITIMQQ
10000    FORMAT(
     +'1**********************************************************'/
     +' ******    RAPGAP     ',A8,'                 ******'/
     +' ******    compiled at date ',I6,'  and time ',I4,'    ******'/
     +' *********************************************************'/)

C---get run number from H1 database
         NCCRUN = MDB('/RUN')


C---initialise PYTHIA6.2 parameters
         CALL GPYINI
C pythia block data taken via external statement
c         write(6,*) ' grapga: PYTHIA block data taken '
C---INITIALISE RAPGAP  PARAMETERS
         CALL GRAINI
C---CHANGE RAPGAP PARAMETERS USING THE GENERATOR STEERING BANK (GRAP)
         CALL GRACHA
C---change JETSET/PYTHIA parameters using the generator steering bank (GJET)
         CALL GPYCHA

C---CHANGE HERACLES PARAMETERS USING GENERATOR STEERING BANK (GDJG)
         CALL GDJCHA
	   
C---possibly modify LHAPDF parameters via LHAP bank
C   (only needed if run with LHAPDF instead of PDFLIB)
#if ( defined(LHAPDF) )
         CALL GLHCHA
#endif


C---fill commons for GENOUT and create generator banks
C   (all parameters must have been set)
         CALL GENFIL

C---for testing only: print generator banks of begin run record
C        CALL BPRNT(IW,'E')
         IF(IFPS.EQ.10) THEN
* change parameters according to generator steering bank (GARI)
#if ( defined(ariadne410) )
            write(6,*) ' in version for ariadne 410 '
* initialise ARIADNE 4.0 parameters
            CALL GARINI
* change parameters according to generator steering bank (GARI)
            CALL GARCHA
            CALL ARINIT('RAPGAP')

            write(6,*) ' end  version for ariadne 410 '
#endif
#if ( !defined(ariadne410) )
            write(6,*) ' in version for ariadne 412 '
* initialise ARIADNE 4.12 parameters
            CALL ARINIT('RAPGAP')
* change parameters according to generator steering bank (GARI)
            CALL GARCHA
            write(6,*) ' end  version for ariadne 412 '
#endif

         ENDIF
C HERE CALCULATE X SECTION ETC....

         CALL RAPGAP
         CALL RAEND(1)

C---begin of job routine for the user
         CALL GUBEG
C        WRITE(6,*) ' AFTER GUBEG   '

      ENDIF

C--------------------GENERATE NEXT EVENT------------------------------

      IF (REVENT) THEN
         IEV = IEV + 1
         NEVENT = IEV
   10    CONTINUE

         writeevent=.false. 
111	   continue
C---generate an event
         CALL EVENT
         call McWeight2(writeevent)
	   if(.not.writeevent) goto 111
	   
c        WRITE(6,*) ' IN EVENT LOOP after event',NEVENT

C Weighted rejection now done directly in EVENT
C         CALL GRAWQ2(IWRITE)

C---fill commons for GENOUT and create generator banks
C         IF(IWRITE.EQ.1) CALL GENFIL
         CALL GENFIL
         call McWeight3(writeevent)

C---for testing only: print generator banks for a few events
C        IF (IEV .LT. 3) CALL BPRNT(IW,'E')
c         IF (IEV .LT. 3) CALL H1PRNT('GEVC',0)
c         IF (IEV .LT. 3) CALL H1PRNT('GHD ',0)
c         IF (IEV .LT. 3) CALL H1PRNT('GKI ',0)
C        IND=NPRNT('GKI ',0)
c         IF (IEV .LT. 3) CALL H1PRNT('GTR ',0)
c         IF (IEV .LT. 3) CALL H1PRNT('GVX ',0)
c
C---event analysis for the user
         CALL GUANA
      ENDIF

C-------------------END OF EVENT GENERATION --------------------------

      IF (ENDJOB) THEN

C---fill commons for GENOUT and create generator bank
C   total number of events and cross section(s)
         CALL GENFIL

C---for testing only: print generator bank GEND
C        CALL BPRNT(IW,'E')
C---PRINT NROF GENERATED EVENTS
         CALL RAEND(20)
         CALL H1PRNT('GEND',0)

C---end of job routine for the user
         CALL GUEND

      ENDIF

      CALL MODULF

      RETURN
      END
