

      PROGRAM H1GEN

*#**********************************************************************
*#
*#    PROGRAM H1GEN
*#
*# PURPOSE:  Main program for modular steering of event generation.
*#
*# AUTHOR: Guenter Grindhammer     CREATED AT: 91/05/28
*#
*# CALLING: BNAMES,BOS,BREADC,INSTCA,draprnIN,BFSEQR,GJPSII,FSEQW
*#
*#
*# CHANGED BY:                              AT:
*# REASON:
*#
*#**********************************************************************

C JPP - Use H1 macros
#include "h1mcutil/comdef/cbosmdl.inc"
#include "h1util/jobnr/cjobnr.inc"
#include "h1util/jobnr/h1unit.inc"
c#include "h1mcutil/comdef/cbcs.inc"
      INTEGER      NHROW,NHCOL,NHLEN
      PARAMETER   (NHROW = 2, NHCOL = 1, NHLEN=2)
      INTEGER      NBOSIW
      PARAMETER   (NBOSIW=1000000)
      INTEGER      IW(NBOSIW)
      REAL         RW(NBOSIW)
      COMMON /BCS/ IW
      EQUIVALENCE (RW(1),IW(1))
      SAVE   /BCS/
	
#if ( defined(H1_VAX) )
*   add error handler for VAX
      CALL UERRHD
*   open steering file(s) readonly/shared
      CALL OPTXFL
#endif


*
*     initialize BOS
*
      CALL BNAMES(1000)
      CALL BOS(IW,NBOSIW)
*
*     read i/o commands and steering banks
* JPP
* Reserve units 11 and 30 for non-fpack use
** 11 is used for HERACLES output
** 30 is used for structure function input
      CALL FRESER(11)
      CALL FRESER(30)

      CALL FPARMR(5)
      CALL BREADC
*
*     check for input file:
*
      IF(IFRST('BOSINPUT',0).NE.0)THEN
         INBOS='BOSINPUT'
      ELSE IF (IFRST('OLDBOS',0).NE.0)THEN
         INBOS='OLDBOS'
      ELSE
         INBOS=' '
      ENDIF

* --- get next job number
*
      JOBNR = MDB('/JOB')
*
* --- initialize random number generator by ISEED value
* 1) check whether RNIN steering bank exists. If yes, take its first
*    word for ISEED. This can be used for debugging, if the user wants
*    to produce the same sequence once more.
* 2) else if H1 data base is written to (i.e. for official production)
*    then the next JOBNR is taken for ISEED.
* 3) else (i.e. for private production) JOBNR=0. In this case the
*    approximate number of minuts since 06.06.1991 or better that of
*    seconds since 17.09.2003 is used.
*
      irnin = 0
      irnin = NLINK('RNIN',0)
      IF (irnin.GT.0) THEN
         ISEED = IW(irnin+1)
         PRINT*,'H1GEN: ISEED = ',ISEED,' from RNIN bank'
      ELSEIF (JOBNR.GT.4) THEN
         ISEED = JOBNR + 1
         PRINT*,'H1GEN: ISEED = ',ISEED,' from JOBNR'
      ELSE
c        ISEED = MINUTS()
         ISEED = NSECONDS()
         PRINT*,'H1GEN: ISEED = ',ISEED,' from NSECONDS'
      ENDIF
*
      IF (ISEED.LT.0) THEN
         ISEED = -ISEED
         PRINT*,'       ISEED is converted to ',ISEED,' !!!'
      ENDIF
      CALL H1RNIN(ISEED)


      N1=0
	N2=0
	J1SEED = IABS(ISEED)
      CALL RM48IN(J1SEED,N1,N2)
      WRITE(6,'(A,I12)') ' H1RN (RM48) initialized from seed: ',J1SEED
* ---- event processing loop ------------------------------------------
*
   10 CALL FSEQR(INBOS,IRET)

      IF (IRET.LT.0) GOTO 20
      CALL GRAPGA
*rw      CALL FSEQW('BOSOUTPUT')
*rw*****************************************
C---  My data selection:
*rw      IA=IA+1
*rw      print*,"*******IA=", IA

      ISEL=0
      CALL GKP(ISEL)
      IF (ISEL.GT.0) THEN 
         CALL FSEQW('BOSOUTPUT')

*rw         IF( IA .LE. 30 ) THEN
*            CALL H1PRNT('GEVC',0)
*            CALL H1PRNT( 'GKI ', 0 )
*            CALL H1PRNT( 'GTR ', 0 )
*            CALL H1PRNT( 'GVX ', 0 )
*wr         END IF
      ENDIF
*rw*****************************************

#if ( defined(H1_H1PHAN) )
      CALL H1PHAN
#endif


      GOTO 10
*
*     perform final book keeping

   20 CONTINUE
*      CALL FPARM('CLOSE ALL')

*rw*****************************************
C---  Print out of selected events
      CALL PKP
*rw*****************************************

      IND=MDB('/END')
      STOP
      END



*CMZ :          04/04/2000  14.36.11  by  R. Gerhards
*-- Author :
      SUBROUTINE GKP (IACEPT)
C-----------------------------------------------------------------------
C
C SUBROUTINE : GKP
C CALLED BY  :
C AUTHOR     : U. KATHAGE 05/12/94
C
C PURPOSE    : SEARCH FOR D* (GTR BANK)
C              VIA DECAY CHANNEL :
C              D*+ --> D0 Pi+
C                      |
C                      --> K- Pi+
C
C INPUT      :
C
C OUTPUT     : IACEPT - RETURN FLAG
C              -1     - NO GTR BANK AVAILABLE
C              -2     - FATAL ERROR
C               0     - NO D* FOUND
C              >0     - #  D* FOUND
C
C-----------------------------------------------------------------------

CRG   IMPLICIT NONE

      INTEGER IACEPT


C-----INCLUDE FILES
C

      PARAMETER (NBOSIW=20000)
      INTEGER      IW(NBOSIW)
      REAL         RW(NBOSIW)
      COMMON /BCS/ IW
      EQUIVALENCE (IW(1),RW(1))

C     ------BOSMDL
      LOGICAL       BEGJOB,ENDRUN,BEGRUN,REVENT,ENDJOB,OTHDAT
      COMMON/BOSMDL/BEGJOB,ENDRUN,BEGRUN,REVENT,ENDJOB,OTHDAT,
     +              LCCRUN,NCCRUN,NEVENT,
     +              IHA,IBS,IDB,IDATEL,LUP,ISN,JSN
      SAVE  /BOSMDL/


C-----PARAMETERS
C
C-----DEBUG FLAG
      LOGICAL LDEBUG
      PARAMETER (LDEBUG=.FALSE.)
C-----MAX NUMBER OF TRACKS
      INTEGER PMAX
      PARAMETER (PMAX=1000)
C-----PHYSICAL CONSTANTS
      REAL PPI
      PARAMETER (PPI=3.141592654)
      REAL PRADP
      PARAMETER (PRADP=180./PPI)
      REAL PEPS
      PARAMETER (PEPS=1.E-30)


C-----START VARIABLES
C
      LOGICAL LSTART
      DATA    LSTART / .TRUE. /


C-----GTR BANK (POINTER,#ROWS)
C
      INTEGER IQGTR,IPGTR
      INTEGER NRGTR
      DATA    IQGTR / 0 /


C-----LOOP INDICES
C
      INTEGER I,J,K


C-----COUNTING VARIABLES
C
C-----NUMBER OF D*,D*-->D0Pi,D*-->KPiPi,ACCEPTED D*-->KPiPi
      INTEGER NDS,NDP,NKPP,NACEPT

C-----ROW NUMBER IN GTR OF D*,D0,K,Pi,Ps
      INTEGER IRDS(10),IRD0(10),IRKA(10),IRPI(10),IRPS(10)


C-----VARIABLES
C
C-----NUMBER OF DAUGHTERS,ROW NUMBER IN GTR
      INTEGER NDAUG,IRDAUG(PMAX)
      INTEGER ID0CHK,IPSCHK,IKACHK,IPICHK

C-----PX,PY,PZ,PT,P,THETA
      REAL PX,PY,PZ,PT,P,THETA

      REAL PTMIN


C-----STATISTICS
C
C-----NUMBER OF EVENTS (PROCESSED,SKIPPED),NUMBER OF CCBAR
      INTEGER NEVT,NSKIP1,NSKIP2,NC, NB
C-----NUMBER OF EVENTS (0 D*,1 D*,2 D* ...)
      INTEGER NCOUNT(4,0:4)
      COMMON /CKP/ NEVT,NSKIP1,NSKIP2,NC,NB,NCOUNT


C-----------------------------------------------------------------------
C
C     C U T S   C U T S   C U T S   C U T S   C U T S   C U T S
C
C-----------------------------------------------------------------------

C-----SWITCH ON/OFF SELECTION
C
      LOGICAL LSELON
      PARAMETER (LSELON=.TRUE.)

C-----THETA(K,PI,PS) >= PTHMIN
      REAL PTHMIN
C-----THETA(K,PI,PS) <= PTHMAX
      REAL PTHMAX

C-----PT(K,PI) >= PTMIN1
      REAL PTMIN1
C-----PT(PS) >= PTMIN2
      REAL PTMIN2
C-----THETAMIN(DSTAR)
      REAL THMIND
C-----THETAMAX(DSTAR)
      REAL THMAXD
C-----PT(D*) >= PPTMIN
      REAL PPTMIN
C-----Save variables for >1. call of routine
      SAVE PTHMIN, PTHMAX, PTMIN1, PTMIN2, PPTMIN

C-----EXTERNAL FUNCTIONS
      INTEGER NAMIND


C-----STATEMENT FUNCTIONS
C
      INTEGER IND,L,IROW
      INTEGER IBTAB
      REAL    RBTAB

      LOGICAL LC,LB,LDS,LD0,LKA,LPI

      INTEGER IMOTH,ISTAT


      IBTAB(IND,L,IROW) = IW(IND+2+IW(IND+1)*(IROW-1)+L)
      RBTAB(IND,L,IROW) = RW(IND+2+IW(IND+1)*(IROW-1)+L)

      LC(IROW)  = (IABS(IBTAB(IPGTR,7,IROW)).EQ.4)
      LB(IROW)  = (IABS(IBTAB(IPGTR,7,IROW)).EQ.5)
      LDS(IROW) = (IABS(IBTAB(IPGTR,7,IROW)).EQ.413)
      LD0(IROW) = (IABS(IBTAB(IPGTR,7,IROW)).EQ.421)
      LKA(IROW) = (IABS(IBTAB(IPGTR,7,IROW)).EQ.321)
      LPI(IROW) = (IABS(IBTAB(IPGTR,7,IROW)).EQ.211)

      IMOTH(IROW) = (MOD(IBTAB(IPGTR,9,IROW),1000))
      ISTAT(IROW) = (IBTAB(IPGTR,8,IROW))


C***********************************************************************
C
C     I N I T I A L I S A T I O N
C
C***********************************************************************

      IF (LSTART) THEN

        LSTART = .FALSE.

C-------RESET COUNTERS
        NEVT   = 0
        NSKIP1 = 0
        NSKIP2 = 0

        NC     = 0

        DO I=1,4
          DO J=0,4
            NCOUNT(I,J) = 0
          ENDDO
        ENDDO

C------ READ IN CUT PARAMETERS FROM STEERING BANK

        IDCUT = nlink('DCUT',0)
        IF (IDCUT.GT.0) THEN
          PTHMIN = RW(IDCUT+1)
          PTHMAX = RW(IDCUT+2)
          PTMIN1 = RW(IDCUT+3)
          PTMIN2 = RW(IDCUT+4)
          THMIND = RW(IDCUT+5)
          THMAXD = RW(IDCUT+6)
          PPTMIN = RW(IDCUT+7)
        ELSE
          WRITE(6,1) ' '
          WRITE(6,*) 'Dstar cut steering bank DCUT not found'
          PTHMIN = 20.
          PTHMAX = 160.
          PTMIN1 = 0.2
          PTMIN2 = 0.075
          THMIND = 20.
          THMAXD = 160.
          PPTMIN = 0.
        ENDIF          

C-------PRINT HEADER
        WRITE(6,1) ' '
        WRITE(6,2)
        WRITE(6,1) 'GKP    : U. KATHAGE   DEC. 94'
        WRITE(6,1) 'D* DECAY MODE : D*+ --> D0 Pi+'
        WRITE(6,1) 'D0 DECAY MODE : D0  --> K- Pi+'
        IF (LSELON) THEN
          WRITE(6,3) 'THETA(TRACK)    > ',PTHMIN
          WRITE(6,3) 'THETA(TRACK)    < ',PTHMAX
          WRITE(6,3) 'PT(KA,PI)       > ',PTMIN1
          WRITE(6,3) 'PT(PS)          > ',PTMIN2
          WRITE(6,3) 'THETA(D*)       > ',THMIND
          WRITE(6,3) 'THETA(D*)       < ',THMAXD
          WRITE(6,3) 'PT(D*)          > ',PPTMIN
        ENDIF
        WRITE(6,2)
        WRITE(6,1) ' '

C-------GET POINTER TO GTR
        IQGTR = NAMIND('GTR ')

      ENDIF


C***********************************************************************
C
C     E V E N T   P R O C E S S I N G
C
C***********************************************************************


C-----RESET VARIABLES
C
      IACEPT = 0

      DO I=1,10
        IRDS(I) = 0
        IRD0(I) = 0
        IRKA(I) = 0
        IRPI(I) = 0
        IRPS(I) = 0
      ENDDO


C-----INCREASE EVENT COUNTER
      NEVT = NEVT + 1


C-----GET GTR BANK
      IPGTR = IW(IQGTR)
      IF (IPGTR.LE.0) THEN
        IACEPT  = -1
        NSKIP1  = NSKIP1 + 1
        GOTO 9999
      ELSE
        NRGTR = IW(IPGTR+2)
        NRGTR = MIN0(NRGTR,PMAX)
      ENDIF


C-----LOOK FOR CCBAR
C
      DO I=1,NRGTR
        IF (LC(I).AND.(ISTAT(I).NE.3)) NC = NC + 1
      ENDDO


C-----LOOK FOR BBBAR
C
      DO I=1,NRGTR
        IF (LB(I).AND.(ISTAT(I).NE.3)) NB = NB + 1
      ENDDO


C-----LOOK FOR D*
C
      NDS = 0
      DO I=1,NRGTR
        IF (LDS(I)) THEN
          NDS = NDS + 1
          IF (NDS.GT.10) THEN
            IACEPT  = -2
            NSKIP2  = NSKIP2 + 1
            GOTO 9999
          ENDIF
          IRDS(NDS) = I
          IF (LDEBUG) THEN
            WRITE(6, 1) ' '
            WRITE(6,50) 'D* FOUND # = ',NDS
            WRITE(6,50) 'D*      IROW = ',IRDS(NDS)
            WRITE(6,50) 'D* MOTH IROW = ',IBTAB(IPGTR, 9,IRDS(NDS))
            WRITE(6,50) 'D* DAUG IROW = ',IBTAB(IPGTR,11,IRDS(NDS))
          ENDIF
        ENDIF
      ENDDO

C
C-----LOOK FOR D* --> D0 PI
C
      NDP = 0
      DO I=1,NDS
        NDAUG = 0
        DO J=1,NRGTR
          IF (IMOTH(J).EQ.IRDS(I)) THEN
            NDAUG = NDAUG + 1
            IRDAUG(NDAUG) = J
          ENDIF
        ENDDO
C-------D* DECAY INTO 2 PARTICLES FOUND
        IF (NDAUG.EQ.2) THEN
          DO K=1,2
            IF (K.EQ.1) THEN
              ID0CHK = IRDAUG(1)
              IPSCHK = IRDAUG(2)
            ELSE
              ID0CHK = IRDAUG(2)
              IPSCHK = IRDAUG(1)
            ENDIF
            IF (LD0(ID0CHK).AND.LPI(IPSCHK)) THEN
              NDP = NDP + 1
              IRD0(I) = ID0CHK
              IRPS(I) = IPSCHK
              IF (LDEBUG) THEN
                WRITE(6, 1) ' '
                WRITE(6,50) 'D* --> D0 PI FOUND # = ',NDP
                WRITE(6,50) 'D*      IROW = ',IRDS(I)
                WRITE(6,50) 'D0      IROW = ',IRD0(I)
                WRITE(6,50) 'PS      IROW = ',IRPS(I)
                WRITE(6,50) 'D* MOTH IROW = ',IBTAB(IPGTR, 9,IRDS(I))
                WRITE(6,50) 'D* DAUG IROW = ',IBTAB(IPGTR,11,IRDS(I))
                WRITE(6,50) 'D0 MOTH IROW = ',IBTAB(IPGTR, 9,IRD0(I))
                WRITE(6,50) 'D0 DAUG IROW = ',IBTAB(IPGTR,11,IRD0(I))
                WRITE(6,50) 'PS MOTH IROW = ',IBTAB(IPGTR, 9,IRPS(I))
                WRITE(6,50) 'PS DAUG IROW = ',IBTAB(IPGTR,11,IRPS(I))
              ENDIF
            ENDIF
          ENDDO
        ENDIF
      ENDDO


C-----LOOK FOR D* --> D0 PI --> (K PI) PI
C
      NKPP = 0
      DO I=1,NDS
        IF (IRD0(I).GT.0) THEN
          NDAUG = 0
          DO J=1,NRGTR
            IF (IMOTH(J).EQ.IRD0(I)) THEN
              NDAUG = NDAUG + 1
              IRDAUG(NDAUG) = J
            ENDIF
          ENDDO
C---------D0 DECAY INTO 2 PARTICLES FOUND
          IF (NDAUG.EQ.2) THEN
            DO K=1,2
              IF (K.EQ.1) THEN
                IKACHK = IRDAUG(1)
                IPICHK = IRDAUG(2)
              ELSE
                IKACHK = IRDAUG(2)
                IPICHK = IRDAUG(1)
              ENDIF
              IF (LKA(IKACHK).AND.LPI(IPICHK)) THEN
                NKPP = NKPP + 1
                IRKA(I) = IKACHK
                IRPI(I) = IPICHK
                IF (LDEBUG) THEN
                  WRITE(6, 1) ' '
                  WRITE(6,50)
     +              'D* --> D0 PI --> (K PI) PI FOUND # = ',NKPP
                  WRITE(6,50) 'D*      IROW = ',IRDS(I)
                  WRITE(6,50) 'D0      IROW = ',IRD0(I)
                  WRITE(6,50) 'PS      IROW = ',IRPS(I)
                  WRITE(6,50) 'KA      IROW = ',IRKA(I)
                  WRITE(6,50) 'PI      IROW = ',IRPI(I)
                  WRITE(6,50) 'D* MOTH IROW = ',IBTAB(IPGTR, 9,IRDS(I))
                  WRITE(6,50) 'D* DAUG IROW = ',IBTAB(IPGTR,11,IRDS(I))
                  WRITE(6,50) 'D0 MOTH IROW = ',IBTAB(IPGTR, 9,IRD0(I))
                  WRITE(6,50) 'D0 DAUG IROW = ',IBTAB(IPGTR,11,IRD0(I))
                  WRITE(6,50) 'PS MOTH IROW = ',IBTAB(IPGTR, 9,IRPS(I))
                  WRITE(6,50) 'PS DAUG IROW = ',IBTAB(IPGTR,11,IRPS(I))
                  WRITE(6,50) 'KA MOTH IROW = ',IBTAB(IPGTR, 9,IRKA(I))
                  WRITE(6,50) 'KA DAUG IROW = ',IBTAB(IPGTR,11,IRKA(I))
                  WRITE(6,50) 'PI MOTH IROW = ',IBTAB(IPGTR, 9,IRPI(I))
                  WRITE(6,50) 'PI DAUG IROW = ',IBTAB(IPGTR,11,IRPI(I))
                ENDIF
              ENDIF
            ENDDO
          ENDIF
        ENDIF
      ENDDO


C-----APPLY SELECTION CRITERIA
C
      NACEPT = NKPP
      IF (LSELON) THEN
        NACEPT = 0
        DO I=1,NDS
          IF (IRKA(I).GT.0) THEN
            IRDAUG(1) = IRKA(I)
            IRDAUG(2) = IRPI(I)
            IRDAUG(3) = IRPS(I)
            IF (LDEBUG) THEN
              WRITE(6, 1) ' '
              WRITE(6,50) 'D*      IROW = ',IRDS(I)
            ENDIF
            DO J=1,3
              PTMIN = PTMIN1
              IF (J.EQ.3) PTMIN = PTMIN2
              PX = RBTAB(IPGTR,1,IRDAUG(J))
              PY = RBTAB(IPGTR,2,IRDAUG(J))
              PZ = RBTAB(IPGTR,3,IRDAUG(J))
              PT = SQRT(PX*PX + PY*PY)
              P  = SQRT(PX*PX + PY*PY + PZ*PZ)
              THETA = PRADP * ACOS(PZ/(P+PEPS))
              IF (LDEBUG) THEN
                WRITE(6,60) 'IROW/PT    : ',IRDAUG(J),PT
                WRITE(6,60) 'IROW/THETA : ',IRDAUG(J),THETA
              ENDIF
              IF (PT.LT.PTMIN)                              GOTO 100
              IF ((THETA.LT.PTHMIN).OR.((THETA.GT.PTHMAX))) GOTO 100
            ENDDO
            PX = RBTAB(IPGTR,1,IRDS(I))
            PY = RBTAB(IPGTR,2,IRDS(I))
            PZ = RBTAB(IPGTR,3,IRDS(I))
            PT = SQRT(PX*PX + PY*PY)
            P  = SQRT(PX*PX + PY*PY + PZ*PZ)
            THETA = PRADP * ACOS(PZ/(P+PEPS))             
            IF (LDEBUG) THEN
              WRITE(6,60) 'IROW/PT    : ',IRDS(I),PT, THETA
            ENDIF
Cob hahaha du idiot du            PRINT*,'hallo PT,PPTMIN = ',PT,PPTMIN
            IF (PT.LT.PPTMIN)                               GOTO 100
            IF ((THETA.LT.THMIND).OR.((THETA.GT.THMAXD)))   GOTO 100 
            NACEPT = NACEPT + 1
Cob bloeder gehts gar nicht mehr            PRINT*,'h PT,PPTMIN = ',PT,PPTMIN
Cob hoholhoho            PRINT*,'h THETA, THMIND, THMAXD = ',THETA, THMIND, THMAXD
            IF (LDEBUG) THEN
              WRITE(6,1) '>>>> D* ACCEPTED <<<<'
            ENDIF
          ENDIF
100     CONTINUE
        ENDDO
      ENDIF


C-----INCREASE COUNTER
C
      IF (NDS.LE.2)    NCOUNT(1,NDS)    = NCOUNT(1,NDS)    + 1
      IF (NDP.LE.2)    NCOUNT(2,NDP)    = NCOUNT(2,NDP)    + 1
      IF (NKPP.LE.2)   NCOUNT(3,NKPP)   = NCOUNT(3,NKPP)   + 1
      IF (NACEPT.LE.2) NCOUNT(4,NACEPT) = NCOUNT(4,NACEPT) + 1

      IF (NDS.GT.0)    NCOUNT(1,3) = NCOUNT(1,3) + 1
      IF (NDP.GT.0)    NCOUNT(2,3) = NCOUNT(2,3) + 1
      IF (NKPP.GT.0)   NCOUNT(3,3) = NCOUNT(3,3) + 1
      IF (NACEPT.GT.0) NCOUNT(4,3) = NCOUNT(4,3) + 1

      NCOUNT(1,4) = NCOUNT(1,4) + NDS
      NCOUNT(2,4) = NCOUNT(2,4) + NDP
      NCOUNT(3,4) = NCOUNT(3,4) + NKPP
      NCOUNT(4,4) = NCOUNT(4,4) + NACEPT


C-----RETURN FLAG
C
      IACEPT = NACEPT
Cob hihihihi      PRINT*,'IACEPT = ',IACEPT


C-----FORMAT STATEMENTS
C
1     FORMAT(1X,A)
2     FORMAT(1X,45('-'))
3     FORMAT(1X,'       | ',A,F8.3)
50    FORMAT(1X,A,I8)
60    FORMAT(1X,A,I8,F8.3)


9999  CONTINUE


      RETURN
      END
*CMZ :          05/04/2000  09.05.28  by  R. Gerhards
*-- Author :
      SUBROUTINE PKP
C-----------------------------------------------------------------------
C
C SUBROUTINE : PKP
C CALLED BY  :
C AUTHOR     : U. KATHAGE 05/12/94
C
C PURPOSE    : PRINT STATISTICS
C
C INPUT      : COMMON /CKP/
C
C OUTPUT     : NONE
C
C-----------------------------------------------------------------------

CRG   IMPLICIT NONE


C-----INCLUDE FILES
C


C-----VARIABLES
C
      REAL BR1,BR2,BR3,BR4


C-----STATISTICS
C
C-----NUMBER OF EVENTS (PROCESSED,SKIPPED),NUMBER OF CCBAR
      INTEGER NEVT,NSKIP1,NSKIP2,NC,NB
C-----NUMBER OF EVENTS (0 D*,1 D*,2 D* ...)
      INTEGER NCOUNT(4,0:4)
      COMMON /CKP/ NEVT,NSKIP1,NSKIP2,NC,NB,NCOUNT


C***********************************************************************
C
C     P R I N T   S T A T I S T I C S
C
C***********************************************************************

      WRITE(6, 1) ' '
      WRITE(6, 2)
      WRITE(6, 3) 'S  U  M  M  A  R  Y'

      WRITE(6, 2)
      WRITE(6, 4) 'Routine  : GKP              '
      WRITE(6, 4) 'D* DECAY : D* --> D0 PI     '
      WRITE(6, 4) 'D0 DECAY : D0 --> K PI      '
      WRITE(6, 2)

      WRITE(6, 2)
      WRITE(6, 5) '#EVENTS (PROCESSED)            : ',NEVT
      WRITE(6, 5) '#EVENTS (SKIPPED,NO GTR BANK)  : ',NSKIP1
      WRITE(6, 5) '#EVENTS (SKIPPED,FATAL ERROR)  : ',NSKIP2
      WRITE(6, 5) '#CCBAR                         : ',NC
      WRITE(6, 5) '#BBBAR                         : ',NB

      WRITE(6, 2)
      WRITE(6, 6) '          D*','   D*-->D0PI',
     +            '    D0-->KPI','    ACCEPTED'
      WRITE(6, 7) '#EVENTS( 0 D*) : ',NCOUNT(1,0),NCOUNT(2,0),
     +                                NCOUNT(3,0),NCOUNT(4,0)
      WRITE(6, 7) '#EVENTS( 1 D*) : ',NCOUNT(1,1),NCOUNT(2,1),
     +                                NCOUNT(3,1),NCOUNT(4,1)
      WRITE(6, 7) '#EVENTS( 2 D*) : ',NCOUNT(1,2),NCOUNT(2,2),
     +                                NCOUNT(3,2),NCOUNT(4,2)
      WRITE(6, 7) '#EVENTS(>0 D*) : ',NCOUNT(1,3),NCOUNT(2,3),
     +                                NCOUNT(3,3),NCOUNT(4,3)
      WRITE(6, 7) '#D*(TOTAL)     : ',NCOUNT(1,4),NCOUNT(2,4),
     +                                NCOUNT(3,4),NCOUNT(4,4)

      IF(NC.GT.0 .AND. NC.GT.NB) THEN
        BR1 = 100. * REAL(NCOUNT(1,4)) / REAL(NC)
        BR2 = 100. * REAL(NCOUNT(2,4)) / REAL(NCOUNT(1,4))
        BR3 = 100. * REAL(NCOUNT(3,4)) / REAL(NCOUNT(2,4))
        BR4 = 100. * REAL(NCOUNT(3,4)) / REAL(NC)
        WRITE(6, 2)
        WRITE(6, 8) 'BR (C  --> D*)               :  ',BR1
        WRITE(6, 8) 'BR (D* --> D0 PI)            :  ',BR2
        WRITE(6, 8) 'BR (D0 --> K PI)             :  ',BR3
        WRITE(6, 8) 'BR (C  --> (K PI) PI)        :  ',BR4
        WRITE(6, 2)
      END IF

      IF(NB.GT.0 .AND. NB.GT.NC) THEN
        BR1 = 100. * REAL(NCOUNT(1,4)) / REAL(Nb)
        BR2 = 100. * REAL(NCOUNT(2,4)) / REAL(NCOUNT(1,4))
        BR3 = 100. * REAL(NCOUNT(3,4)) / REAL(NCOUNT(2,4))
        BR4 = 100. * REAL(NCOUNT(3,4)) / REAL(Nb)
        WRITE(6, 2)
        WRITE(6, 8) 'BR (B  --> D*)               :  ',BR1
        WRITE(6, 8) 'BR (D* --> D0 PI)            :  ',BR2
        WRITE(6, 8) 'BR (D0 --> K PI)             :  ',BR3
        WRITE(6, 8) 'BR (B  --> (K PI) PI)        :  ',BR4
        WRITE(6, 2)
      END IF


C-----FORMAT STATEMENTS
C
1     FORMAT(1X,A)
2     FORMAT(1X,77('-'))
3     FORMAT(1X,'| ',27(' '),A,27(' ')  ,' |')
4     FORMAT(1X,'| ',A,45(' ')          ,' |')
5     FORMAT(1X,'| ',A,I8,32(' ')       ,' |')
6     FORMAT(1X,'| ',17(' '),4('  ',A)  ,' |')
7     FORMAT(1X,'| ',A,4('  ',I12)      ,' |')
8     FORMAT(1X,'| ',A,F7.3,' %',32(' '),' |')


      RETURN
      END
