// * This code is licensed under:
// * RunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de).
// * All rights reserved.

// root stuff
#include <TROOT.h>
#include <TTree.h>
#include <TChain.h>

#include<iostream>
#include<fstream>
using namespace std;

#include<SetIni.h>    // include class containing initializations for RunMC


static char * NtupleNames[1000];
static Int_t  NTnumber;

#ifdef  PYTHIA57
 #include "hepevt_pythia57.h"
#endif
 
#ifdef  PYTHIA6
  #include "hepevt_pythia62.h"
#endif
 
#include<hepevt_local.h>
#include<heplist.h>
static TChain *chain2 = new TChain("thepevt"); 




Int_t  get_htup( Int_t  mode ) { 

  extern SetIni inival; 
  static Int_t  nbytes = 0;
  static Int_t  ntotntuple=0;
  hepenvtlocal hntup; // HEPEVT local for output 

 
  if (mode == -1) {   


// get ntuples 
  ifstream myin(".runmc.tup", ios::in); //only check at the beginning
  if (!myin) {
  cout << "Cannot open .runmc.tup" << endl; return 1;};

  char buffer[300];
  NTnumber=-1;
  while (! myin.eof() )
  {
     NTnumber++;
     myin.getline (buffer,300);
     NtupleNames[NTnumber] = new char[strlen(buffer)+1];
     strcpy(NtupleNames[NTnumber],buffer);
     }
  myin.close();

     cout << "RUNMC: total number of ntuples: " << NTnumber << endl;
     for (int m=0; m<NTnumber; m++) {
     cout << "   ntuple: " << NtupleNames[m] << endl;
     }


  for (Int_t m=0; m<NTnumber; m++) chain2->Add(NtupleNames[m]); 
  chain2->SetBranchAddress("NEVHEP",&hntup.NEVHEP);
  chain2->SetBranchAddress("NHEP",&hntup.NHEP);
  chain2->SetBranchAddress("ISTHEP",&hntup.ISTHEP);
  chain2->SetBranchAddress("IDHEP",&hntup.IDHEP);
  chain2->SetBranchAddress("CHA3",&hntup.CHA3);
  chain2->SetBranchAddress("JMOHEP1",&hntup.JMOHEP1);
  chain2->SetBranchAddress("JMOHEP2",&hntup.JMOHEP2);
  chain2->SetBranchAddress("JDAHEP1",&hntup.JDAHEP1);
  chain2->SetBranchAddress("JDAHEP2",&hntup.JDAHEP2);
  chain2->SetBranchAddress("PX",&hntup.PHEP_X);
  chain2->SetBranchAddress("PY",&hntup.PHEP_Y);
  chain2->SetBranchAddress("PZ",&hntup.PHEP_Z);
  chain2->SetBranchAddress("E",&hntup.PHEP_E);
  chain2->SetBranchAddress("M",&hntup.PHEP_M);
  chain2->SetBranchAddress("VX",&hntup.VHEP_X);
  chain2->SetBranchAddress("VY",&hntup.VHEP_Y);
  chain2->SetBranchAddress("VZ",&hntup.VHEP_Z);
  chain2->SetBranchAddress("VT",&hntup.VHEP_T);

  
  ntotntuple= (long int)chain2->GetEntries();
  cout << "RUNMC: total number of events in this ntuple = " << ntotntuple << endl;
// run over this number only 
  if (ntotntuple < inival.Nevents ) inival.Nevents=ntotntuple;
 

  return 0;

  } // end if 



   Int_t i=mode; 
   nbytes += chain2->GetEntry(i);  
  
//   cout  << i << "  " << hntup.NHEP << endl;
 

   extern hepenvtcommon hepevt_ ; // To access the external HEPEVT
//   cout << "Particles = " << hntup.NHEP << endl;
   hepevt_.NEVHEP=hntup.NEVHEP;
   hepevt_.NHEP=hntup.NHEP;
        for (Int_t nn=0; nn < hepevt_.NHEP; nn++) {
  hepevt_.ISTHEP[nn]=hntup.ISTHEP[nn];
  hepevt_.IDHEP[nn]=hntup.IDHEP[nn];
  hepevt_.JMOHEP[nn][0]=hntup.JMOHEP1[nn];
  hepevt_.JMOHEP[nn][1]=hntup.JMOHEP2[nn];
  hepevt_.JDAHEP[nn][0]=hntup.JDAHEP1[nn];
  hepevt_.JDAHEP[nn][1]=hntup.JDAHEP2[nn];
  hepevt_.PHEP[nn][0]=hntup.PHEP_X[nn];
  hepevt_.PHEP[nn][1]=hntup.PHEP_Y[nn];
  hepevt_.PHEP[nn][2]=hntup.PHEP_Z[nn];
  hepevt_.PHEP[nn][3]=hntup.PHEP_E[nn];
  hepevt_.PHEP[nn][4]=hntup.PHEP_M[nn];
  hepevt_.VHEP[nn][0]=hntup.VHEP_X[nn];
  hepevt_.VHEP[nn][1]=hntup.VHEP_Y[nn];
  hepevt_.VHEP[nn][2]=hntup.VHEP_Z[nn];
  hepevt_.VHEP[nn][3]=hntup.VHEP_T[nn]; 
  }
 


// ouutput for 3 events:

    if (mode < 3) {
    printf("\n\n HEPEVT event  from HTUP    = %5d \n",mode); 
    printf(" Total number of particles  = %5d \n",hepevt_.NHEP); 
// loop over all particles !
    for (Int_t  nn=0; nn<hepevt_.NHEP;nn++) {
    printf("%4d ISTHEP=%5d  IDHEP=%5d JMOHEP[0]=%5d JMOHEP[1]=%5d JDAHEP[0]=%5d JDAHEP[1]=%5d \n",
    nn,hepevt_.ISTHEP[nn],hepevt_.IDHEP[nn],hepevt_.JMOHEP[nn][0],hepevt_.JMOHEP[nn][1],hepevt_.JDAHEP[nn][0],hepevt_.JDAHEP[nn][1] );
    printf("     Px=%6.3f  Py=%6.3f  Pz=%6.3f  E=%6.3f Mass=%8.4f\n",
    hepevt_.PHEP[nn][0], hepevt_.PHEP[nn][1], hepevt_.PHEP[nn][2], hepevt_.PHEP[nn][3], hepevt_.PHEP[nn][4]);
    printf("     V1=%6.5f  V2=%6.5f  V3=%6.5f  V4=%6.5f \n",
    hepevt_.VHEP[nn][0], hepevt_.VHEP[nn][1], hepevt_.VHEP[nn][2], hepevt_.VHEP[nn][3]  );
 
    } // end loop over particles 

   }

 return 0;
}
