      Subroutine McWeight3(writeevent)
      implicit none
#include "h1mcutil/comdef/cbcs.inc"
      INTEGER INTCHA,MBANK,MDARD,MDARS,MDROP,MLINK,MPRNT,MREADC,MSWAP
     +             ,NAMIND,NBANK,NDANR,NDROP,NLINK,NPRNT,NSWAP
      real*4 pt2,weight,q2min,q2startt,wmax,rand,xp,zq,
     &  w,h1rn,r,pmin,k,shat,yb

cccccccccccc
C---LEPTO commons
      real*4 cut,parl,x,y,w2,q2,u
      integer lst
      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),X,Y,W2,Q2,U

CTH additional common for ARIADNE kinematics
      Real*8 yd,pt2d,phid,A,shatd,pid
      Parameter (pid=3.141592653589793d0)
      real phar
      integer mhar
      COMMON /ARHIDE/ PHAR(400),MHAR(400)

      integer iariad,ibgf
* ARIADNE steering common
      COMMON /RUNAR/ IARIAD, IBGF
      SAVE /RUNAR/
cccccc	
#include "rgrapgki.inc"
      DOUBLE PRECISION Q2r,Q2Q,PCM
      COMMON /PARAE/Q2r,Q2Q,PCM(4,18)
      DOUBLE PRECISION Q2START,W_Q2,OMEG2
      INTEGER IRUNA,IQ2,IRUNAEM
      INTEGER IPRO
      COMMON/RAPA /IPRO,IRUNA,IQ2,IRUNAEM,Q2START,W_Q2,OMEG2
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer ipgki,ipmcwe,ipgevc,generator
      character*6 genn(2)
      data genn/'Django','Rapgap'/
C      parameter (e2start=100.0,
C     &           wmin=0.1)
      logical first,writeevent
      data first/.true./

      save first,ipmcwe,r,q2min,q2startt,wmax,k,pmin
C-------------------------------------------------------------------
C-- McWeight introduces a weight on the matrixelement according to
C--
      weight(q2,pt2)=max(1.0,q2startt/(1.+pt2+q2*yb))
C--
C-- The return value, writeevent, is true if the event is to be kept.
C-- The weight is stored in the GKI bank in word 20. If the event is 
C-- to be dropped, the weight is set to zero.
C--
C-- A steering bank, MCWE described below, must be provided, otherwise
C-- the routine does nothing.
C-- There are no default settings, so the bank has to be 5 words long 
C-- providing all the parameters, otherwise the routine does nothing.
C--
C-- Q2min  - the Q2 where the generation started.
C-- r      - exponetial suppression factor, the larger r the larger 
C--          suppression. Should be around one.
C-- Wmax    - maximum weight allowed. You can probably handle a Wmax of 200.
C--           The weighting function is using pmin=1/Wmax
C-- E2start - the value above which everything is kept. 
C-- k       - multiplier for pt2. Zero means no pt2 weighting.
C--
C--        Q2min   r   E2start  Wmax   k
C-- MCWE     0.5  1.1   1000.   200.  10. - this setting gives large weights
C--                                         for a very low Q2 jet file.
C-- MCWE     5.   0.5   1000.   200.  10. - this setting gives decent weights
C--                                         for a low Q2 jet file.
C--          Q2=5  pt2=0   => weight=200.
C--          Q2=10 pt2=9   => weight=3.2
C--          Q2=10 pt2=25  => weight=1.97
C--          Q2=30 pt2=9   => weight=2.9
C--          Q2=30 pt2=25  => weight=1.89
C--
C-- MCWE     5.   1.     45.    200.   0. - gives a pure Q2 weighting below 50.
C--                                         everything above 50 is kept.
C--          Q2=5          => weight=200.
C--          Q2=10         => weight=8.65
C--          Q2=30         => weight=1.79
C--
C-------------------------------------------------------------------



      if(first) then
       first=.false.
       ipmcwe = NLINK( 'MCWE',0)

       If(ipmcwe.eq.0) Then
         Print *,'McWeight: No MCWE bank, exiting.'
         Return
       EndIf

       If(iw(ipmcwe).ne.2) Then
         Print *,'McWeight: Wrong length of MCWE bank.'
         Print *,'McWeight: The length is ',iw(ipmcwe),' words,'
         Print *,'McWeight: , but it should be 2.'
         Print *,'McWeight: Exiting.'
         ipmcwe=0
         Return
       EndIf

       generator = iw(ipmcwe+1)
       q2startt=rw(ipmcwe+2)
       print *,'=============================================='
       print *,'                McWeight'
       print *,'----------------------------------------------'
       print *,'Steering: Generator  :',genn(generator)
       print *,'          Q2start    :',q2startt
       print *,'=============================================='
      endif

      IF( ipmcwe .NE. 0 ) Then

       IPGKI = Nlink('GKI ',0)
       If(IPGKI.eq.0) Then
         Print *,'McWeight: No GKI bank, exiting.'
         Return
       EndIf

       q2=rw(ipgki+7)
      if(generator.eq.1)then
       yb=yy
       If(IW(IPGKI).ge.34) Then
         xp = RW(IPGKI+32)
         zq = RW(IPGKI+33)
         if(xp.gt.0.)then
          pt2=q2*(1./xp-1.)*zq*(1.-zq)
         else
          pt2=0.
         endif
       else
        pt2=max(rw(ipgki+30),0.)
       ENDIF
      else 
        yb=y
        pt2=max(rw(ipgki+30),0.)
      endif
c      print *,pt2,q2
       pt2=(sign(1.0,pt2-3.0)+1.)/2.*pt2

       w=weight(q2,pt2)
C       rand=h1rn()

       if (writeevent) then
        rw(ipgki+20)=w
       else
        rw(ipgki+20)=0.
       endif
      endif
c      print *,'McWeight3',rw(ipgki+20),writeevent
*
      return
      END
